#include <iostream>
#include <vector>
#include <map>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    map<string, int> sizeMap;
    for (int i = 0; i < m; i++) {
        string size;
        cin >> size;
        sizeMap[size] = i;
    }
    vector<vector<int>> tshirts(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> tshirts[i][j];
        }
    }
    int k;
    cin >> k;
    vector<vector<int>> remaining = tshirts;
    vector<vector<int>> missing(n, vector<int>(m));
    for (int i = 0; i < k; i++) {
        int color;
        string size;
        cin >> color >> size;
        color--;
        int sizeIndex = sizeMap[size];
        if (remaining[color][sizeIndex] > 0) {
            remaining[color][sizeIndex]--;
        }
        else {
            missing[color][sizeIndex]++;
        }
    }
    for (const auto& row : remaining) {
        for (int tshirt : row) {
            cout << tshirt << ' ';
        }
        cout << '\n';
    }

    for (const auto& row : missing) {
        for (int tshirt : row) {
            cout << tshirt << ' ';
        }
        cout << '\n';
    }
    return 0;
}