def process_requests(n, m, sizes, t_shirts, winners):
    remaining_t_shirts = [[0] * m for _ in range(n)]
    needed_t_shirts = [[0] * m for _ in range(n)]
    for i in range(n):
        for j in range(m):
            remaining_t_shirts[i][j] = t_shirts[i][j]
    for i in range(len(winners)):
        color, size = winners[i]
        color -= 1  # Adjusting color index
        size_index = sizes.index(size)
        found = False
        for s in range(size_index, m):
            if remaining_t_shirts[color][s] > 0:
                remaining_t_shirts[color][s] -= 1
                found = True
                break
        if not found:
            for s in range(size_index, m):
                for c in range(n):
                    if remaining_t_shirts[c][s] > 0:
                        remaining_t_shirts[c][s] -= 1
                        needed_t_shirts[c][s] += 1
                        found = True
                        break
                if found:
                    break

    return remaining_t_shirts, needed_t_shirts
n, m = map(int, input().split())
sizes = input().split()
t_shirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(lambda x: int(x) if x.isdigit() else x, input().split())) for _ in range(k)]
remaining_t_shirts, needed_t_shirts = process_requests(n, m, sizes, t_shirts, winners)
for row in remaining_t_shirts:
    print(" ".join(map(str, row)))
for row in needed_t_shirts:
    print(" ".join(map(str, row)))
