import heapq
def max_unmarked_sequence(n, m, wheels):
    max_len = 0
    heap = [-(wheel - 1) // 2 for wheel in wheels]
    heapq.heapify(heap)

    while m > 0:
        wheel = -heapq.heappop(heap)
        remaining_colors = wheel * 2
        if remaining_colors >= m:
            max_len += m
            break
        else:
            max_len += remaining_colors
            m -= remaining_colors

        if heap:
            heapq.heappush(heap, -(wheel - remaining_colors // 2))

    return max_len
n, m = map(int, input().split())
wheels = list(map(int, input().split()))