#include <iostream>
using namespace std;

const int MAX_N = 100;
const int MAX_M = 6;

int main() {
    int n, m;
    cin >> n >> m;

    char sizes[MAX_M];
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    int available[MAX_N][MAX_M];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    int remaining[MAX_N][MAX_M] = {0};
    int needed[MAX_N][MAX_M] = {0};

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;

        int sizeIndex = 0;
        while (sizes[sizeIndex] != s) {
            ++sizeIndex;
        }

        bool found = false;

        for (int j = sizeIndex; j < m; ++j) {
            if (available[c - 1][j] > 0) {
                --available[c - 1][j];
                found = true;
                break;
            }
        }

        if (!found) {
            for (int j = sizeIndex - 1; j >= 0; --j) {
                for (int l = 0; l < n; ++l) {
                    if (available[l][j] > 0) {
                        --available[l][j];
                        found = true;
                        break;
                    }
                }
                if (found) break;
            }
        }

        if (!found) {
            ++needed[c - 1][sizeIndex];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << needed[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}