def process_requests(n, m, sizes, available, k, requests):
  remaining = [[0] * m for _ in range(n)]
  needed = [[0] * m for _ in range(n)]

  for i in range(k):
      color, size = requests[i]
      size_index = sizes.index(size)

      if available[color - 1][size_index] > 0:
          available[color - 1][size_index] -= 1
      else:
          found = False

       
          for j in range(n):
              if j != color - 1 and available[j][size_index] > 0:
                  available[j][size_index] -= 1
                  found = True
                  break

          if not found:
             
              for j in range(size_index + 1, m):
                  if available[color - 1][j] > 0:
                      available[color - 1][j] -= 1
                      found = True
                      break
                  else:
                      for k in range(n):
                          if k != color - 1 and available[k][j] > 0:
                              available[k][j] -= 1
                              found = True
                              break

                  if found:
                      break

          if not found:
              needed[color - 1][size_index] += 1

  return remaining, needed


def main():
  n, m = map(int, input().split())
  sizes = input().split()

  available = [list(map(int, input().split())) for _ in range(n)]

  k = int(input())
  requests = [map(str, input().split()) for _ in range(k)]

  remaining, needed = process_requests(n, m, sizes, available, k, requests)

  for row in remaining:
      print(*row)


  for row in needed:
      print(*row)


if __name__ == "__main__":
  main()
