weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

initial_box_weights = [0, 0]
min_max_weight = float('inf')
move_item = -1

for i in range(4):
    current_box = boxes[i] - 1
    current_weight = initial_box_weights[current_box] + weights[i]
    other_weight = initial_box_weights[1 - current_box]
    max_weight_after_move = max(current_weight, other_weight)

    if max_weight_after_move < min_max_weight:
        min_max_weight = max_weight_after_move
        move_item = i + 1

    initial_box_weights[current_box] += weights[i]

print(move_item)