#include <iostream>

int main() {
    // Введення ваг речей
    int w[4];
    for (int i = 0; i < 4; ++i) {
        std::cin >> w[i];
    }

    // Введення номерів коробок
    int t[4];
    for (int i = 0; i < 4; ++i) {
        std::cin >> t[i];
    }

    // Обчислення ваг коробок
    int boxWeight[3] = {0};
    for (int i = 0; i < 4; ++i) {
        boxWeight[t[i] - 1] += w[i];
    }

    // Знаходження речі для переміщення
    int maxDiff = -1;
    int moveItem = -1;
    for (int i = 0; i < 4; ++i) {
        int currentDiff = std::max(boxWeight[(t[i] - 1) % 2], boxWeight[t[i] % 2]) - w[i];
        if (currentDiff > maxDiff) {
            maxDiff = currentDiff;
            moveItem = i + 1;
        }
    }

    // Виведення результату
    if (maxDiff == -1) {
        std::cout << "-1" << std::endl;
    } else {
        std::cout << moveItem << std::endl;
    }

    return 0;
}