#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    return a.score > b.score;
}

int main() {
    int n;
 cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
  cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
       cin >> olympiad;

         vector<int> teamIds;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            for (const auto& participant : participants) {
                if (teamIds.size() < ((olympiad == "BaltOI") ? 6 : 4)) {
                    teamIds.push_back(participant.id);
                } else {
                    break;
                }
            }
        } else if (olympiad == "EGOI") {
            for (const auto& participant : participants) {
                if (participant.gender == "female" && teamIds.size() < 4) {
                    teamIds.push_back(participant.id);
                }
            }
        } else if (olympiad == "EJOI") {
            for (const auto& participant : participants) {
                if (participant.age <= 15 && teamIds.size() < 4) {
                    teamIds.push_back(participant.id);
                }
            }
        } else if (olympiad == "BalkOI") {
            for (const auto& participant : participants) {
                if (participant.grade != 11 && teamIds.size() < 4) {
                    teamIds.push_back(participant.id);
                }
            }
        } else if (olympiad == "JBOI") {
            for (const auto& participant : participants) {
                if (participant.grade != 11 && participant.grade != 10 && teamIds.size() < 4) {
                    teamIds.push_back(participant.id);
                }
            }
        }

   cout << olympiad << endl;
        for (const auto& id : teamIds) {
           cout << id <<endl;
        }
    }

    return 0;
}