#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int main() {
    int n, m;
    cin >> n >> m;

  vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long left = 0, right = 1e18;
    while (left < right) {
        long long mid = (left + right + 1) / 2;
        long long cnt = 0;
        bool flag = false;
        for (int i = 0; i < n; ++i) {
            if (a[i] >= mid) {
                cnt += a[i] - mid + 1;
                flag = true;
            } else {
                cnt = 0;
            }
        }

        if (cnt >= m) {
            left = mid;
        } else {
            right = mid - 1;
        }
    }

    cout << left << endl;

    return 0;
}