#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    vector<int> w(4), t(4);

    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    vector<int> original_w = w;
    sort(w.begin(), w.end());

    do {
        int weight_box1 = 0, weight_box2 = 0;
        for (int i = 0; i < 4; ++i) {
            if (t[i] == 1) {
                weight_box1 += w[i];
            } else {
                weight_box2 += w[i];
            }
        }

        if (max(weight_box1, weight_box2) <= max(original_w[0], original_w[1]) &&
            min(weight_box1, weight_box2) <= min(original_w[0], original_w[1])) {
            cout << -1 << endl;
            return 0;
        }

        for (int i = 0; i < 4; ++i) {
            if (t[i] == 1 && weight_box1 - original_w[i] + w[i] <= weight_box2) {
                cout << i - 1 << endl;
                return 0;
            }
            if (t[i] == 2 && weight_box2 - original_w[i] + w[i] <= weight_box1) {
                cout << i + 1 << endl;
                return 0;
            }
        }
    } while (next_permutation(w.begin(), w.end()));

    return 0;
}

