#include<bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for(int i = 0; i < m; i++) cin >> sizes[i];

    map<string, int> size_to_idx;
    for(int i = 0; i < m; i++) size_to_idx[sizes[i]] = i;

    vector<vector<int>> tshirts(n, vector<int>(m));
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            cin >> tshirts[i][j];

    int k;
    cin >> k;

    vector<vector<int>> remaining = tshirts, needed(n, vector<int>(m, 0));
    while(k--) {
        int color;
        string size;
        cin >> color >> size;
        color--;

        int idx = size_to_idx[size];
        if(remaining[color][idx] > 0) {
            remaining[color][idx]--;
            continue;
        }

        needed[color][idx]++;
        for(int i = idx + 1; i < m; i++) {
            if(remaining[color][i] > 0) {
                remaining[color][i]--;
                break;
            }
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << remaining[i][j] << " ";
        }
        cout << "\n";
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << needed[i][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}