# Input
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Calculate the weight of each box
box_weights = [0, 0]
for i in range(4):
    box_weights[boxes[i] - 1] += weights[i]

# Check each possible move and find the optimal one
for i in range(4):
    # Simulate moving item i to the other box
    new_box_weights = box_weights.copy()
    new_box_weights[boxes[i] - 1] -= weights[i]
    new_box_weights[1 if boxes[i] == 2 else 0] += weights[i]

    # Check if the new configuration is better
    if max(new_box_weights) < max(box_weights):
        print(i + 1)
        break
else:
    print(-1)
