def max_box_weight(weights, boxes):
    box_weights = [0, 0]

    for weight, box in zip(weights, boxes):
        box_weights[box - 1] += weight

    return max(box_weights)


weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

for i in range(4):
    original_box = boxes[i]
    boxes[i] = 3 - original_box 

    if max_box_weight(weights, boxes) < max_box_weight(weights, [3 - b for b in boxes]):
        print(i + 1) 
        break
    else:
        boxes[i] = original_box  

else:
    print(-1)