from collections import defaultdict

def get_team_for_olympiad(p, o, rc):
    team = []
    if o == 'IOI' or o == 'CEOI':
        team = sorted(p, key=lambda x: x[4], reverse=True)[:rc]
    elif o == 'EGOI':
        team = sorted([p for p in p if p[1] == 'female'], key=lambda x: x[4], reverse=True)[:rc]
    elif o == 'EJOI':
        team = sorted([p for p in p if p[3] <= 15], key=lambda x: x[4], reverse=True)[:rc]
    elif o == 'BaltOI':
        team = sorted(p, key=lambda x: x[4], reverse=True)[:rc]
    elif o == 'BalkOI':
        team = sorted([p for p in p if p[3] != 11], key=lambda x: x[4], reverse=True)[:rc]
    elif o == 'JBOI':
        team = sorted([p for p in p if p[3] != 11 and p[3] != 10], key=lambda x: x[4], reverse=True)[:rc]
    return sorted([p[0] for p in team])

def main():
    n = int(input())
    p = [tuple(map(int, input().split())) for _ in range(n)]

    m = int(input())
    os = [input() for _ in range(m)]

    t = defaultdict(list)
    for o in os:
        required_count = 4 if olympiad != 'BaltOI' else 6
        t[olympiad] = gtf(p, o, rc)

    for o in os:
        print(o)
        for participant_id in t[o]:
            print(participant_id)

if __name__ == "__main__":
    main()