def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]
    
    for i in range(n):
        for j in range(m):
            if i == 0 or i == n-1 or j == 0 or j == m-1:
                ornament[i][j] = 'x'
            elif i == j or i == m-j-1:
                ornament[i][j] = 'x'
    
    return '\n'.join([''.join(row) for row in ornament])

# Example usage
n, m = 6, 4
print(create_ornament(n, m))
n, m = 12, 5
print(create_ornament(n, m))
n, m = 21, 12
print(create_ornament(n, m))
