import heapq

def solve(n, m, a):
    heap = []
    for i in range(n):
        if a[i] % 2 == 0:
            heapq.heappush(heap, a[i]//2)
        else:
            heapq.heappush(heap, a[i]//2 + 1)

    while m > 0:
        max_len = heapq.heappop(heap)
        new_len = max_len//2
        if max_len % 2 == 0:
            new_len -= 1
        if new_len > 0:
            heapq.heappush(heap, new_len)
        m -= 1

    return heapq.heappop(heap)

n, m = map(int, input().split())
a = list(map(int, input().split()))
print(solve(n, m, a))