def color_wheels(n, m, a):
    queues = [[] for _ in range(n)]
    lengths = [0 for _ in range(n)]
    for i in range(n):
        queues[i] = [(i + 1) * j for j in range(1, a[i] + 1)]
        lengths[i] = a[i]

    used = [False for _ in range(n)]
    while m > 0:
        max_len = max(lengths)
        for i in range(n):
            if lengths[i] == max_len:
                if used[i]:
                    if lengths[i] % 2 == 0:
                        lengths[i] //= 2
                    else:
                        lengths[i] = (lengths[i] + 1) // 2
                else:
                    used[i] = True
                    lengths[i] -= 1
                    m -= 1
                    if m == 0:
                        return max_len
    return -1


# Reading input from the user
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Calculating the maximum length of the sequence of unmarked colors
result = color_wheels(n, m, a)

# Printing the result
print(result)
