
// function findItemToMove(weights, boxes) {
//   const box1Weight = (boxes[0] === 1 ? weights[0] : 0) + (boxes[1] === 1 ? weights[1] : 0) + (boxes[2] === 1 ? weights[2] : 0) + (boxes[3] === 1 ? weights[3] : 0);
//   const box2Weight = (boxes[0] === 2 ? weights[0] : 0) + (boxes[1] === 2 ? weights[1] : 0) + (boxes[2] === 2 ? weights[2] : 0) + (boxes[3] === 2 ? weights[3] : 0);
//   const maxWeight = Math.max(box1Weight, box2Weight);

//   for (let i = 0; i < 4; i++) {
//     if (boxes[i] === 1) {
//       const box1WithoutItem = box1Weight - weights[i];
//       const box2WithItem = box2Weight + weights[i];

//       if (Math.max(box1WithoutItem, box2WithItem) === maxWeight) {
//         return i + 1;
//       }
//     } else if (boxes[i] === 2) {
//       const box2WithoutItem = box2Weight - weights[i];
//       const box1WithItem = box1Weight + weights[i];

//       if (Math.max(box2WithoutItem, box1WithItem) === maxWeight) {
//         return i + 1;
//       }
//     }
//   }

//   return -1;
// }

// console.log(findItemToMove([4, 2, 3, 7], [2, 1, 1, 2])); 
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

for i in range(4):
    current_max = max(sum(weights[j] for j in range(4) if boxes[j] == 1),
                      sum(weights[j] for j in range(4) if boxes[j] == 2))

    # Simulate moving the i-th item to the other box and calculate new max weight
    boxes[i] = 3 - boxes[i]  # Switch box
    new_max = max(sum(weights[j] for j in range(4) if boxes[j] == 1),
                  sum(weights[j] for j in range(4) if boxes[j] == 2))

    # If the new max weight is less than or equal to the current max, print the item to move
    if new_max <= current_max:
        print(i + 1)
        break
else:
    print(-1)  # No move needed
