from collections import defaultdict

def process_Tshirts(n, m, sizes, teams):
    shirts_count = {(color, size): 0 for color in range(n) for size in range(m)}

    for team in teams:
        color, size = team.split()
        size_idx = sizes.index(size)
        for i in range(size_idx, m):
            if shirts_count[(int(color) - 1, i)] > 0:
                shirts_count[(int(color) - 1, i)] -= 1
                break
        else:
            for i in range(size_idx):
                if shirts_count[(int(color) - 1, i)] > 0:
                    shirts_count[(int(color) - 1, i)] -= 1
                    break
            else:
                for i in range(size_idx + 1, m):
                    found = False
                    for j in range(n):
                        if shirts_count[(j, i)] > 0:
                            shirts_count[(j, i)] -= 1
                            shirts_count[(int(color) - 1, i)] += 1
                            found = True
                            break
                    if found:
                        break

    return shirts_count


n, m = map(int, input().split())
sizes = input().split()
teams = [input() for _ in range(n * m)]
num_gifts = int(input())
superfluous = process_Tshirts(n, m, sizes, teams)
needed = {(i, j): int(teams.count(f"{i} {sizes[j]}")) for i in range(1, n + 1) for j in range(m)}

for i in range(n):
    for j in range(m):
        print(superfluous[(i, j)], end=" ")
    print()
for i in range(n):
    for j in range(m):
        print(max(0, needed[(i + 1, j)] - superfluous[(i, j)]), end=" ")
    print()



