def max_unmarked_sequence_length(n, m, a):
    total_colors = sum(a)
    remaining_colors = total_colors + m
    max_length = 0

    for wheel_size in a:
        length = min(remaining_colors, wheel_size) - 1
        max_length = max(max_length, length)

    return max_length

def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    result = max_unmarked_sequence_length(n, m, a)
    print(result)

if __name__ == "__main__":
    main()
