def знаходження_нсд(a: int, b: int) -> int:
    """Знаходження максимального спільного дільника.

    Args:
        a (int): Перше число.
        b (int): Друге число.

    Returns:
        int: Максимальний спільний дільник.
    """
    while b:
        a, b = b, a % b
    return a

if __name__ == "__main__":
    # Зчитуємо введені дані
    n = int(input())
    m = int(input())

    # Знаходимо та виводимо результат
    нсд = знаходження_нсд(n, m)
    print(нсд)