import heapq

def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0

    heap = [-x for x in a]
    heapq.heapify(heap)

    for i in range(m):
        longest_seq = -heapq.heappop(heap)
        if longest_seq % 2 == 0:
            mid = longest_seq // 2
            heapq.heappush(heap, -mid)
            heapq.heappush(heap, -mid)
        else:
            mid = (longest_seq - 1) // 2
            heapq.heappush(heap, -mid)
            heapq.heappush(heap, -mid)

    return -heapq.heappop(heap)

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)