using System;

class Program
{
    static void Main()
    {
        // Зчитування вхідних даних
        string[] weightsInput = Console.ReadLine().Split();
        int[] weights = Array.ConvertAll(weightsInput, int.Parse);

        string[] boxesInput = Console.ReadLine().Split();
        int[] boxes = Array.ConvertAll(boxesInput, int.Parse);

        // Знайдення ваг коробок
        int box1Weight = 0, box2Weight = 0;

        for (int i = 0; i < 4; i++)
        {
            if (boxes[i] == 1)
                box1Weight += weights[i];
            else
                box2Weight += weights[i];
        }

        // Перевірка, чи оптимально нічого не змінювати
        if (Math.Max(box1Weight, box2Weight) < Math.Min(box1Weight + weights[3], box2Weight - weights[3]))
        {
            Console.WriteLine("4");
        }
        else if (Math.Max(box1Weight, box2Weight) < Math.Min(box1Weight - weights[3], box2Weight + weights[3]))
        {
            Console.WriteLine("4");
        }
        else
        {
            // Якщо оптимально нічого не змінювати
            Console.WriteLine("-1");
        }
    }
}
