using System;

class Program
{
    static void Main()
    {
        // Зчитування вхідних даних
        string[] weightsInput = Console.ReadLine().Split();
        int[] weights = Array.ConvertAll(weightsInput, int.Parse);

        string[] boxesInput = Console.ReadLine().Split();
        int[] boxes = Array.ConvertAll(boxesInput, int.Parse);

        // Знайдення ваг коробок
        int box1Weight = 0, box2Weight = 0;

        for (int i = 0; i < 4; i++)
        {
            if (boxes[i] == 1)
                box1Weight += weights[i];
            else
                box2Weight += weights[i];
        }

        // Пошук речі, яку слід перемістити
        for (int i = 0; i < 4; i++)
        {
            int currentWeight = weights[i];
            int currentBox = boxes[i];

            // Розрахунок ваги коробок після переміщення
            int newBox1Weight = box1Weight - (currentBox == 1 ? currentWeight : 0) + (currentBox == 2 ? currentWeight : 0);
            int newBox2Weight = box2Weight - (currentBox == 2 ? currentWeight : 0) + (currentBox == 1 ? currentWeight : 0);

            // Перевірка, чи максимальна вага коробки стане меншою
            if (Math.Max(newBox1Weight, newBox2Weight) < Math.Max(box1Weight, box2Weight))
            {
                Console.WriteLine(i + 1);
                return;
            }
        }

        // Якщо оптимально нічого не змінювати
        Console.WriteLine("-1");
    }
}
