#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long total_colors = 0;
    for (int i = 0; i < n; ++i) {
        total_colors += a[i];
    }

    // Знаходимо максимальний підвідрізок незакреслених кольорів
    long long max_subarray = min(a[0], total_colors - a[0] + 1);

    for (int i = 1; i < n; ++i) {
        max_subarray = max(max_subarray, min(a[i], total_colors - a[i] + 1));
    }

    // Виводимо результат
    cout << max_subarray << endl;

    return 0;
}
