def max_unmarked_subarray(arr, m):
    n = len(arr)
    prefix_sum = [0] * (n + 1)

    for i in range(n):
        prefix_sum[i + 1] = prefix_sum[i] + arr[i]

    max_length = 0

    for i in range(1, n + 1):
        for j in range(i, n + 1):
            length = j - i + 1
            marked_count = prefix_sum[j] - prefix_sum[i - 1]

            if length % 2 == 1:
                max_length = max(max_length, min(m, length - marked_count))
            else:
                max_length = max(max_length, min(m, length - marked_count - 1))

    return max_length

# Вхідні дані
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Знаходимо та виводимо результат
result = max_unmarked_subarray(colors, m)
print(result)
