def max_unmarked_subarray_length(n, m, colors):
    max_length = 0

    if n == 1:
        max_length = min(colors[0] - 1, m)
    else:
        for _ in range(m + 1):
            lengths = []
            for i in range(n):
                if colors[i] == 0:
                    cnt = 0
                    j = i
                    while j < n and colors[j] == 0:
                        cnt += 1
                        j += 1
                    lengths.append(cnt)

            if not lengths:
                break

            chosen_length = max(lengths)
            max_length += chosen_length

            # Закреслити середину або один із двох середніх елементів
            mid = chosen_length // 2
            if chosen_length % 2 == 1:
                colors[i + mid] = 1
            else:
                colors[i + mid - 1] = 1 if colors[i + mid - 1] == 0 else 1
                colors[i + mid] = 1

    return max_length

# Приклад виклику функції зі згенерованими даними
n = 1
m = 5
colors = [100]
result = max_unmarked_subarray_length(n, m, colors)
print(result)
