using System;

class Program
{
    static void Main()
    {
        string[] input1 = Console.ReadLine().Split();
        int n = int.Parse(input1[0]);
        long m = long.Parse(input1[1]);

        string[] input2 = Console.ReadLine().Split();
        long[] colors = new long[n];
        for (int i = 0; i < n; i++)
        {
            colors[i] = long.Parse(input2[i]);
        }

        // Розрахунок максимальної довжини підвідрізку перед вибором (m+n)-го колору
        long max_length = 0;

        // Знайдемо початкову довжину підвідрізку
        for (int i = 0; i < n; i++)
        {
            max_length += (colors[i] + 1) / 2;
        }

        // Знаходимо різницю між поточною кількістю кольорів і кількістю, яку планує вибрати Міс М
        long remaining_colors = max_length - m;

        // Максимальна довжина підвідрізку перед вибором (m+n)-го колору
        if (remaining_colors <= 0)
        {
            Console.WriteLine(max_length);
        }
        else
        {
            // Розглядаємо варіант, коли Міс М обирає декілька кольорів із середини
            max_length -= Math.Min(remaining_colors, max_length / 2);
            Console.WriteLine(max_length);
        }
    }
}
