def choose_colors(n, m, a):
    # Ініціалізуємо список для зберігання кольорів
    colors = [0] * n
    
    # Знаходимо максимальний неперервний підвідрізок
    max_subarray = 0
    current_subarray = 0
    for i in range(n):
        current_subarray += a[i]
        if current_subarray < 0:
            current_subarray = 0
        max_subarray = max(max_subarray, current_subarray)
    
    # Додаємо максимальний підвідрізок до загальної кількості кольорів
    total_colors = max_subarray * m
    
    # Додаємо залишкові кольори, якщо m менше, ніж кількість кольорів у підвідрізку
    if m < max_subarray:
        total_colors -= (max_subarray - m)
    
    return total_colors

# Зчитуємо вхідні дані
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Викликаємо функцію та виводимо результат
result = choose_colors(n, m, a)
print(result)
