def generate_pascals_triangle(num_rows):
    triangle = []

    for row_num in range(num_rows):
        row = [1] * (row_num + 1)
        if row_num >= 2:
            for i in range(1, row_num):
                row[i] = triangle[row_num - 1][i - 1] + triangle[row_num - 1][i]
        triangle.append(row)

    return triangle

def display_pascals_triangle(triangle):
    for row in triangle:
        print(" ".join(map(str, row)).center(len(triangle[-1]) * 3))

num_rows = int(input("Enter the number of rows for Pascal's Triangle: "))
pascals_triangle = generate_pascals_triangle(num_rows)
display_pascals_triangle(pascals_triangle)
