def max_passes(n, m):
    # The maximum number of passes is determined by the formula below
    # Number of passes = (n * m) // 2 + (n * m) % 2 if (n * m) % 2 == 1 else (n * m) // 2
    
    return (n * m + 1) // 2  # Simplified formula for the maximum number of passes

# Reading input values
n = int(input())
m = int(input())

# Calculate and print the maximum number of passes needed
result = max_passes(n, m)
print(result)
