n, m = map(int, input().split())
a = list(map(int, input().split()))

# Function to find the maximum length of unmarked colors
def max_unmarked_colors(a, m):
    max_len = 0
    total = sum(a)
    if m >= total:
        return max(total + (m - total) // n, max(a))
    
    a.sort()
    l, r = 1, a[-1]
    while l <= r:
        mid = (l + r) // 2
        count = sum(max(0, (x - mid + 1) // 2) for x in a)
        if count >= m:
            max_len = mid
            l = mid + 1
        else:
            r = mid - 1
    
    return max_len

result = max_unmarked_colors(a, m)
print(result)
