n, m = map(int, input().split())
a = list(map(int, input().split()))

def max_unmarked_sequence_length(a, m):
    a.sort()
    l = len(a)
    low, high = 0, a[-1]

    while low < high:
        mid = (high - low + 1) // 2 + low
        count = 0

        for i in range(l):
            count += max(0, (a[i] - mid + 1 + 1) // 2)

        if count >= m:
            low = mid
        else:
            high = mid - 1

    return low

result = max_unmarked_sequence_length(a, m)
print(result)
