n, m = map(int, input().split())
a = list(map(int, input().split()))

# Function to calculate the number of unmarked colors at a given step
def unmarked_colors_count(a, steps):
    total = 0
    for count in a:
        total += min(steps, count)
    return total

# Binary search to find the maximum step where Miss M selects m colors
left, right = 0, 10**18
while left < right:
    mid = (left + right + 1) // 2
    if unmarked_colors_count(a, mid) >= m:
        left = mid
    else:
        right = mid - 1

# Calculate the remaining unmarked colors before selecting the (m+1)-th color
remaining = m - unmarked_colors_count(a, left)
max_length = left + remaining

print(max_length)
