weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

optimal_max_weight = float('inf')
chosen_item = -1

for i in range(4):
    for j in range(4):
        if i != j:
            current_boxes = boxes.copy()
            current_boxes[i], current_boxes[j] = current_boxes[j], current_boxes[i]

            weights_in_boxes = [sum(weights[current_boxes[k] - 1] for k in range(2)),
                                sum(weights[current_boxes[k] - 1] for k in range(2, 4))]

            max_weight = max(weights_in_boxes)

            if max_weight < optimal_max_weight:
                optimal_max_weight = max_weight
                chosen_item = i + 1

print(chosen_item)