def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m // 2)):
        ornament[i][i] = 'x'
        ornament[i][m - i - 1] = 'x'

    for i in range(m // 2, min(n, m)):
        ornament[i][m // 2] = 'x'
        ornament[i][m // 2 - 1] = 'x'

    return ornament

n, m = map(int, input().split())

ornament = create_ornament(n, m)

for row in ornament:
    print(''.join(row))