def max_subsequence_length(colors, m):
    n = len(colors)
    max_length = 0

    for i in range(1, n + 1):
        for j in range(i, n + 1):
            current_subsequence = sorted(set(colors[i - 1:j]))
            subsequence_length = len(current_subsequence)

            if subsequence_length % 2 == 1:
                middle_index = subsequence_length // 2
                current_sum = current_subsequence[middle_index]
            else:
                middle_index = subsequence_length // 2 - 1
                current_sum = current_subsequence[middle_index] + current_subsequence[middle_index + 1]

            if current_sum <= m:
                max_length = max(max_length, subsequence_length)

    return max_length

def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    max_length = max_subsequence_length(colors, m)
    print(max_length)

if __name__ == "__main__":
    main()