def max_unmarked_sequence(n, m, wheels):
    max_sequence = max(wheels)
    
    remaining_wheels = sorted(wheels, reverse=True)[1:]
    
    for wheel in remaining_wheels:
        if wheel % 2 == 0:
            max_sequence = max(max_sequence, wheel // 2)
        else:
            max_sequence = max(max_sequence, (wheel // 2) + 1)
    
    return min(max_sequence + m, sum(wheels) + n - 1)

n, m = map(int, input().split())
wheels = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, wheels)
print(result)