def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][0] = 'x'
        ornament[i][m - 1] = 'x'

    for j in range(min(n, m)):
        ornament[0][j] = 'x'
        ornament[n - 1][j] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))


n, m = map(int, input().split())

ornament = generate_ornament(n, m)
print_ornament(ornament)


