#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    // Создаем вектор из n элементов для хранения целых чисел типа long long
    vector<long long> a(n);
    
    // Считываем n чисел в вектор a
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    // Сортируем вектор a по возрастанию
    sort(a.begin(), a.end());

    // Инициализируем переменную max_sequence значением 0
    long long max_sequence = 0;

    // Итерируемся по элементам вектора
    for (int i = 0; i < n; ++i) {
        // Вычисляем оставшееся значение для текущего элемента
        long long remaining = a[i] - 1;
        
        // Вычисляем, сколько мы можем "взять" из текущего элемента
        long long take = min(remaining, (long long)m);
        
        // Обновляем max_sequence, если текущее значение больше
        max_sequence = max(max_sequence, a[i] - take);

        // Уменьшаем m на взятую часть
        m -= take;

        // Если m стало 0, выходим из цикла
        if (m == 0) break;
    }


    cout << max_sequence + m / n << endl;

    return 0;
}
