# Вхідні дані
n, m = map(int, input().split()) # кількість різних кольорів та розмірів футболок відповідно
sizes = input().split() # розміри футболок, які доставили Міс М
# Створюємо словник, який відображає розмір футболки на його порядковий номер
size_to_index = {}
for i in range(m):
    size_to_index[sizes[i]] = i
# Створюємо матрицю n на m, заповнену нулями
matrix = [[0 for j in range(m)] for i in range(n)]
# Зчитуємо кількість футболок кожного кольору та розміру
for i in range(n):
    row = list(map(int, input().split()))
    for j in range(m):
        matrix[i][j] = row[j]
# Зчитуємо кількість переможців
k = int(input())
# Створюємо дві матриці n на m, заповнені нулями
# Перша матриця буде зберігати кількість футболок, які залишилися
# Друга матриця буде зберігати кількість футболок, які потрібно докупити
left = [[0 for j in range(m)] for i in range(n)]
need = [[0 for j in range(m)] for i in range(n)]
# Копіюємо початкову матрицю в матрицю футболок, які залишилися
for i in range(n):
    for j in range(m):
        left[i][j] = matrix[i][j]
# Обробляємо запити переможців
for i in range(k):
    # Зчитуємо колір та розмір футболки, яку хоче переможець
    color, size = input().split()
    # Визначаємо індекси кольору та розміру
    ci = int(color) - 1 # індекс кольору
    si = size_to_index[size] # індекс розміру
    # Перевіряємо, чи є футболка потрібного кольору та розміру
    if left[ci][si] > 0:
        # Якщо так, то видаємо її переможцю
        left[ci][si] -= 1
    else:
        # Інакше, шукаємо футболку того ж розміру, але іншого кольору
        found = False # прапорець, чи знайшли футболку
        for j in range(n):
            if left[j][si] > 0:
                # Якщо знайшли футболку, то видаємо її переможцю
                left[j][si] -= 1
                found = True
                break
        # Якщо не знайшли футболку того ж розміру, то шукаємо футболку наступного більшого розміру
        if not found:
            for j in range(si + 1, m):
                # Шукаємо футболку з пріоритетом кольору, який було вказано учасником на початку
                if left[ci][j] > 0:
                    # Якщо знайшли футболку, то видаємо її переможцю
                    left[ci][j] -= 1
                    found = True
                    break
                # Якщо немає футболки з пріоритетним кольором, але є кілька інших, то вибираємо футболку з мінімальним номером
                else:
                    for k in range(n):
                        if left[k][j] > 0:
                            # Якщо знайшли футболку, то видаємо її переможцю
                            left[k][j] -= 1
                            found = True
                            break
                    if found:
                        break
        # Якщо ніяка футболка з тих, що залишилися, не підійшла, то футболку, яку вказав учасник, записуємо як відсутню
        if not found:
            need[ci][si] += 1

# Вихідні дані
# Виводимо матрицю футболок, які залишилися
for i in range(n):
    for j in range(m):
        print(left[i][j], end=' ')
    print()
# Виводимо матрицю футболок, які потрібно докупити
for i in range(n):
    for j in range(m):
        print(need[i][j], end=' ')
    print()
