#include <vector>
#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

class olimp
{
public:
	int ID;
	string gender;
	int grade;
	int age;
	int score;
	olimp() {
		this->gender = '0';
		this->grade = 0;
		this->ID = 0;
		this->age = 0;
		this->score = 0;
	}
	olimp(int id, string gender, int grade, int age, int score) {
		this->gender = gender;
		this->grade = grade;
		this->ID = id;
		this->age = age;
		this->score = score;
	}

private:

};

void IOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec)
		result.push_back(pair<int, int>(x.score, x.ID));
	sort(result.begin(), result.end());
	cout << "IOI" << endl;
	if (result.size() > 4)
		result.erase(result.begin(), result.end() - 4);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

void CEOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec)
		result.push_back(pair<int, int>(x.score, x.ID));
	sort(result.begin(), result.end());
	cout << "CEOI" << endl;
	if (result.size() > 4)
		result.erase(result.begin(), result.end() - 4);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

void EGOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec) {
		if (x.gender == "female")
			result.push_back(pair<int, int>(x.score, x.ID));
	}
	sort(result.begin(), result.end());
	cout << "EGOI" << endl;
	if (result.size() > 4)
		result.erase(result.begin(), result.end() - 4);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

void EJOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec) {
		if (x.age <= 15)
			result.push_back(pair<int, int>(x.score, x.ID));
	}
	sort(result.begin(), result.end());
	cout << "EJOI" << endl;
	if (result.size() > 4)
		result.erase(result.begin(), result.end() - 4);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

void BaltOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec)
		result.push_back(pair<int, int>(x.score, x.ID));
	sort(result.begin(), result.end());
	cout << "BaltOI" << endl;
	if (result.size() > 6)
		result.erase(result.begin(), result.end() - 6);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

void BalkOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec) {
		if (x.grade != 11)
			result.push_back(pair<int, int>(x.score, x.ID));
	}
	sort(result.begin(), result.end());
	cout << "BalkOI" << endl;
	if (result.size() > 4)
		result.erase(result.begin(), result.end() - 4);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

void JBOI(vector<olimp> vec) {
	vector<pair<int, int>> result;
	for (auto x : vec) {
		if (x.grade != 11 && x.grade != 10)
			result.push_back(pair<int, int>(x.score, x.ID));
	}
	sort(result.begin(), result.end());
	cout << "JBOI" << endl;
	if (result.size() > 4)
		result.erase(result.begin(), result.end() - 4);
	vector<int> result1;
	for (auto x : result)
		result1.push_back(x.second);
	sort(result1.begin(), result1.end());
	for (auto x : result1)
		cout << x << endl;
	cout << endl;
}

int main()
{
	cout << "11";
}
