n = int(input())  
participants = []
girls = []
juniors = []
no11Grades = []
no11_10Grades = []
for _ in range(n):
    participant_data = input().split()
    participant = {
        'id': int(participant_data[0]),
        'gender': participant_data[1],
        'grade': int(participant_data[2]),
        'age': int(participant_data[3]),
        'score': int(participant_data[4])
    }
    participants.append(participant)
    if (participant_data[1] == 'female'):
        girls.append(participant)
    if (int(participant_data[3])<=15):
        juniors.append(participant)
    if (int(participant_data[2])<11):
        no11Grades.append(participant)
    if (int(participant_data[2])<10):
        no11_10Grades.append(participant)
    
participants = sorted(participants, key=lambda x: x['score'], reverse=True)
girls = sorted(girls, key=lambda x: x['score'], reverse=True)
juniors = sorted(juniors, key=lambda x: x['score'], reverse=True)
no11Grades = sorted(no11Grades, key=lambda x: x['score'], reverse=True)
no11_10Grades = sorted(no11_10Grades, key=lambda x: x['score'], reverse=True)




m = int(input())  
olympiads = {}

for _ in range(m):
    olympiad = input().strip()
    olympiads[olympiad] = []

def task_for_IOI():
    for i in range(0, min(4, len(participants))):
        olympiads['IOI'].append(participants[i]['id'])

def task_for_CEOI():
    for i in range(0, min(4, len(participants))):
        olympiads['CEOI'].append(participants[i]['id'])

def task_for_EGOI():
    for i in range(0, min(4, len(girls))):
        olympiads['EGOI'].append(girls[i]['id'])

def task_for_EJOI():
    for i in range(0, min(4, len(juniors))):
        olympiads['EJOI'].append(juniors[i]['id'])

def task_for_BaltOI():
    for i in range(0, min(6, len(participants))):
        olympiads['BaltOI'].append(participants[i]['id'])

def task_for_BalkOI():
    for i in range(0, min(4, len(no11Grades))):
        olympiads['BalkOI'].append(no11Grades[i]['id'])

def task_for_JBOI():
    length = min(4, len(no11_10Grades))
    for i in range(0, length):
        olympiads['JBOI'].append(no11_10Grades[i]['id'])
    
    
tasks = {
    task.__name__.split('_')[-1]: task for task in [
        task_for_IOI, task_for_CEOI, task_for_EGOI,
        task_for_EJOI, task_for_BaltOI, task_for_BalkOI, task_for_JBOI
    ]
}

for i in olympiads.keys():
    tasks[i]()

    
for olympiad_name, id_list in olympiads.items():
    print(olympiad_name)
    for participant_id in id_list:
        print(participant_id)
    print()
