#include <queue>
#include <iostream>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int n;
    long long m;
    cin >> n >> m;
    
    priority_queue<long long> pq;
    
    for (int i = 0; i < n; i++) {
        long long ai;
        cin >> ai;
        pq.push(ai);
    }
    
    for (long long i = 0; i < m-1; i++) {
        long long longest_sequence = pq.top();
        pq.pop();
        long long smaller_sequence1 = longest_sequence / 2;
        long long smaller_sequence2 = longest_sequence - 1 - smaller_sequence1;
        if (smaller_sequence1 > 0) pq.push(smaller_sequence1);
        if (smaller_sequence2 > 0) pq.push(smaller_sequence2);
    }
    
    cout << pq.top() << endl;
    
    return 0;
}
