#include <iostream>
#include <vector>

int main() {
    // Введення ваг та номерів коробок
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Знайдемо ваги коробок
    int box1_weight = 0, box2_weight = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            box1_weight += weights[i];
        } else {
            box2_weight += weights[i];
        }
    }

    // Перевірка всіх можливих переміщень та знаходження оптимального
    for (int i = 0; i < 4; ++i) {
        int current_weight = (boxes[i] == 1) ? (box1_weight - weights[i]) : (box2_weight - weights[i]);
        int other_box_weight = (boxes[i] == 1) ? (box2_weight + weights[i]) : (box1_weight + weights[i]);

        if (current_weight <= other_box_weight) {
            // Якщо вага коробки після переміщення не перевищує вагу іншої коробки
            std::cout << i + 1 << std::endl;  // Виводимо номер речі, яку потрібно перемістити
            return 0;
        }
    }

    // Якщо немає оптимального переміщення
    std::cout << "-1" << std::endl;

    return 0;
}
