#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // Зчитуємо кількість речей (n)
    int n;
    cin >> n;

    // Зчитуємо ваги кожної з чотирьох речей
    vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }

    // Зчитуємо номери коробок для кожної речі
    vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    // Знайдемо ваги коробок
    int box1_weight = 0, box2_weight = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            box1_weight += weights[i];
        } else {
            box2_weight += weights[i];
        }
    }

    // Перевірка всіх можливих переміщень та знаходження оптимального
    for (int i = 0; i < 4; ++i) {
        int current_weight = (boxes[i] == 1) ? (box1_weight - weights[i]) : (box2_weight - weights[i]);
        int other_box_weight = (boxes[i] == 1) ? (box2_weight + weights[i]) : (box1_weight + weights[i]);

        if (current_weight <= other_box_weight) {
            // Якщо вага коробки після переміщення не перевищує вагу іншої коробки
            cout << i + 1 << "\n";  // Виводимо номер речі, яку потрібно перемістити
            return 0;
        }
    }

    // Якщо немає оптимального переміщення
    cout << "-1\n";

    return 0;
}

