#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> colorSegments(n);
    for (int i = 0; i < n; ++i) {
        cin >> colorSegments[i];
    }

    long long maxLength = 0;
    for (int i = 0; i < m; ++i) {
        // Знаходимо найдовший незакреслений підвідрізок
        long long maxSegmentLength = 0;
        int chosenColorIndex = -1;

        for (int j = 0; j < n; ++j) {
            if (j == 0 || (j > 0 && colorSegments[j] - colorSegments[j - 1] > maxSegmentLength)) {
                maxSegmentLength = colorSegments[j] - (j > 0 ? colorSegments[j - 1] : 0);
                chosenColorIndex = j;
            }
        }

        // Позначаємо вибраний колір як використаний
        colorSegments[chosenColorIndex] = (maxSegmentLength % 2 == 0)
                                            ? (colorSegments[chosenColorIndex] + colorSegments[chosenColorIndex - 1]) / 2
                                            : colorSegments[chosenColorIndex];

        // Оновлюємо максимальну довжину
        maxLength = max(maxLength, maxSegmentLength);
    }

    cout << maxLength << endl;

    return 0;
}
