class Participant:
    def __init__(self, id, gender, grade, age, score):
        self.id = id
        self.gender = gender
        self.grade = grade
        self.age = age
        self.score = score

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        data = input().split()
        participant = Participant(int(data[0]), data[1], int(data[2]), int(data[3]), int(data[4]))
        participants.append(participant)

    m = int(input())
    olympiad_participants = []

    for _ in range(m):
        olympiad = input().strip()
        team_size = 4

        if olympiad in ["EGOI", "JBOI"]:
            team_size = 2

        selected_ids = []

        if olympiad in ["IOI", "CEOI", "EGOI", "EJOI"]:
            participants.sort(key=lambda x: x.score, reverse=True)
            selected_ids = [participant.id for participant in participants[:team_size]]
        elif olympiad in ["BaltOI", "BalkOI", "JBOI"]:
            participants.sort(key=lambda x: x.score, reverse=True)
            temp_ids = [participant.id for participant in participants if participant.grade not in [10, 11]]
            selected_ids = temp_ids[:team_size]

        olympiad_participants.append(selected_ids)

    for selected_ids in olympiad_participants:
        print(len(selected_ids))
        for participant_id in selected_ids:
            print(participant_id)

if __name__ == "__main__":
    main()
