weights = list(map(int, input().split()))  
boxes = list(map(int, input().split()))    

def max_weight_after_move(item_weights, box_numbers, item_index):
    box1_weight = sum(item_weights[i] for i in range(4) if box_numbers[i] == 1)
    box2_weight = sum(item_weights[i] for i in range(4) if box_numbers[i] == 2)
    
    if box_numbers[item_index] == 1:
        box1_weight -= item_weights[item_index]
        box2_weight += item_weights[item_index]
    else:
        box1_weight += item_weights[item_index]
        box2_weight -= item_weights[item_index]
    
    return max(box1_weight, box2_weight)

min_max_weight = float('inf')
move_index = -1

for i in range(4):
    new_max_weight = max_weight_after_move(weights, boxes, i)
    if new_max_weight < min_max_weight:
        min_max_weight = new_max_weight
        move_index = i + 1

if min_max_weight == max(sum(weights)//2, max(weights)):
    print("-1")
else:
    print(move_index)
