#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    // Зчитуємо вхідні дані
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    // Визначаємо максимальну довжину підвідрізку
    int max_length = 0;
    vector<int> chosen_colors;

    // Вибираємо перший колір на кожному колі
    for (int i = 0; i < n; i++) {
        max_length += a[i];
        chosen_colors.push_back(a[i]);
    }

    // Вибираємо ще m кольорів
    for (int i = 0; i < m; i++) {
        // Знаходимо найдовший підвідрізок
        auto max_subarray_it = max_element(chosen_colors.begin(), chosen_colors.end());
        int max_subarray_length = *max_subarray_it;

        // Оновлюємо вибрані кольори
        *max_subarray_it += 1;

        // Перевіряємо, чи змінилась максимальна довжина
        max_length = max(max_length, max_subarray_length);
    }

    // Виводимо результат
    cout << max_length << endl;

    return 0;
}
