process.stdin.on('data', function (data) {
  const lines = (""+data).split('\n');
  const n = parseInt(lines[0]);
  const participants = lines.slice(1, n+1).map(p => {
    const fields = p.split(' ');
    return {
      id: parseInt(fields[0]),
      gender: fields[1],
      grade: parseInt(fields[2]),
      age: parseInt(fields[3]),
      score: parseInt(fields[4])
    };
  });
  const contests = lines.slice(n+2, lines.length-1)
    .map(c => c.replaceAll('\r', ''))
  
  let participantsList = {};
  contests.forEach(c => {
    if (c == 'IOI' || c == 'CEOI') {
      const byScore = participants
        .sort((a, b) => a.score > b.score ? -1 : 1); 
      participantsList[c] = byScore.slice(0, 4);
    } else if (c == 'EGOI') {
      const females = participants.filter(p => p.gender == 'female');
      const byScore = females
        .sort((a, b) => a.score > b.score ? -1 : 1);
      participantsList[c] = byScore.slice(0, 4);       
    } else if (c == 'EJOI') {
      const juniors = participants.filter(p => p.age <= 15);
      const byScore = juniors
        .sort((a, b) => a.score > b.score ? -1 : 1);
      participantsList[c] = byScore.slice(0, 4);       
    } else if (c == 'BaltOI') {
      const byScore = participants
        .sort((a, b) => a.score > b.score ? -1 : 1); 
      participantsList[c] = byScore.slice(0, 6);      
    } else if (c == 'BalkOI') {
      const excludeGrade = participants.filter(p => p.grade < 11);
      const byScore = excludeGrade
        .sort((a, b) => a.score > b.score ? -1 : 1);
      participantsList[c] = byScore.slice(0, 4);       
    } else if (c == 'JBOI') {
      const excludeGrade = participants.filter(p => p.grade < 10);
      const byScore = excludeGrade
        .sort((a, b) => a.score > b.score ? -1 : 1);
      participantsList[c] = byScore.slice(0, 4);       
    }
  });

  for (const [contest, participants] of Object.entries(participantsList)) {
    participantIds = participants.map(p => p.id)
      .sort((a, b) => a < b ? -1 : 1);

    console.log(contest);
    participantIds.forEach(id => console.log(id));
  }
});
