#include <iostream>
#include <string>
#include <vector>


int main()
 {

    std::vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

 
    std::vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }


    int sum_box1 = 0, sum_box2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            sum_box1 += weights[i];
        } else {
            sum_box2 += weights[i];
        }
    }

    
    int item_to_move = -1;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            if (sum_box1 - weights[i] == sum_box2 + weights[i]) {
                item_to_move = i + 1;
                break;
            }
        } else {
            if (sum_box2 - weights[i] == sum_box1 + weights[i]) {
                item_to_move = i + 1;
                break;
            }
        }
    }

  
    std::cout << item_to_move << std::endl;

    
}
