#include <iostream>
#include <vector>
using namespace std;
void printPattern(int n, int m) {
    std::vector<vector<char>> pattern(n,vector<char>(m, '.'));

    // правий промінь
    for (int row = 0, col = 0, dir = 1; row < n; ++row) {
        pattern[row][col] = 'x';
        col += dir;
        if (col == m || col == -1) {
            dir *= -1;
            col += dir;
        }
    }

    // лівий промінь
    for (int row = 0, col = m - 1, dir = -1; row < n; ++row) {
        pattern[row][col] = 'x';
        col += dir;
        if (col == m || col == -1) {
            dir *= -1;
            col += dir;
        }
    }

    // Виведення малюнка
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << pattern[i][j];
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, m;
    cin>>n>>m;
    printPattern(n, m);
    return 0;
}