#include <bits/stdc++.h>
using namespace std;

int main() {
    int n;
    cin >> n;

    // Read the weights of the items
    vector<int> weights(n);
    for (int i = 0; i < n; ++i) {
        cin >> weights[i];
    }

    // Sort the weights in non-decreasing order
    sort(weights.begin(), weights.end());

    // Initialize variables to store the weights of the two boxes
    int box1 = 0, box2 = 0;

    // Distribute the items between the two boxes
    for (int i = n - 1; i >= 0; --i) {
        if (box1 <= box2) {
            box1 += weights[i];
        } else {
            box2 += weights[i];
        }
    }

    // Calculate the maximum possible weight of the box
    int maxWeight = max(box1, box2);

    cout << maxWeight << endl;

    return 0;
}

