#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<int> w(4), t(4);

    // Input weights
    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }

    // Input box numbers
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    // Calculate the weight of each box
    vector<int> boxWeight(3, 0);
    for (int i = 0; i < 4; ++i) {
        boxWeight[t[i]] += w[i];
    }

    int originalMaxWeight = max(boxWeight[1], boxWeight[2]);
    int minMoveWeight = originalMaxWeight;

    int moveItem = -1;

    // Try redistributing each item
    for (int i = 0; i < 4; ++i) {
        boxWeight[t[i]] -= w[i];   // Remove the item from its current box
        boxWeight[3 - t[i]] += w[i];  // Put the item in the other box

        int maxWeight = max(boxWeight[1], boxWeight[2]);

        if (maxWeight < minMoveWeight) {
            minMoveWeight = maxWeight;
            moveItem = i + 1; // Items are 1-indexed
        }

        // Undo the redistribution
        boxWeight[t[i]] += w[i];
        boxWeight[3 - t[i]] -= w[i];
    }

    // Output the result
    if (minMoveWeight <= originalMaxWeight) {
        cout << "-1\n"; // No need to move anything
    } else {
        cout << moveItem << "\n";
    }

    return 0;
}
