#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    vector<string> olympiads(m);

    for (int i = 0; i < m; ++i) {
        cin >> olympiads[i];

        int teamSize;
        if (olympiads[i] == "IOI" || olympiads[i] == "CEOI") {
            teamSize = 4;
        } else if (olympiads[i] == "EGOI" || olympiads[i] == "EJOI") {
            teamSize = 4;
        } else if (olympiads[i] == "BaltOI") {
            teamSize = 6;
        } else {
            teamSize = 4;
        }

        vector<int> teamIds;

        for (int j = 0; j < n; ++j) {
            if ((olympiads[i] == "EGOI" && participants[j].gender == "female") ||
                (olympiads[i] == "EJOI" && participants[j].age <= 15) ||
                (olympiads[i] == "BalkOI" && participants[j].grade != 11) ||
                (olympiads[i] == "JBOI" && participants[j].grade != 11 && participants[j].grade != 10)) {
                teamIds.push_back(participants[j].id);
            }

            if (teamIds.size() == teamSize) {
                break;
            }
        }

        sort(teamIds.begin(), teamIds.end());

        for (int id : teamIds) {
            cout << olympiads[i] << " " << id << '\n';
        }
    }

    return 0;
}
