#include <bits/stdc++.h>
#include <vector>
#include <string>
#include <map>
#include <iostream>
using namespace std;

int StringSizeToIntSize(std::string size, std::vector<std::string> availableSize) 
{
    for (int i = 0; i < availableSize.size(); i++) 
    {
        if (availableSize[i] == size) 
        {
            return i;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int numberOfColors, numberOfSize;

    cin >> numberOfColors;
    cin >> numberOfSize;

    std::vector<std::string> availableSize = std::vector<std::string>();


    for (int size_index = 0; size_index < numberOfSize; size_index++) 
    {
        std::string _tempStr;
        cin >> _tempStr;

        availableSize.push_back(_tempStr);
    }

    std::vector<std::vector<int>> TShirtsRemaining = std::vector<std::vector<int>>();
    for (int color = 0; color < numberOfColors; color++) 
    {
        TShirtsRemaining.push_back(std::vector<int>());
        for (int size = 0; size < numberOfSize; size++) 
        {
            int num_of_t_shirts;
            cin >> num_of_t_shirts;

            TShirtsRemaining[color].push_back(num_of_t_shirts);
        }
    }

    int winners;
    cin >> winners;

    for (int winner = 0; winner < winners; winner++) 
    {
        int color;
        cin >> color;
        color--;

        std::string size;
        cin >> size;

        int size_n = StringSizeToIntSize(size, availableSize);

        if (TShirtsRemaining[color][size_n] > 0) 
        {
            TShirtsRemaining[color][size_n]--;
        }
        else 
        {
            bool found = false;
            for (int size_index = size_n; size_index < numberOfSize; size_index++) {
                bool foundColor = false;
                for (int color_index = 0; color_index < numberOfColors; color_index++) 
                {
                    if (TShirtsRemaining[color][size_index] > 0) 
                    {
                        TShirtsRemaining[color][size_index]--;
                        foundColor = true;
                        break;
                    }
                }

                if (foundColor) 
                {
                    found = true;
                    break;
                }
            }

            if (!found) 
            {
                TShirtsRemaining[color][size_n]--;
            }
        }

        
        
    }

    for (int color = 0; color < numberOfColors; color++) 
    {
        for (int size = 0; size < numberOfSize; size++) 
        {
            if (TShirtsRemaining[color][size] > 0) {
                cout << TShirtsRemaining[color][size] << " ";
            } else 
            {
                cout << "0 ";
            }
        }

        cout << "\n";
    }

    for (int color = 0; color < numberOfColors; color++) 
    {
        for (int size = 0; size < numberOfSize; size++) 
        {
            if (TShirtsRemaining[color][size] < 0) {
                cout << -TShirtsRemaining[color][size] << " ";
            } else 
            {
                cout << "0 ";
            }
        }

        cout << "\n";
    }
}
