weights = {tonumber(io.read()), tonumber(io.read()), tonumber(io.read()), tonumber(io.read())}
boxes = {tonumber(io.read()), tonumber(io.read()), tonumber(io.read()), tonumber(io.read())}

-- Find the box with the minimum total weight
function findMinWeightBox()
    local minWeightBox = boxes[1]
    local minTotalWeight = calculateTotalWeight(minWeightBox)

    for i = 2, 4 do
        local box = boxes[i]
        local totalWeight = calculateTotalWeight(box)

        if totalWeight < minTotalWeight then
            minWeightBox = box
            minTotalWeight = totalWeight
        end
    end

    return minWeightBox
end

-- Calculate the total weight of a box
function calculateTotalWeight(box)
    local totalWeight = 0
    for i = 1, 4 do
        if boxes[i] == box then
            totalWeight = totalWeight + weights[i]
        end
    end
    return totalWeight
end

-- Find the item to move
function findItemToMove(minWeightBox)
    for i = 1, 4 do
        if boxes[i] ~= minWeightBox then
            return i
        end
    end
end

-- Main logic
local minWeightBox = findMinWeightBox()
local itemToMove = findItemToMove(minWeightBox)

-- Output the result
print(itemToMove or -1)
