#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }

    long long result = 0;
    long long prefix_sum = 0;

    for (int i = 0; i < n; ++i) {
        prefix_sum += a[i];

        if (prefix_sum % 2 == 0) {
            result = std::max(result, prefix_sum);
        } else {
            result = std::max(result, prefix_sum - a[i] / 2);
        }
    }

    std::cout << result << std::endl;

    return 0;
}
