import java.util.Arrays;

public class MissM {

    public static void main(String[] args) {
        int[] weights = new int[]{5, 2, 4, 3};
        int[] boxes = new int[]{1, 2, 2, 1};

        int[] box1 = new int[weights.length];
        int[] box2 = new int[weights.length];
        for (int i = 0; i < weights.length; i++) {
            if (boxes[i] == 1) {
                box1[i] = weights[i];
            } else {
                box2[i] = weights[i];
            }
        }

        int max1 = Arrays.stream(box1).max().getAsInt();
        int max2 = Arrays.stream(box2).max().getAsInt();

        int minMax = Math.min(max1, max2);

        // Якщо в обох коробках ваги рівні, то не потрібно нічого переміщувати
        if (max1 == max2) {
            System.out.println(-1);
        } else {
            // Знаходимо річ, яка зменшить максимальну вагу однієї коробки
            for (int i = 0; i < weights.length; i++) {
                int newMax1 = Math.max(max1 - weights[i], box2[i]);
                int newMax2 = Math.max(max2 + weights[i], box1[i]);

                if (newMax1 < minMax) {
                    minMax = newMax1;
                    System.out.println(i + 1);
                    break;
                } else if (newMax2 < minMax) {
                    minMax = newMax2;
                    System.out.println(i + 1);
                    break;
                }
            }
        }
    }
} 