def find_item_to_move(weights, boxes):
    # Обчислюємо максимальну вагу кожної коробки
    box_weights = [0, 0]
    for i, weight in enumerate(weights):
        box_weights[boxes[i] - 1] += weight

    # Шукаємо річ, яку потрібно перемістити, щоб зменшити максимальну вагу коробок
    min_max_weight = float('inf')
    item_to_move = -1
    for i in range(4):
        for j in range(2):
            if boxes[i] - 1 != j:
                new_box_weights = box_weights[:]
                new_box_weights[boxes[i] - 1] -= weights[i]
                new_box_weights[j] += weights[i]
                max_weight = max(new_box_weights)
                if max_weight < min_max_weight:
                    min_max_weight = max_weight
                    item_to_move = i + 1

    return item_to_move

# Зчитуємо вхідні дані
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Знаходимо річ для переміщення та виводимо результат
result = find_item_to_move(weights, boxes)
print(result)
