def distribute_tshirts(n, m, sizes, quantities, requests):

  leftovers = [[0 for _ in range(m)] for _ in range(n)]
  needed = [[0 for _ in range(m)] for _ in range(n)]

  for i in range(n):
    for j in range(m):
      leftovers[i][j] = quantities[i][j]

  for request in requests:
    color = request[0] - 1
    size = sizes.index(request[1])

    # Шукаємо футболку потрібного розміру та кольору.
    while leftovers[color][size] == 0:
      # Якщо футболки такого розміру не залишилося, шукаємо футболку наступного розміру.
      size += 1
      if size == m:
        # Якщо футболки такого розміру також не залишилося, записуємо запит у список відсутніх футболок.
        needed[color][size] += 1
        break

    # Якщо футболку знайдено, видаємо її.
    leftovers[color][size] -= 1

  return leftovers, needed