def read_input():
    n, m = map(int, input().split())
    sizes = input().split()
    t = []
    for _ in range(n):
        t.append(list(map(int, input().split())))
    k = int(input())
    requests = []
    for _ in range(k):
        ci, si = input().split()
        requests.append((int(ci), si))
    return n, m, sizes, t, k, requests

def process_requests(n, m, sizes, t, k, requests):
    remaining_t = t[:]
    ordered_t = [[0] * m for _ in range(n)]
    for ci, si in requests:
        si_index = sizes.index(si)
        for i in range(si_index, -1, -1):
            if remaining_t[ci - 1][i] > 0:
                remaining_t[ci - 1][i] -= 1
                break
        if remaining_t[ci - 1][i] == 0:
            ordered_t[ci - 1][i] += 1
    return remaining_t, ordered_t

def print_output(n, m, remaining_t, ordered_t):
    for remaining in remaining_t:
        print(" ".join(map(str, remaining)))
    for ordered in ordered_t:
        print(" ".join(map(str, ordered)))

if __name__ == "__main__":
    n, m, sizes, t, k, requests = read_input()
    remaining_t, ordered_t = process_requests(n, m, sizes, t, k, requests)
    print_output(n, m, remaining_t, ordered_t)
