#include <bits/stdc++.h>
#include <vector>
#include <string>
using namespace std;

struct Member {
    long int id;
    string gender;
    int grade;
    int age;
    long int score;
};

bool cmp_scr (Member m1, Member m2) {
    return m1.score>m2.score;
}

bool cmp_id (Member m1, Member m2) {
    return m1.id<m2.id;
}

void IOI (vector<Member> members) {
    cout << "IOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<4; it++) {
        participants.push_back(*it);
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

void CEOI (vector<Member> members) {
    cout << "CEOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<4; it++) {
        participants.push_back(*it);
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

void EGOI (vector<Member> members) {
    cout << "EGOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<4; it++) {
        if (it->gender=="female") {
            participants.push_back(*it);
        }
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

void EJOI (vector<Member> members) {
    cout << "EJOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<4; it++) {
        if (it->age<=15) {
            participants.push_back(*it);
        }
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

void BaltOI (vector<Member> members) {
    cout << "BaltOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<6; it++) {
        participants.push_back(*it);
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

void BalkOI (vector<Member> members) {
    cout << "BalkOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<4; it++) {
        if (it->grade!=11) {
            participants.push_back(*it);
        }
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

void JBOI (vector<Member> members) {
    cout << "JBOI" << endl;
    vector<Member> participants;
    for (vector<Member>::iterator it=members.begin(); it<members.end() && participants.size()<4; it++) {
        if (it->grade!=11 || it->grade!=10) {
            participants.push_back(*it);
        }
    }
    sort(participants.begin(), participants.end(), cmp_id);
    for (vector<Member>::iterator it=participants.begin(); it<participants.end(); it++) {
        cout << it->id << endl;
    }
    cout << endl;
}

int main() {
    vector<Member> members;
    Member mem;
    int n, m;
    vector<string> olimpiados;
    string olemp;

    cin >> n;

    for (int i=0; i<n; i++) {
        cin >> mem.id;
        cin >> mem.gender;
        cin >> mem.grade;
        cin >> mem.age;
        cin >> mem.score;
        members.push_back(mem);
    }

    sort(members.begin(), members.end(), cmp_scr);
    
    cin >> m;

    for (int i=0; i<m; i++) {
        cin >> olemp;
        if (olemp=="IOI") {
            IOI(members);
        } else if (olemp=="CEOI") {
            CEOI(members);
        } else if (olemp=="EGOI") {
            EGOI(members);
        } else if (olemp=="EJOI") {
            EJOI(members);
        } else if (olemp=="BaltOI") {
            BaltOI(members);
        } else if (olemp=="BalkOI") {
            BalkOI(members);
        } else if (olemp=="JBOI") {
            JBOI(members);
        }
    }
}
