def process(n, m, sizes, available, orders):
    leftovers = [[0] * m for l in range(n)]
    needed = [[0] * m for l in range(n)]
    for order in orders:
        color, size = sizes.index(order[1]), int(order[0]) - 1
        if size < m and available[color][size] > 0:
            available[color][size] -= 1
            leftovers[color][size] += 1
        else:
            while size < m:
                for c in range(n):
                    if available[c][size] > 0:
                        available[c][size] -= 1
                        leftovers[c][size] += 1
                        break
                else:
                    size += 1
            if size == m:
                needed[color][sizes.index(order[1])] += 1
    return leftovers, needed

n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for l in range(n)]
k = int(input())
orders = [tuple(map(str, input().split())) for l in range(k)]
leftovers, needed = process(n, m, sizes, available, orders)

for row in leftovers:
    print(*row)
for row in needed:
    print(*row)