def select_team(olympiad, participants):
    teams = []
    
    if olympiad == 'IOI':
        participants.sort(key=lambda x: x[4], reverse=True)
        for participant in participants[:4]:
            teams.append(participant[0])
    elif olympiad == 'CEOI':
        participants.sort(key=lambda x: x[4], reverse=True)
        for participant in participants[:4]:
            teams.append(participant[0])
    elif olympiad == 'EGOI':
        females = [participant for participant in participants if participant[1] == 'female']
        females.sort(key=lambda x: x[4], reverse=True)
        for participant in females[:4]:
            teams.append(participant[0])
    # Додайте умови для інших олімпіад на основі вказаних умов у завданні
    
    return teams

def main():
    n = int(input())
    participants = []
    
    for _ in range(n):
        data = input().split()
        participants.append((int(data[0]), data[1], int(data[2]), int(data[3]), int(data[4])))
    
    m = int(input())
    olympiads = [input().strip() for _ in range(m)]
    
    for olympiad in olympiads:
        teams = select_team(olympiad, participants)
        print(olympiad)
        for team in teams:
            print(team)
        print()

if __name__ == "__main__":
    main()