def max_subarray_length(n, m, colors):
    # Загальна кількість кольорів у всіх колірних колах
    total_colors = sum(colors)
    
    # Загальна кількість циклів кольорів
    total_cycles = total_colors // n
    
    # Кількість незакреслених кольорів у повних циклах
    remaining_colors_in_cycles = total_colors % n
    
    # Кількість вже використаних повних циклів
    used_cycles = min(total_cycles, m)
    
    # Кількість незакреслених кольорів у використаних циклах
    remaining_colors = remaining_colors_in_cycles - (m - used_cycles) * n
    
    # Максимальна довжина незакреслених кольорів
    max_length = used_cycles * n + max(0, min(n, remaining_colors))
    
    return max_length

# Читаємо вхідні дані
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Виводимо результат
result = max_subarray_length(n, m, colors)
print(result)