def select_team(olympiad, participants):
    if olympiad == "IOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:min(4, len(participants))]
    elif olympiad == "CEOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:min(4, len(participants))]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        return sorted(female_participants, key=lambda x: x[4], reverse=True)[:min(4, len(female_participants))]
    elif olympiad == "EJOI":
        under_15_participants = [p for p in participants if p[3] <= 15]
        return sorted(under_15_participants, key=lambda x: x[4], reverse=True)[:min(4, len(under_15_participants))]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:min(6, len(participants))]
    elif olympiad == "BalkOI":
        non_11th_graders = [p for p in participants if p[2] != 11]
        return sorted(non_11th_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_11th_graders))]
    elif olympiad == "JBOI":
        non_10th_11th_graders = [p for p in participants if p[2] not in [10, 11]]
        return sorted(non_10th_11th_graders, key=lambda x: x[4], reverse=True)[:min(4, len(non_10th_11th_graders))]

# Зчитуємо кількість учасників
n = int(input())
participants = []

# Зчитуємо інформацію про учасників
for _ in range(n):
    participant_info = list(map(str, input().split()))
    participants.append(tuple(participant_info))

# Зчитуємо кількість міжнародних олімпіад
m = int(input())

# Зчитуємо назви міжнародних олімпіад
olympiads_to_check = [input() for _ in range(m)]

# Для кожної олімпіади визначаємо та виводимо склад команди
for olympiad in olympiads_to_check:
    team = select_team(olympiad, participants)
    print(olympiad)
    for participant in sorted(team, key=lambda x: int(x[0])):
        print(participant[0])
