n, m = map(int, input().split())
a = list(map(int, input().split()))

# Find the maximum length of unmarked consecutive colors
max_unmarked_length = 0
current_unmarked_length = 0

for i in range(n):
    if a[i] % 2 == 1:
        current_unmarked_length = a[i]
    else:
        current_unmarked_length = max(0, current_unmarked_length - 1)

    max_unmarked_length = max(max_unmarked_length, current_unmarked_length)

# Calculate the maximum length of unmarked colors before selecting the (m+1)-th color
result = min(max_unmarked_length, m)

print(result)

