#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

int calcm(vector<int> v, vector<bool> corc)
{
    int sumt = 0, sumf = 0;
    for (int i = 0; i < 4; i++)
    {
        if (corc[i]) sumt += v[i];
        else sumf += v[i];
    }
    return max(sumt, sumf);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    vector<int> v; vector<bool> corc;
    for (int i = 0; i < 4; i++)
    {
        int inp; cin >> inp; v.push_back(inp);
    }
    for (int i = 0; i < 4; i++)
    {
        int inp; cin >> inp; corc.push_back(inp == 1);
    }
    int best = calcm(v, corc), best_id = -1;
    for (int i = 0; i < 4; i++)
    {
        corc[i] = !corc[i]; 
        int tr = calcm(v, corc);
        if (tr < best)
        {
            best = tr;
            best_id = i + 1;
        }
        corc[i] = !corc[i];
    }
    cout << best_id;
}