#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> m >> n;
    vector<vector<char>> v(m, vector<char>(n, '.'));
    int x1 = 0, x2 = n - 1; bool d1 = true, d2 = false;
    for (int i = 0; i < m; i++)
    {
        v[i][x1] = v[i][x2] = 'x';
        if (d1) x1++;
        else x1--;
        if (d2) x2++;
        else x2--;
        if (x1 == 0) d1 = true;
        if (x1 == n - 1) d1 = false;
        if (x2 == 0) d2 = true;
        if (x2 == n - 1) d2 = false;
    }
    for (int i = 0; i < v.size(); i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            cout << v[i][j];
        }
        cout << "\n";
    }
}
