#include <bits/stdc++.h>
#include <vector>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;
        --c; // зменшуємо на 1, оскільки індексація векторів з 0

        bool found = false;

        // Шукаємо футболку потрібного кольору та розміру
        for (int j = 0; j < m; ++j) {
            if (sizes[j][0] == s && available[c][j] > 0) {
                --available[c][j];
                ++remaining[c][j];
                found = true;
                break;
            }
        }

        // Якщо футболку потрібного кольору та розміру не знайдено, шукаємо будь-який інший колір
        if (!found) {
            for (int j = 0; j < m; ++j) {
                if (available[c][j] > 0) {
                    --available[c][j];
                    ++remaining[c][j];
                    break;
                }
            }
        }

        // Шукаємо футболку більшого розміру, якщо є
        for (int j = sizes.find(s) + 1; j < m; ++j) {
            if (available[c][j] > 0) {
                --available[c][j];
                ++remaining[c][j];
                break;
            }
        }

        // Шукаємо футболку іншого кольору більшого розміру, якщо є
        for (int j = 0; j < m; ++j) {
            if (available[c][j] > 0) {
                --available[c][j];
                ++remaining[c][j];
                break;
            }
        }
    }

    // Виводимо результат
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}