#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<int> weights(4);
    vector<int> boxes(4);
    
    for (int i = 0; i < 4; i++) {
        cin >> weights[i];
    }
    
    for (int i = 0; i < 4; i++) {
        cin >> boxes[i];
    }

    int x = 0;
    int y = 0;
    
    for (int i = 0; i < 4; i++) {
        if (boxes[i] == 1) {
            x += weights[i];
        } else {
            y += weights[i];
        }
    }
    

    int minMaxWeight = max(x, y);
    int itemToMove = -1;
    
    for (int i = 0; i < 4; i++) {
        int newx = x;
        int newy = y;
        
        if (boxes[i] == 1) {
            newx -= weights[i];
            newy += weights[i];
        } else {
            newx += weights[i];
            newy -= weights[i];
        }
        
        int maxWeight = max(newx, newy);
        
        if (maxWeight < minMaxWeight) {
            minMaxWeight = maxWeight;
            itemToMove = i + 1;
        }
    }
    
    cout << itemToMove << endl;
    
    return 0;
}