n = int(input().strip())
participants = [input().strip().split() for _ in range(n)]

for p in participants:
    p[0] = int(p[0])  # ID
    p[3] = int(p[3])  # Age
    p[4] = int(p[4])  # Score

def select_IOI_CEOI_BaltOI(p): return True
def select_EGOI(p): return p[1] == "female"
def select_EJOI(p): return p[3] < 15
def select_BalkOI(p): return p[2] != "11"
def select_JBOI(p): return p[2] not in ["10", "11"]

olympiad_funcs = {
    "IOI": select_IOI_CEOI_BaltOI,
    "CEOI": select_IOI_CEOI_BaltOI,
    "EGOI": select_EGOI,
    "EJOI": select_EJOI,
    "BaltOI": select_IOI_CEOI_BaltOI,
    "BalkOI": select_BalkOI,
    "JBOI": select_JBOI
}

team_sizes = {"IOI": 4, "CEOI": 4, "EGOI": 4, "EJOI": 4, "BaltOI": 6, "BalkOI": 4, "JBOI": 4}

m = int(input().strip())
for _ in range(m):
    olympiad = input().strip()
    select_func = olympiad_funcs[olympiad]
    team_size = team_sizes[olympiad]

    filtered = [p for p in participants if select_func(p)]
    filtered.sort(key=lambda x: (-x[4], x[0]))

    selected_participants = filtered[:team_size]
    selected_participants.sort(key=lambda x: x[0])

    print(olympiad)
    for p in selected_participants:
        print(p[0])
