def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]
    for i in range(min(n, m)):
        ornament[i][0] = 'x'
        ornament[0][i] = 'x'
    for i in range(1, n):
        for j in range(1, m):
            if ornament[i][j] != 'x':
                if i % 2 == j % 2:
                    ornament[i][j] = 'x'
    
    return ornament
n, m = map(int, input().split())
ornament = create_ornament(n, m)
for row in ornament:
    print(''.join(row))