import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int[] weights = new int[4];
        for (int i = 0; i < 4; i++) {
            weights[i] = in.nextInt();
        }
        
        int[] boxes = new int[4];
        for (int i = 0; i < 4; i++) {
            boxes[i] = in.nextInt();
        }

        int maxDiff = weight(weights, boxes);

        int ans = -1;

        for (int i = 0; i < 4; i++)
        {
            if (boxes[i] == 1)
            {
                boxes[i] = 2;
            }else{
                boxes[i] = 1;
            }
            
            int diff = weight(weights, boxes);
            
            if (diff < maxDiff)
            {
                maxDiff = diff;
                ans = i + 1;
            }

            if (boxes[i] == 1)
            {
                boxes[i] = 2;
            }else{
                boxes[i] = 1;
            }
        }
        
        System.out.println(ans);
    }

    public static int weight(int[] a, int[] b)
    {
        int w1 = 0;
        int w2 = 0;
        for (int i = 0; i < 4; i++)
        {
            if (b[i] == 1)
            {
                w1 += a[i];
            }else
            {
                w2 += a[i];
            }
        }
        return Math.abs(w1 - w2);
    }
}
