def process_requests(n, m, sizes, available_tshirts, k, requests):
    remaining_tshirts = [row[:] for row in available_tshirts]
    needed_tshirts = [[0] * m for _ in range(n)]

    for c, s in requests:
        size_index = sizes.index(s)
        color_index = int(c) - 1  

        found_tshirt = False


        if remaining_tshirts[color_index][size_index] > 0:
            remaining_tshirts[color_index][size_index] -= 1
            found_tshirt = True
        else:
            for j in range(size_index, m):
                for i in range(n):
                    if remaining_tshirts[i][j] > 0 and (i == color_index or remaining_tshirts[color_index][j] == 0):
                        remaining_tshirts[i][j] -= 1
                        found_tshirt = True
                        break

                if found_tshirt:
                    break

        if not found_tshirt:
            needed_tshirts[color_index][size_index] += 1

    return remaining_tshirts, needed_tshirts


n, m = map(int, input().split())
sizes = input().split()
available_tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [input().split() for _ in range(k)]

remaining_tshirts, needed_tshirts = process_requests(n, m, sizes, available_tshirts, k, requests)

for row in remaining_tshirts:
    print(*row)

for row in needed_tshirts:
    print(*row)
