#include <iostream>
#include <vector>

int main() {
    // Зчитуємо ваги та номери коробок
    std::vector<int> weights(4), boxes(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Знаходимо вагу кожної коробки
    int box1_weight = 0, box2_weight = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            box1_weight += weights[i];
        } else {
            box2_weight += weights[i];
        }
    }

    // Шукаємо номер речі, яку можна перемістити, щоб зменшити максимальну вагу коробки
    for (int i = 0; i < 4; ++i) {
        int current_box = boxes[i] - 1;
        int other_box = 1 - current_box;

        int new_weight_current_box = box1_weight, new_weight_other_box = box2_weight;
        if (boxes[i] == 1) {
            new_weight_current_box -= weights[i];
            new_weight_other_box += weights[i];
        } else {
            new_weight_current_box += weights[i];
            new_weight_other_box -= weights[i];
        }

        int max_weight = std::max(new_weight_current_box, new_weight_other_box);
        int min_weight = std::min(new_weight_current_box, new_weight_other_box);

        if (max_weight - min_weight <= 1) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // Якщо оптимально нічого не змінювати
    std::cout << "-1" << std::endl;

    return 0;
}
