def filter_participants(olympiad, participants):
    result = []
    if olympiad == 'IOI' or olympiad == 'CEOI':
        result = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'EGOI':
        result = sorted(filter(lambda x: x[1] == 'female', participants), key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'EJOI':
        result = sorted(filter(lambda x: x[3] <= 15, participants), key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'BaltOI':
        result = sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad == 'BalkOI':
        result = sorted(filter(lambda x: x[3] != 11, participants), key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == 'JBOI':
        result = sorted(filter(lambda x: x[3] != 11 and x[3] != 10, participants), key=lambda x: x[4], reverse=True)[:4]

    return result


n = int(input())
participants = []
for _ in range(n):
    participant = input().split()
    participant[0] = int(participant[0])
    participant[3] = int(participant[3])
    participant[4] = int(participant[4])
    participants.append(participant)

m = int(input())
olympiads = [input() for _ in range(m)]

for olympiad in olympiads:
    filtered = filter_participants(olympiad, participants)
    print(olympiad)
    for participant in filtered:
        print(participant[0])
