#include <iostream>
#include <vector>

using namespace std;

int max_uncolored_subsegment(int n, int m, int k, vector<int>& a) {
    int odd_prefix = min(n / 2 + 1, k);
    int even_suffix = min(n / 2, k);
    int max_length = min(m + 1, max(odd_prefix, even_suffix));
    return max_length;
}

int main() {
    int n, m, k;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cin >> k;

    int result = max_uncolored_subsegment(n, m, k, a);
    cout << result << endl;

    return 0;
}
