def find_item_to_move(weights, boxes):
    total_weight = sum(weights)
    max_box_weight = max(sum(weights[i] for i in range(4) if boxes[i] == box) for box in {1, 2})

    for i in range(4):
        if boxes[i] == 1 and total_weight - weights[i] <= max_box_weight:
            return i + 1

    return -1

def main():
    weights = list(map(int, input().split()))
    boxes = list(map(int, input().split()))

    result = find_item_to_move(weights, boxes)
    print(result)

if __name__ == "__main__":
    main()
