#include <bits/stdc++.h>

using namespace std;

int main() {
  int n, m;
  cin >> n >> m;

  vector<int> sizes(m);
  for (int i = 0; i < m; i++) {
    cin >> sizes[i];
  }

  vector<vector<int>> available(n, vector<int>(m, 0));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cin >> available[i][j];
    }
  }

  int k;
  cin >> k;

  vector<vector<int>> requests(k, vector<int>(2, 0));
  for (int i = 0; i < k; i++) {
    cin >> requests[i][0] >> requests[i][1];
  }

  for (const auto& request : requests) {
    int color = request[0] - 1;
    int size = std::find(sizes.begin(), sizes.end(), request[1]) - sizes.begin();
    available[color][size]--;
  }

  vector<vector<int>> needed(n, vector<int>(m, 0));
  for (const auto& request : requests) {
    int color = request[0] - 1;
    int size = std::find(sizes.begin(), sizes.end(), request[1]) - sizes.begin();
    needed[color][size] += 1;
  }

  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cout << available[i][j] << " ";
    }
    cout << endl;
  }

  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cout << needed[i][j] << " ";
    }
    cout << endl;
  }

  return 0;
}
