#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

struct Contestant 
{
    int id;
    string gender;
    int age;
    int height;
    int score;
};

void filterContestants(const vector<Contestant>& contestants, const vector<string>& selectedContests) 
{
    for (const auto& contest : selectedContests) 
    {
        cout << contest << endl;

        for (const auto& contestant : contestants) 
        {
            if (contestant.gender == contest.substr(0, 1) && contestant.age >= (contest[1] - '0') && contestant.height >= (contest[2] - '0') && contestant.score >= stoi(contest.substr(3))) 
            {
                cout << contestant.id << endl;
            }
        }

        cout << endl;
    }
}

int main() 
{
    int n;
    cin >> n;

    vector<Contestant> contestants(n);
    for (int i = 0; i < n; ++i) 
    {
        cin >> contestants[i].id >> contestants[i].gender >> contestants[i].age >> contestants[i].height >> contestants[i].score;
    }

    int m;
    cin >> m;

    vector<string> selectedContests(m);
    for (int i = 0; i < m; ++i) 
    {
        cin >> selectedContests[i];
    }

    filterContestants(contestants, selectedContests);

    return 0;
}
