def select_team(olympiad, participants):
    if olympiad == "IOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        return sorted(filter(lambda x: x[1] == 'female', participants), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EJOI":
        return sorted(filter(lambda x: x[3] <= 15, participants), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        return sorted(filter(lambda x: x[3] != 11, participants), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "JBOI":
        return sorted(filter(lambda x: x[3] not in {10, 11}, participants), key=lambda x: (-x[4], x[0]))[:4]

# Read input values
n = int(input())
participants = []

# Read participant information
for _ in range(n):
    info = input().split()
    participants.append((int(info[0]), info[1], int(info[2]), int(info[3]), int(info[4])))

m = int(input())
olympiads = [input() for _ in range(m)]

# Select teams for each olympiad
teams = {olympiad: select_team(olympiad, participants) for olympiad in olympiads}

# Print the results
for olympiad in olympiads:
    print(olympiad)
    for participant in teams[olympiad]:
        print(participant[0])
