def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        ornament[i][0] = 'x'
        if i > 0:
            ornament[i - 1][1] = 'x'

    for i in range(n - 1, -1, -1):
        ornament[i][m - 1] = 'x'
        if i < n - 1:
            ornament[i + 1][m - 2] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

n, m = map(int, input().split())

ornament = generate_ornament(n, m)
print_ornament(ornament)