def process_tshirts(n, m, sizes, available_tshirts, k, winners):
    remaining_tshirts = [list(row) for row in available_tshirts]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = winners[i]
        color = int(color) - 1
        size_index = sizes.index(size)

        if remaining_tshirts[color][size_index] > 0:
            remaining_tshirts[color][size_index] -= 1
        else:
            found = False

            for j in range(size_index + 1, m):
                if remaining_tshirts[color][j] > 0:
                    needed_tshirts[color][j] += 1
                    remaining_tshirts[color][j] -= 1
                    found = True
                    break

            if not found:
                for j in range(n):
                    if remaining_tshirts[j][size_index] > 0:
                        needed_tshirts[j][size_index] += 1
                        remaining_tshirts[j][size_index] -= 1
                        found = True
                        break

            if not found:
                for j in range(size_index + 1, m):
                    for k in range(n):
                        if remaining_tshirts[k][j] > 0:
                            needed_tshirts[k][j] += 1
                            remaining_tshirts[k][j] -= 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                needed_tshirts[color][size_index] += 1

    return remaining_tshirts, needed_tshirts

n, m = 2, 3
sizes = ["S", "M", "XL"]
available_tshirts = [
    [1, 3, 0],
    [3, 0, 3],
]
k = 9
winners = [
    ("1", "S"),
    ("2", "XL"),
    ("1", "M"),
    ("2", "XL"),
    ("1", "M"),
    ("2", "M"),
    ("1", "M"),
    ("2", "S"),
    ("1", "XL"),
]

remaining, needed = process_tshirts(n, m, sizes, available_tshirts, k, winners)

for row in remaining:
    print(*row)

for row in needed:
    print(*row)