#include <stdio.h>

int maxFlowerPaths(int n, int m) {
    int paths[n][m];
    for (int i = 0; i < n; i++)
        paths[i][0] = 1;
    for (int j = 0; j < m; j++)
        paths[0][j] = 1;
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < m; j++) {
            paths[i][j] = paths[i - 1][j] + paths[i][j - 1];
        }
    }
    return paths[n - 1][m - 1];
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    int result = maxFlowerPaths(n, m);
    printf("%d\n", result);

    return 0;
}