weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

box_weights = [sum(weights[i] for i in range(4) if boxes[i] == j) for j in range(1, 3)]

max_weight = max(box_weights)

# Ініціалізуємо змінні для збереження оптимального вибору
optimal_move = -1
min_max_weight = max_weight

# Перебираємо всі предмети та коробки
for i in range(4):
    if boxes[i] == 1:
        new_weight = box_weights[0] - weights[i]
        max_weight_after_move = max(new_weight, box_weights[1] + weights[i])
    else:
        new_weight = box_weights[1] - weights[i]
        max_weight_after_move = max(new_weight, box_weights[0] + weights[i])

    # Перевіряємо, чи оптимізуємо максимальну вагу
    if max_weight_after_move < min_max_weight:
        min_max_weight = max_weight_after_move
        optimal_move = i + 1

# Виводимо результат
print(optimal_move)