#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long totalColors = 0;
    long long maxSegment = 0;

    for (int i = 0; i < n; ++i) {
        totalColors += a[i];
        maxSegment = max(maxSegment, totalColors);
    }

    if (totalColors <= m) {
        cout << maxSegment << endl;
    } else {
        long long remainingColors = m;
        long long segments = (remainingColors / totalColors) * n;
        remainingColors %= totalColors;

        for (int i = 0; i < n && remainingColors > 0; ++i) {
            remainingColors -= a[i];
            if (remainingColors >= 0) {
                segments++;
            }
        }

        cout << max(maxSegment, segments) << endl;
    }

    return 0;
}
