#include <iostream>
#include <vector>

void generateOrnament(int n, int m) {
    std::vector<char> ornament(n * m, ' ');


    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int index = i * m + j;
            if (i == 0 || j == 0 || i == n - 1 || j == m - 1) {
                ornament[index] = '*';
            } else if (i == j || i == m - 1 - j) {
                ornament[index] = '*';
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int index = i * m + j;
            std::cout << ornament[index] << ' ';
        }
        std::cout << '\n';
    }
}

int main() {

    int n, m;
    std::cin >> n >> m;


    generateOrnament(n, m);

    return 0;
}

