#include <iostream>
#include <vector>

using namespace std;

int maxFlowers(vector<vector<int>>& garden) {
    int n = garden.size();
    int m = garden[0].size();

    
    vector<vector<int>> dp(n, vector<int>(m, 0));

  
    dp[0][0] = garden[0][0];
    for (int i = 1; i < n; ++i) {
        dp[i][0] = dp[i - 1][0] + garden[i][0];
    }
    for (int j = 1; j < m; ++j) {
        dp[0][j] = dp[0][j - 1] + garden[0][j];
    }

   
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < m; ++j) {
            dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]) + garden[i][j];
        }
    }

    
    return dp[n - 1][m - 1];
}

int main() {
 
    vector<vector<int>> garden = {
        {1, 2, 3},
        {4, 5, 6},
        {7, 8, 9}
    };

    cout <<  maxFlowers(garden) << endl;

    return 0;
}
