#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
    vector<int> weights(4);
    vector<int> boxes(4);
    for (int i = 0; i < 4; i++) {
        cin >> weights[i];
    }
    for (int i = 0; i < 4; i++) {
        cin >> boxes[i];
    }

    int box1_weight = 0, box2_weight = 0;
    for (int i = 0; i < 4; i++) {
        if (boxes[i] == 1) {
            box1_weight += weights[i];
        } else {
            box2_weight += weights[i];
        }
    }

    if (box1_weight == box2_weight) {
        cout << -1 << endl;
        return 0;
    }

    int diff = abs(box1_weight - box2_weight);
    int item_to_move = -1;
    for (int i = 0; i < 4; i++) {
        if (boxes[i] == 1 && abs(box1_weight - 2*weights[i] - box2_weight) < diff) {
            diff = abs(box1_weight - 2*weights[i] - box2_weight);
            item_to_move = i;
        } else if (boxes[i] == 2 && abs(box2_weight - 2*weights[i] - box1_weight) < diff) {
            diff = abs(box2_weight - 2*weights[i] - box1_weight);
            item_to_move = i;
        }
    }

    if (item_to_move == -1) {
        cout << -1 << endl;
    } else {
        cout << item_to_move + 1 << endl;
    }

    return 0;
}

