def print_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Fill the upper left quarter with 'x'
    for i in range(n):
        for j in range(min(i + 1, m)):
            ornament[i][j] = 'x'

    # Mirror the upper left quarter to the upper right quarter
    for i in range(n):
        for j in range(m - 1, m - 1 - min(i + 1, m), -1):
            ornament[i][j] = ornament[i][m - 1 - j]

    # Mirror the upper left and upper right quarters to create the full ornament
    for i in range(n):
        print("".join(ornament[i]))

# Read input
n, m = map(int, input().split())

# Print the ornament
print_ornament(n, m)


