#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct P {
    int id, grade, age, score;
    string gender;
};

bool comp(const P &a, const P &b) {
    return a.score > b.score;
}

vector<P> st(const string &o, const vector<P> &p) {
    vector<P> sp;
    if (o == "IOI" || o == "CEOI" || o == "BaltOI") {
        int ts = min((o == "BaltOI" ? 6 : 4), static_cast<int>(p.size()));
        sp = p;
        sort(sp.begin(), sp.end(), comp);
        sp.resize(ts);
    } else if (o == "EGOI") {
        vector<P> fp;
        for (const auto &x : p) if (x.gender == "female") fp.push_back(x);
        int ts = min(4, static_cast<int>(fp.size()));
        sp = fp;
        sort(sp.begin(), sp.end(), comp);
        sp.resize(ts);
    } else if (o == "EJOI") {
        vector<P> u15p;
        for (const auto &x : p) if (x.age <= 15) u15p.push_back(x);
        int ts = min(4, static_cast<int>(u15p.size()));
        sp = u15p;
        sort(sp.begin(), sp.end(), comp);
        sp.resize(ts);
    } else if (o == "BalkOI") {
        vector<P> n11gp;
        for (const auto &x : p) if (x.grade != 11) n11gp.push_back(x);
        int ts = min(4, static_cast<int>(n11gp.size()));
        sp = n11gp;
        sort(sp.begin(), sp.end(), comp);
        sp.resize(ts);
    } else if (o == "JBOI") {
        vector<P> n11o10gp;
        for (const auto &x : p) if (x.grade != 11 && x.grade != 10) n11o10gp.push_back(x);
        int ts = min(4, static_cast<int>(n11o10gp.size()));
        sp = n11o10gp;
        sort(sp.begin(), sp.end(), comp);
        sp.resize(ts);
    }
    return sp;
}

int main() {
    int n;
    cin >> n;
    vector<P> pp;
    for (int i = 0; i < n; ++i) {
        P x;
        cin >> x.id >> x.gender >> x.grade >> x.age >> x.score;
        pp.push_back(x);
    }

    int m;
    cin >> m;
    vector<string> oo(m);
    for (int i = 0; i < m; ++i) {
        cin >> oo[i];
    }

    for (const auto &o : oo) {
        vector<P> stp = st(o, pp);
        cout << o << endl;
        sort(stp.begin(), stp.end(), [](const P &a, const P &b) {
            return a.id < b.id;
        });
        for (const auto &p : stp) {
            cout << p.id << endl;
        }
    }

    return 0;
}
