def max_unselected_length(n, m, a):
    period_length = sum(a)
    
    full_periods = m // period_length
    
    remaining_colors = m % period_length
    
    colors = a.copy()
    
    max_length = 0
    current_length = 0
    for i in range(remaining_colors):
        current_length += colors[i]
        max_length = max(max_length, current_length)
    
    return full_periods * period_length + max_length

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unselected_length(n, m, a)
print(result)


