def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][i] = 'x'
        ornament[i][m - i - 1] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Example usage
n, m = map(int, input().split())
ornament = generate_ornament(n, m)
print_ornament(ornament)