def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        ornament[i][i] = 'x'
        ornament[i][m - i - 1] = 'x'

    mid_row = n // 2
    mid_col = m // 2

    if n % 2 == 0:
        ornament[mid_row][mid_col - 1] = '.'
        ornament[mid_row][mid_col] = '.'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Example usage
n, m = map(int, input().split())
ornament = generate_ornament(n, m)
print_ornament(ornament)
