def process_winners(n, m, sizes, available_tshirts, num_winners, winners):
    remaining_tshirts = [[0] * m for _ in range(n)]
    required_tshirts = [[0] * m for _ in range(n)]
    for i in range(num_winners):
        color, size = winners[i]
        color = int(color) - 1
        found_tshirt = False
        if available_tshirts[color][sizes.index(size)] > 0:
            available_tshirts[color][sizes.index(size)] -= 1
            found_tshirt = True
        else:
            for c in range(n):
                if c != color and available_tshirts[c][sizes.index(size)] > 0:
                    available_tshirts[c][sizes.index(size)] -= 1
                    found_tshirt = True
                    break
            for s in range(sizes.index(size) + 1, m):
                if available_tshirts[color][s] > 0:
                    available_tshirts[color][s] -= 1
                    found_tshirt = True
                    break
                for c in range(n):
                    if c != color and available_tshirts[c][s] > 0:
                        available_tshirts[c][s] -= 1
                        found_tshirt = True
                        break
                if found_tshirt:
                    break
        if not found_tshirt:
            required_tshirts[color][sizes.index(size)] += 1
    return available_tshirts, required_tshirts
def print_tshirts(tshirts):
    for row in tshirts:
        print(" ".join(map(str, row)))
if __name__ == "__main__":
    n, m = map(int, input().split())
    sizes = input().split()
    available_tshirts = [list(map(int, input().split())) for _ in range(n)]
    num_winners = int(input())
    winners = [list(map(str, input().split())) for _ in range(num_winners)]
    available_tshirts, required_tshirts = process_winners(n, m, sizes, available_tshirts, num_winners, winners)
    print_tshirts(available_tshirts)
    print_tshirts(required_tshirts)
