def max_unmarked_length(n, m, a):
    remaining_colors = n + m
    unmarked_sequences = [x - 1 for x in a]  # Subtract 1 for the initially marked color

    unmarked_sequences.sort(reverse=True)

    max_len = 0
    for i in range(len(unmarked_sequences)):
        if remaining_colors == 0:
            break

        if unmarked_sequences[i] % 2 == 0:
            max_len = max(max_len, min(remaining_colors, unmarked_sequences[i]))
        else:
            max_len = max(max_len, min(remaining_colors - 1, unmarked_sequences[i]))

        remaining_colors -= 2

    return max_len

# Example usage
n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_length(n, m, a)
print(result)
