def max_unmarked_length(n, m, a):
    total_colors = sum(a) + n
    remaining_colors = n + m

    max_sequence_length = 0
    a.sort(reverse=True)

    for length in a:
        if remaining_colors == 0:
            break

        if length % 2 == 0:
            max_sequence_length = max(max_sequence_length, min(remaining_colors, length - 1))
        else:
            max_sequence_length = max(max_sequence_length, min(remaining_colors, length))

        remaining_colors -= length // 2

    return max_sequence_length

# Example usage
n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_length(n, m, a)
print(result)
