#include <iostream>
#include <vector>

using namespace std;

void make(int n, int m) 
{
    vector<vector<char>> s(n, vector<char>(m, '.'));

    int left = 0, right = m - 1;
    int left_ = 1, right_ = -1; 

    for (int i = 0; i < n; i++) 
    {
        s[i][left] = 'x';
        s[i][right] = 'x';

        left += left_;
        right += right_;

        if (left == 0 || left == m - 1) left_ *= -1;
        if (right == 0 || right == m - 1) right_ *= -1;
    }

    for (int i = 0; i < n; i++) 
    {
        for (int j = 0; j < m; j++) 
            cout << s[i][j];
        cout<<"\n";
    }
}

int main() 
{
    int N,M;
    cin>>N>>M;
    make(N,M);

    return 0;
}