#include <iostream>
#include <vector>

int main() {
    std::vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }
    std::vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }
    std::vector<int> maxWeightInBox(2, 0);
    for (int i = 0; i < 4; ++i) {
        maxWeightInBox[boxes[i] - 1] = std::max(maxWeightInBox[boxes[i] - 1], weights[i]);
    }

    int minMaxWeightBox = 0;
    for (int i = 1; i < 2; ++i) {
        if (maxWeightInBox[i] < maxWeightInBox[minMaxWeightBox]) {
            minMaxWeightBox = i;
        }
    }
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] != minMaxWeightBox + 1 && weights[i] < maxWeightInBox[minMaxWeightBox]) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    std::cout << "-1" << std::endl;

    return 0;
}