#include <bits/stdc++.h>
#include <vector>
#include <unordered_map>
#include <algorithm>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    unordered_map<string, int> size_index;
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
        size_index[sizes[i]] = i;
    }

    vector<vector<int>> available(n, vector<int>(m));
    vector<vector<int>> remaining(n, vector<int>(m));
    vector<vector<int>> to_order(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
            remaining[i][j] = available[i][j];
        }
    }

    int k;
    cin >> k;

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;

        string size_str(1, s);
        int size_index_val = size_index[size_str];

        if (remaining[c - 1][size_index_val] > 0) {
            --remaining[c - 1][size_index_val];
        } else {
            int found_j = -1;

            for (int j = size_index_val + 1; j < m; ++j) {
                if (remaining[c - 1][j] > 0) {
                    found_j = j;
                    break;
                }
            }

            if (found_j == -1) {
                for (int j = 0; j < m; ++j) {
                    if (remaining[c - 1][j] > 0) {
                        found_j = j;
                        break;
                    }
                }
            }

            if (found_j != -1) {
                --remaining[c - 1][found_j];
                ++to_order[c - 1][found_j];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
