n, m = map(int, input().split())
sizes = list(input().split())
tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [input().split() for _ in range(k)]

size_to_idx = {size: idx for idx, size in enumerate(sizes)}
idx_to_size = {idx: size for size, idx in size_to_idx.items()}
requests = [(int(color)-1, size_to_idx[size]) for color, size in requests]

remaining = [row[:] for row in tshirts]
needed = [[0]*m for _ in range(n)]

for color, size in requests:
    if remaining[color][size] > 0:
        remaining[color][size] -= 1
    elif any(remaining[color]):
        new_size = min(idx for idx in range(m) if remaining[color][idx] > 0)
        remaining[color][new_size] -= 1
        needed[color][size] += 1
    else:
        needed[color][size] += 1

for row in remaining:
    print(*row)
for row in needed:
    print(*row)
