def calculate_max_weight(weights, target_box_weight):
    total_weight = sum(weights)
    current_box_weight = 0

    for i in range(len(weights)):
        current_box_weight += weights[i]

        if current_box_weight >= target_box_weight and i + 1 < len(weights):
            current_box_weight -= weights[i + 1]

        elif current_box_weight == target_box_weight and i + 1 == len(weights):
            return i + 1

    return -1

weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

target_box_weight = sum(weights[i] for i in range(len(weights)) if boxes[i] == 1)
target_box_weight = min(target_box_weight, sum(weights[i] for i in range(len(weights)) if boxes[i] == 2))

result = calculate_max_weight(weights, target_box_weight)

print(result)
  