#include <iostream>

using namespace std;

int main() {
  // Введіть дані
  int n, m;
  cin >> n >> m;
  vector<int> sizes(m);
  for (int i = 0; i < m; i++) {
    cin >> sizes[i];
  }
  vector<vector<int>> colors(n, vector<int>(m, 0));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cin >> colors[i][j];
    }
  }
  int k;
  cin >> k;
  vector<pair<int, char>> requests(k);
  for (int i = 0; i < k; i++) {
    cin >> requests[i].first >> requests[i].second;
  }

  // Обробіть запити
  vector<vector<int>> left_overs(n, vector<int>(m, 0));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      left_overs[i][j] = colors[i][j];
    }
  }
  for (int i = 0; i < k; i++) {
    int color = requests[i].first;
    char size = requests[i].second;
    int size_index = find(sizes.begin(), sizes.end(), size) - sizes.begin();
    if (left_overs[color - 1][size_index] > 0) {
      left_overs[color - 1][size_index]--;
    } else {
      for (int j = size_index + 1; j < m; j++) {
        if (left_overs[color - 1][j] > 0) {
          left_overs[color - 1][j]--;
          size_index = j;
          break;
        }
      }
      if (size_index == m) {
        // Не можемо видати футболку
      }
    }
  }

  // Виведіть результати
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cout << left_overs[i][j] << " ";
    }
    cout << endl;
  }

  return 0;
}