def max_flowers(n, m):
    # Ініціалізуємо dp масив
    dp = [[0] * m for _ in range(n)]

    # Перше значення - верхній лівий кут
    dp[0][0] = 1

    # Заповнюємо dp масив
    for i in range(n):
        for j in range(m):
            if i > 0:
                dp[i][j] += dp[i - 1][j]
            if j > 0:
                dp[i][j] += dp[i][j - 1]

    # Повертаємо кількість способів дійти до правого нижнього кута
    return dp[n - 1][m - 1]

# Зчитуємо розміри клумби
n = int(input())
m = int(input())

# Виводимо результат
result = max_flowers(n, m)
print(result)
