#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }

    vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    int totalWeightBox1 = 0, totalWeightBox2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            totalWeightBox1 += weights[i];
        } else {
            totalWeightBox2 += weights[i];
        }
    }

    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            if (totalWeightBox1 - weights[i] + weights[i] <= totalWeightBox2) {
                cout << i + 1 << endl;
                return 0;
            }
        } else {
            if (totalWeightBox2 - weights[i] + weights[i] <= totalWeightBox1) {
                cout << i + 1 << endl;
                return 0;
            }
        }
    }

    cout << "-1" << endl;

    return 0;
}
