#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Input weights
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    // Input box numbers
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    int totalWeightBox1 = 0, totalWeightBox2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            totalWeightBox1 += weights[i];
        } else {
            totalWeightBox2 += weights[i];
        }
    }

    // Iterate through each item and find the one that, if moved, minimizes the maximum weight
    for (int i = 0; i < 4; ++i) {
        int newTotalWeightBox1 = totalWeightBox1 - weights[i];
        int newTotalWeightBox2 = totalWeightBox2 + weights[i];
        int maxWeightAfterMove = std::max(newTotalWeightBox1, newTotalWeightBox2);

        if (maxWeightAfterMove <= std::max(totalWeightBox1, totalWeightBox2)) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // If it's optimal not to change anything
    std::cout << "-1" << std::endl;

    return 0;
}
