#include <bits/stdc++.h>
using namespace std;
typedef map<string, int> Mymap;

int n,m;
int needBuy[100][6];
int Tleft[100][6];
Mymap poz;

void printResult()
{
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cout << Tleft[i][j] << " ";
        }
        cout << "\n";
    }

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cout << needBuy[i][j] << " ";
        }
        cout << "\n";
    }
}

bool hasColor(int color, int digSize)
{
    for(int i =0; i<n; i++)
    {
        if(Tleft[i][digSize]>0)
        {
            Tleft[i][digSize]--;
            return true;
        }
    }
    return false;
}

bool take(int color, int digSize)
{
    //color and size
    if(Tleft[color][digSize]>0)
    {
        Tleft[color][digSize]--;
        return true;
    }

    if(hasColor(color, digSize))
    {
        return true;
    }

    if(digSize < m-1)
    {
        return take(color, digSize+1);
    }

    return false;
}

int main()
{
    cin>>n>>m;
    string str;
    for(int i=0; i<m; i++)
    {
        cin>>str;
        poz.insert(Mymap::value_type(str, i));
    }

    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
        {
            cin>>Tleft[i][j];
        }
    int am;
    cin>>am;
    int a;
    string cont;

    for(int i=0; i<am; i++)
    {
        cin>>a>>cont;
        int digSize = poz[cont];
        if(!take(a, digSize))
        {
//            cout <<"need to buy : "<<a<< cont<<"\n";
            needBuy[a-1][poz[cont]]++;
        }
    }
    printResult();
}

