def find_item_to_move(weights, boxes):
    total_weight_box_1 = sum(weights[i] for i in range(4) if boxes[i] == 1)
    total_weight_box_2 = sum(weights[i] for i in range(4) if boxes[i] == 2)

    for i in range(4):
        new_total_weight_box_1 = total_weight_box_1 - weights[i] + (boxes[i] == 2) * weights[i]
        new_total_weight_box_2 = total_weight_box_2 - weights[i] + (boxes[i] == 1) * weights[i]

        max_weight_after_move = max(new_total_weight_box_1, new_total_weight_box_2)
        
        if max_weight_after_move <= max(total_weight_box_1, total_weight_box_2):
            return i + 1

    return -1

weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

result = find_item_to_move(weights, boxes)
print(result)
