#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    vector<int> weights(4), boxes(4);
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }
    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    int box1_weight = 0, box2_weight = 0;

    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            box1_weight += weights[i];
        } else {
            box2_weight += weights[i];
        }
    }

    int max_box_weight = max(box1_weight, box2_weight);

    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            int temp_box1 = box1_weight - weights[i] + box2_weight;
            int temp_box2 = box2_weight - weights[i] + box1_weight;
            if (abs(temp_box1 - temp_box2) < abs(max_box_weight - temp_box1) || abs(temp_box1 - temp_box2) < abs(max_box_weight - temp_box2)) {
                cout << i + 1 << endl;
                return 0;
            }
        } else {
            int temp_box1 = box1_weight + weights[i] - box2_weight;
            int temp_box2 = box2_weight + weights[i] - box1_weight;
            if (abs(temp_box1 - temp_box2) < abs(max_box_weight - temp_box1) || abs(temp_box1 - temp_box2) < abs(max_box_weight - temp_box2)) {
                cout << i + 1 << endl;
                return 0;
            }
        }
    }

    cout << "-1" << endl;

    return 0;
}