#include <iostream>
#include <vector>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Зчитуємо вхідні дані
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Знаходимо суми ваг речей у кожній коробці
    int box1_weight = 0, box2_weight = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            box1_weight += weights[i];
        } else {
            box2_weight += weights[i];
        }
    }

    // Визначаємо, яку річ перемістити (якщо потрібно)
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1 && box1_weight - weights[i] == box2_weight + weights[i]) {
            std::cout << i + 1 << std::endl; // Виводимо номер речі, яку потрібно перемістити
            return 0;
        }
        if (boxes[i] == 2 && box2_weight - weights[i] == box1_weight + weights[i]) {
            std::cout << i + 1 << std::endl; // Виводимо номер речі, яку потрібно перемістити
            return 0;
        }
    }

    // Якщо оптимально нічого не змінювати
    std::cout << "-1" << std::endl;
    return 0;
}
