def find_item_to_move(weights, boxes):
    box_1_weight = sum(weights[i] for i in range(4) if boxes[i] == 1)
    box_2_weight = sum(weights[i] for i in range(4) if boxes[i] == 2)

    max_weight_box = max(box_1_weight, box_2_weight)
    min_weight_box = min(box_1_weight, box_2_weight)

    if max_weight_box - weights[0] == min_weight_box or max_weight_box - weights[1] == min_weight_box or max_weight_box - weights[2] == min_weight_box or max_weight_box - weights[3] == min_weight_box:
        return -1
    else:
        for i in range(4):
            if weights[i] == max_weight_box - min_weight_box:
                return i + 1

# Приклад використання:
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))
result = find_item_to_move(weights, boxes)
print(result)
