#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<int> colors(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> colors[i];
    }

    // Знаходимо максимальну довжину підвідрізку незакреслених кольорів
    int max_length = 0;
    int current_length = 0;

    for (int i = 0; i < n; ++i) {
        if (colors[i] % 2 == 0) {
            current_length++;
        } else {
            max_length = std::max(max_length, current_length);
            current_length = 0;
        }
    }
    max_length = std::max(max_length, current_length);

    // Додаємо m до максимальної довжини
    max_length += m;

    std::cout << max_length << std::endl;

    return 0;
}