#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<int> colors(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> colors[i];
    }

    int max_length = 0;
    int current_length = 0;

    for (int i = 0; i < n; ++i) {
        if (colors[i] % 2 == 1) {
            ++current_length;
            max_length = std::max(max_length, current_length);
        } else {
            current_length = 0;
        }
    }

    if (max_length == 0) {
        std::cout << m << std::endl;
    } else {
        std::cout << std::min(n, max_length + m) << std::endl;
    }

    return 0;
}