def max_length(colors, m):
    longest_segment = 0
    current_segment = 0

    for color in colors:
        if color == 0:
            current_segment += 1
            longest_segment = max(longest_segment, current_segment)
        else:
            current_segment = 0

    return min(longest_segment, m)

def main():
    n, m = map(int, input().split())
    color_counts = list(map(int, input().split()))

    max_unmarked = max_length(color_counts, m)

    remaining_colors = m - max_unmarked
    max_length_remaining = max_length(color_counts[::-1], remaining_colors)

    print(max_unmarked + max_length_remaining)

if __name__ == "__main__":
    main()