def max_subarray_length(n, m, a):
    left, right = 0, sum(a)
    
    while left < right:
        mid = (left + right + 1) // 2
        total = 0
        count = 0
        
        for ai in a:
            total += min(ai, mid)
            count += 1 if ai >= mid else 0
        
        if total >= m:
            left = mid
        else:
            right = mid - 1
    
    return left

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_subarray_length(n, m, a)
print(result)
