#include <bits/stdc++.h>
#include <algorithm>
#include <array>

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    
    // Read input data
    std::array<int, 4> w, t;
    for (int& elem : w) { std::cin >> elem; }
    for (int& elem : t) { std::cin >> elem; }

    std::array<int, 3> diffs = {
        w[0] - std::max({w[1], w[2], w[3]}),
        w[1] - std::max({w[0], w[2], w[3]}),
        w[2] - std::max({w[0], w[1], w[3]}),
    };

    int maxDiff = *std::max_element(diffs.begin(), diffs.end());

    if (maxDiff != 0) {
        std::cout << *std::find(diffs.begin(), diffs.end(), maxDiff) << std::endl;
    } else {
        std::cout << -1 << std::endl;
    }
}
