def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Add rays to the upper corners
    ornament[0][0] = 'X'
    ornament[0][m - 1] = 'X'

    # Create the reflection pattern for the ornament
    reflection_pattern = [
        'X..X',
        '.xx.',
        '.xx.',
        'Χ..Χ',
    ]

    # Copy the reflection pattern to the ornament
    for i in range(4):
        for j in range(4):
            ornament[i][j] = reflection_pattern[i][j]

    # Print the ornament
    for row in ornament:
        print(''.join(row))

# Input
n, m = map(int, input().split())

# Output
create_ornament(n, m)
