def max_unmarked_sequence(n, m, a):
    max_sequence = max(a)
    remaining = m - n

    if remaining <= 0:
        return max_sequence

    total_unmarked = sum(a)
    if remaining >= total_unmarked:
        return max_sequence + remaining // total_unmarked * max_sequence

    remaining %= total_unmarked
    colors = sorted(a)
    while remaining > 0:
        mid = len(colors) // 2
        if len(colors) % 2 == 0:
            max_sequence = max(max_sequence, colors[mid])
        else:
            max_sequence = max(max_sequence, colors[mid - 1])
        colors = colors[:mid] + colors[mid + 1:]
        remaining -= 1

    return max_sequence

# Taking input
n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, a)
print(result)
