def max_unmarked_sequence(n, m, a):
    a.sort()
    left = 1
    right = a[-1]

    while left <= right:
        mid = (left + right) // 2
        count = 0

        for i in range(n):
            count += (a[i] + mid - 1) // mid

        if count <= m:
            right = mid - 1
        else:
            left = mid + 1

    return left

n, m = map(int, input().split())
a = list(map(int, input().split()))

print(max_unmarked_sequence(n, m, a))
