#include <iostream>
#include <vector>

using namespace std;

int solution(int n, int m, vector<int>& a) {
    vector<int> used(n, 0);
    int max_length = 0;

    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            used[i] = a[i] + 1;
            max_length = max(max_length, used[i]);
        }
    }

    return max_length;
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int result = solution(n, m, a);
    cout << result << endl;

    return 0;
}
