import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();
        String[] result = new String[n];
        for (int i = 0; i < n; i++) {
            StringBuilder row = new StringBuilder();
            for (int j = 0; j < m; j++) {
                row.append(getOrnament(i, j, n, m));
            }
            result[i] = row.toString();
        }
        for (String s : result) {
            System.out.println(s);
        }
    }

    private static char getOrnament(int row, int col, int rows, int cols) {
        int dRow = row - rows / 2;
        int dCol = col - cols / 2;
        int dSum = Math.abs(dRow) + Math.abs(dCol);
        return dSum % 2 == 0 ? 'x' : '.';
    }
}