import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int m = scanner.nextInt();

        char[][] ornament = createOrnament(n, m);

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(ornament[i][j]);
            }
            System.out.println();
        }
    }

    private static char[][] createOrnament(int n, int m) {
        char[][] ornament = new char[n][m];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (i % 2 == 0 || j % 2 == 0) {
                    ornament[i][j] = 'x';
                } else {
                    ornament[i][j] = '.';
                }
            }
        }

        return ornament;
    }
}