def max_unmarked_sequence_length(n, m, wheels):
    max_length = 0
    total_unmarked = 0

    for wheel in wheels:
        total_unmarked += wheel - 1
        max_length = max(max_length, wheel)

    max_length += min(m, total_unmarked)

    return max_length

def main():
    n, m = map(int, input().split())
    wheels = list(map(int, input().split()))

    result = max_unmarked_sequence_length(n, m, wheels)
    print(result)

if __name__ == "__main__":
    main()
