program TShirts;

const
  MAX_SIZES = 6;

type
  TShirtArray = array of array of integer;

var
  colors, sizes: array[1..MAX_SIZES] of integer;
  available, needed: TShirtArray;
  n, m, i, j, c, winners, currentColor, currentSize: integer;
  sizeIndex: array['XS'..'2XL'] of integer;
  color, size: string;

procedure InitializeArrays();
begin
  SetLength(available, n + 1, m + 1);
  SetLength(needed, n + 1, m + 1);
  for i := 1 to n do
    for j := 1 to m do
    begin
      available[i, j] := 0;
      needed[i, j] := 0;
    end;
end;

begin
  sizeIndex['XS'] := 1;
  sizeIndex['S'] := 2;
  sizeIndex['M'] := 3;
  sizeIndex['L'] := 4;
  sizeIndex['XL'] := 5;
  sizeIndex['2XL'] := 6;

  readln(n, m);
  
  for i := 1 to m do
    read(sizes[i]);
  
  for i := 1 to n do
    for j := 1 to m do
      read(colors[i, j]);

  InitializeArrays();

  readln(winners);
  
  // Остальной код программы...
end.