program TShirts;

const
  MAX_COLORS = 100;
  MAX_SIZES = 6;

type
  TShirtArray = array[1..MAX_COLORS, 1..MAX_SIZES] of integer;

var
  colors, sizes: array[1..MAX_COLORS, 1..MAX_SIZES] of integer;
  available, needed: TShirtArray;
  n, m, i, j, k, c, winners, currentColorIndex, currentSizeIndex: integer;
  color, size: string;

procedure InitializeArrays();
var
  i, j: integer;
begin
  for i := 1 to MAX_COLORS do
    for j := 1 to MAX_SIZES do
    begin
      available[i, j] := 0;
      needed[i, j] := 0;
    end;
end;

begin
  readln(n, m);

  for i := 1 to m do
  begin
    read(size);
    sizes[1, i] := i;
  end;

  for i := 1 to n do
    for j := 1 to m do
      read(colors[i, j]);

  InitializeArrays();

  readln(winners);

  for i := 1 to winners do
  begin
    readln(c, size);
    readln(color);

    currentSizeIndex := -1;
    for k := 1 to m do
      if sizes[1, k] = c then
      begin
        currentSizeIndex := k;
        break;
      end;

    currentColorIndex := -1;
    for k := 1 to n do
      if colors[k, currentSizeIndex] > 0 then
      begin
        currentColorIndex := k;
        break;
      end;

    if currentColorIndex > 0 then
    begin
      available[currentColorIndex, currentSizeIndex] := available[currentColorIndex, currentSizeIndex] + 1;
      colors[currentColorIndex, currentSizeIndex] := colors[currentColorIndex, currentSizeIndex] - 1;
    end
    else
    begin
      for j := currentSizeIndex + 1 to m do
      begin
        for k := 1 to n do
        begin
          if colors[k, j] > 0 then
          begin
            available[k, j] := available[k, j] + 1;
            colors[k, j] := colors[k, j] - 1;
            break;
          end;
        end;
        if available[k, j] > 0 then
          break;
      end;

      if available[k, currentSizeIndex] = 0 then
        needed[k, currentSizeIndex] := needed[k, currentSizeIndex] + 1;
    end;
  end;

  for i := 1 to n do
  begin
    for j := 1 to m do
      write(available[i, j], ' ');
    writeln;
  end;

  for i := 1 to n do
  begin
    for j := 1 to m do
      write(needed[i, j], ' ');
    writeln;
  end;
end.