def process_gifts(n, m, sizes, available, winners):
    remaining = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for i in range(len(winners)):
        color, size = int(winners[i][0]), winners[i][1]
        color_index = sizes.index(size)

        if available[color-1][color_index] > 0:
            available[color-1][color_index] -= 1
        else:
            for j in range(color-1, n):
                if available[j][color_index] > 0:
                    available[j][color_index] -= 1
                    remaining[j][color_index] += 1
                    break
            else:
                for j in range(color_index+1, m):
                    for k in range(n):
                        if available[k][j] > 0:
                            available[k][j] -= 1
                            remaining[k][j] += 1
                            break
                    else:
                        to_order[k][j] += 1
                        break

    return remaining, to_order

n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]

remaining, to_order = process_gifts(n, m, sizes, available, winners)

for row in remaining:
    print(*row)

for row in to_order:
    print(*row)

