def can_choose_color(mid, n, m, a):
    remaining = mid
    for i in range(n):
        if a[i] > mid:
            remaining -= (a[i] - mid + 1) // 2
    return remaining >= 0

def find_max_length(n, m, a):
    left, right = 1, max(a)
    result = 0

    while left < right:
        mid = (left + right) // 2
        if can_choose_color(mid, n, m, a):
            left = mid + 1
            result = mid
        else:
            right = mid

    return result

# Зчитування вхідних даних
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Знаходження та виведення результату
result = find_max_length(n, m, a)
print(result)
