def calc(colors, sizes, available, winners):
    remaining = [[count for count in color] for color in available]
    to_order = [[0 for _ in range(len(sizes))] for _ in range(len(colors))]

    for winner in winners:
        color_index = int(winner[0]) - 1
        size_index = sizes.index(winner[1])

        if remaining[color_index][size_index] > 0:
            remaining[color_index][size_index] -= 1
        else:
            found = False
            for i in range(size_index + 1, len(sizes)):
                if remaining[color_index][i] > 0:
                    remaining[color_index][i] -= 1
                    found = True
                    break

            if not found:
                for i in range(color_index + 1, len(colors)):
                    for j in range(size_index, len(sizes)):
                        if remaining[i][j] > 0:
                            remaining[i][j] -= 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                to_order[color_index][size_index] += 1

    return remaining, to_order

n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
num_winners = int(input())
winners = [list(map(str, input().split())) for _ in range(num_winners)]

remaining_tshirts, tshirts_to_order = calc(range(1, n + 1), sizes, available, winners)

for row in remaining_tshirts:
    print(' '.join(map(str, row)))

for row in tshirts_to_order:
    print(' '.join(map(str, row)))