def find_item_to_move(weights, boxes):
    total_weight = [0, 0]

    for i in range(4):
        total_weight[boxes[i] - 1] += weights[i]

    max_weight = max(total_weight)

    for i in range(4):
        new_box = 2 - boxes[i] + 1
        if weights[i] + total_weight[new_box - 1] <= max_weight:
            return i + 1

    return -1

def main():
    weights = list(map(int, input().split()))
    boxes = list(map(int, input().split()))

    result = find_item_to_move(weights, boxes)
    print(result)

main()

