n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participants.append({
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    })

m = int(input())

olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    team = []

    if olympiad == 'IOI':
        team = sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'CEOI':
        team = sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p['gender'] == 'female']
        team = sorted(female_participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'EJOI':
        young_participants = [p for p in participants if p['age'] <= 15]
        team = sorted(young_participants, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'BaltOI':
        team = sorted(participants, key=lambda x: x['score'], reverse=True)[:6]
    elif olympiad == 'BalkOI':
        non_11th_graders = [p for p in participants if p['grade'] != 11]
        team = sorted(non_11th_graders, key=lambda x: x['score'], reverse=True)[:4]
    elif olympiad == 'JBOI':
        non_11th_10th_graders = [p for p in participants if p['grade'] not in [10, 11]]
        team = sorted(non_11th_10th_graders, key=lambda x: x['score'], reverse=True)[:4]

    print(olympiad)
    for participant in sorted(team, key=lambda x: x['id']):
        print(participant['id'])
