def max_unmarked_sequence(n, m, a):
    total_colors = sum(a)
    if m >= total_colors:
        return total_colors

    max_unmarked = 0

    for wheel_size in a:
        if wheel_size % 2 == 1:
            max_unmarked = max(max_unmarked, wheel_size)
        else:
            max_unmarked = max(max_unmarked, wheel_size // 2)

    remaining_m = m - total_colors + max_unmarked

    if remaining_m > 0:
        max_unmarked += remaining_m // n * (n - 1)
        max_unmarked += remaining_m % n

    return max_unmarked


n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, a)
print(result)
