n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant_id = int(participant_info[0])
    gender = participant_info[1]
    grade = int(participant_info[2])
    age = int(participant_info[3])
    score = int(participant_info[4])
    
    participants.append((participant_id, gender, grade, age, score))

m = int(input())
olympiads = [input() for _ in range(m)]

criteria = lambda x: 0

for olympiad in olympiads:
    team = []
    
    if olympiad == "IOI" or olympiad == "CEOI" or olympiad == "BaltOI":
        criteria = lambda x: x[4]
    elif olympiad == "EGOI":
        criteria = lambda x: x[4] if x[1] == "female" else -1
    elif olympiad == "EJOI":
        criteria = lambda x: x[4] if x[3] <= 15 else -1
    elif olympiad == "BalkOI":
        criteria = lambda x: x[4] if x[2] != 11 else -1
    elif olympiad == "JBOI":
        criteria = lambda x: x[4] if x[2] not in [10, 11] else -1

    team = sorted(participants, key=criteria, reverse=True)[:6] if olympiad == "BaltOI" else sorted(participants, key=criteria, reverse=True)[:4]
    
    print(olympiad)
    for member in team:
        print(member[0])
