def max_1_length(a, m):
    max_sum = float("-inf")
    max_length = 0
    current_sum = 0

    for i in range(len(a)):
        current_sum += a[i]

        if current_sum >= 0:
            max_sum = max(max_sum, current_sum)
            max_length = max(max_length, i + 1)
        else:
            current_sum = 0

    return max_length if max_sum >= m else 0

def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    result = max_1_length(a, m)
    print(result)

if __name__ == "__main__":
    main()













