n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant = {
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    }
    participants.append(participant)

m = int(input())
olympiads = []

for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)

results = {olympiad: [] for olympiad in olympiads}

for olympiad in olympiads:
    if olympiad == 'IOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:4]
    elif olympiad == 'CEOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:4]
    elif olympiad == 'EGOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['gender'] == 'female' and participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:4]
    elif olympiad == 'EJOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['age'] <= 15 and participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:4]
    elif olympiad == 'BaltOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:6]
    elif olympiad == 'BalkOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['grade'] != 11 and participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:4]
    elif olympiad == 'JBOI':
        results[olympiad] = sorted(
            [participant['id'] for participant in participants if participant['grade'] not in {10, 11} and participant['score'] > 0],
            key=lambda x: participants[x - 1]['score'],
            reverse=True
        )[:4]

for olympiad in olympiads:
    print(olympiad)
    for participant_id in results[olympiad]:
        print(participant_id)
