def select_participants(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        return sorted((p for p in participants if p[1] == "female"), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EJOI":
        return sorted((p for p in participants if p[3] <= 15), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        return sorted((p for p in participants if p[2] != 11), key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "JBOI":
        return sorted((p for p in participants if p[2] not in [10, 11]), key=lambda x: (-x[4], x[0]))[:4]


n = int(input())
participants = [list(map(lambda x: int(x) if x.isdigit() else x, input().split())) for _ in range(n)]

m = int(input())
olympiads = [input().strip() for _ in range(m)]


for olympiad in olympiads:
    selected_participants = select_participants(olympiad, participants)
    print(olympiad)
    for participant in selected_participants:
        print(participant[0])