def countTshirts(n, m, sizes, tshirts, winners):
    sizeIndexDict = {size: i for i, size in enumerate(sizes)}
    left = [[tshirts[i][j] for j in range(m)] for i in range(n)]
    need = [[0 for _ in range(m)] for _ in range(n)]

    for color, size in winners:
        size_idx = sizeIndexDict[size]
        if left[color - 1][size_idx] > 0:
            left[color - 1][size_idx] -= 1
        else:
            alt = False
            for alt_size in range(size_idx, m):
                if alt_size == size_idx:
                    for alt_color in range(n):
                        if left[alt_color][alt_size] > 0:
                            left[alt_color][alt_size] -= 1
                            alt = True
                            break
                else:
                    if left[color - 1][alt_size] > 0:
                        left[color - 1][alt_size] -= 1
                        alt = True
                        break
                    else:
                        for alt_color in range(n):
                            if left[alt_color][alt_size] > 0:
                                left[alt_color][alt_size] -= 1
                                alt = True
                                break

                if alt:
                    break

            if not alt:
                need[color - 1][size_idx] += 1

    return left, need



n, m = map(int, input().split())
sizes = input().split()
tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(input().split()) for _ in range(k)]
winners = [(int(color), size) for color, size in winners]

left, need = countTshirts(n, m, sizes, tshirts, winners)


for row in left:
    print(' '.join(map(str, row)))

for row in need:
    print(' '.join(map(str, row)))
