n = int(input())

olympiads = {
    'IOI': [],
    'CEOI': [],
    'EGOI': [],
    'EJOI': [],
    'BaltOI': [],
    'BalkOI': [],
    'JBOI': []
}

for i in range(n):
    info = input().split()
    id, gender, grade, age, score = int(info[0]), info[1], int(info[2]), int(info[3]), int(info[4])
    olympiads['IOI'].append((id, score))
    olympiads['CEOI'].append((id, score))
    olympiads['BaltOI'].append((id, score))
    if gender == 'female':
        olympiads['EGOI'].append((id, score))
    if age <= 15:
        olympiads['EJOI'].append((id, score))
    if grade < 11: 
        olympiads['BalkOI'].append((id, score))
    if grade < 11 and grade < 10:
        olympiads['JBOI'].append((id, score))

olympiads['IOI'].sort(key=lambda x: x[1], reverse=True)
olympiads['CEOI'].sort(key=lambda x: x[1], reverse=True)
olympiads['EGOI'].sort(key=lambda x: x[1], reverse=True)
olympiads['EJOI'].sort(key=lambda x: x[1], reverse=True)
olympiads['BaltOI'].sort(key=lambda x: x[1], reverse=True)
olympiads['BalkOI'].sort(key=lambda x: x[1], reverse=True)
olympiads['JBOI'].sort(key=lambda x: x[1], reverse=True)

m = int(input())

results = []
for j in range(m):
    rqstd = input().strip()
    team = []
    if rqstd in olympiads:
        if rqstd != 'BaltOI':
            participants = olympiads[rqstd][:4]
        else:
            participants = olympiads[rqstd][:6]
        team = list(map(lambda x: x[0], sorted(participants)))
    results.append((rqstd, team))

for k in results:
    print(k[0])
    for mbr in k[1]:
        print(mbr)
    print()
