n, m = map(int, input().split())

grid = [['.' for _ in range(m)] for _ in range(n)]

x1_row, x1_col = 0, 0
x2_row, x2_col = 0, m - 1

result = ""

reflected = False

for i in range(n * m):
    grid[x1_row][x1_col] = 'x'
    grid[x2_row][x2_col] = 'x'

    if x1_col in (m - 1, 0) and x2_col in (m - 1, 0) and i != 0:
        reflected = not reflected

    if not reflected:
        x1_col += 1
    else:
        x1_col -= 1

    x2_col = m - 1 - x1_col

    if not reflected:
        x2_col -= 1
    else:
        x2_col += 1

    if x1_col in (m, -1):
        x1_row += 1
        x1_col = 0 if not reflected else m - 1

    if x2_col in (m, -1):
        x2_row += 1
        x2_col = m - 1 if not reflected else 0

# Join the rows to form the result string
result = "\n".join("".join(row) for row in grid)

print(result)
