#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> colorWheels(n);

    for (int i = 0; i < n; ++i) {
        cin >> colorWheels[i];
    }

    sort(colorWheels.begin(), colorWheels.end(), greater<long long>());

    long long totalLength = 0;

    for (int i = 0; i < n; ++i) {
        totalLength += colorWheels[i] - 1;
    }

    totalLength += min(colorWheels[0] - 1, static_cast<long long>(m));

    cout << totalLength << endl;

    return 0;
}

