n, m = map(int, input().split())
sizes = input().split()
t_shirts = [[int(x) for x in input().split()] for _ in range(n)]
k = int(input())
requests = [input().split() for _ in range(k)]

leftover = [[0] * m for _ in range(n)]
to_order = [[0] * m for _ in range(n)]

size_map = {s: i for i, s in enumerate(sizes)}

for color, size in requests:
    color = int(color) - 1
    req_size = size_map[size]
    
    found = False
    for i in range(req_size, m):
        if t_shirts[color][i] > 0:
            t_shirts[color][i] -= 1
            found = True
            break
            
    if not found:
        to_order[color][req_size] += 1
        
for i in range(n):
    for j in range(m):
        leftover[i][j] = t_shirts[i][j]
        
for row in leftover:
    print(*row)
    
for row in to_order:
    print(*row)