#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;
    
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    
    std::vector<std::pair<int, int>> seqs;
    for (int i = 0; i < n; i++) {
        seqs.push_back(std::make_pair(a[i], 1));
    }
    
    for (int i = 0; i < m - n; i++) {
        std::sort(seqs.begin(), seqs.end(), [](const std::pair<int, int>& x, const std::pair<int, int>& y) {
            return x.first > y.first;
        });
        
        std::pair<int, int> max_seq = seqs[0];
        
        if (max_seq.first % 2 != 0) {
            seqs.push_back(std::make_pair(max_seq.first / 2, 1));
            seqs.push_back(std::make_pair(max_seq.first / 2, 1));
        } else {
            seqs.push_back(std::make_pair(max_seq.first / 2, 1));
            seqs.push_back(std::make_pair(max_seq.first - 1 - (max_seq.first / 2), 1));
        }
        
        seqs.erase(seqs.begin());
    }
    
    std::sort(seqs.begin(), seqs.end(), [](const std::pair<int, int>& x, const std::pair<int, int>& y) {
        return x.first > y.first;
    });
    
    std::cout << seqs[0].first << std::endl;
    
    return 0;
}