#include <iostream>
#include <vector>
using namespace std;
int fjr(int n, int m) {
    vector<vector<int>> d(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        d[i][0] = 1;
    }
    for (int j = 0; j < m; j++) {
        d[0][j] = 1;
    }
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < m; j++) {
            d[i][j] = d[i-1][j] + d[i][j-1];
        }
    }
    return d[n-1][m-1];
}

int max_p(int n, int m) {
    if (n == 1 || m == 1) {
        return 1;
    }

    return n * m - fjr(n, m);
}

int main() {
    int n, m;
    cin >> n >> m;
    cout << max_p(n, m) << endl;
    return 0;
}
