n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append((int(score), int(id), gender, int(grade), int(age)))

participants.sort(reverse=True)

m = int(input())
for _ in range(m):
    olympiad = input().strip()
    if olympiad == 'IOI':
        print('IOI')
        for _, id, _, _, _ in sorted(participants[:4], key=lambda x: x[1]):
            print(id)
    elif olympiad == 'CEOI':
        print('CEOI')
        for _, id, _, _, _ in sorted(participants[:4], key=lambda x: x[1]):
            print(id)
    elif olympiad == 'EGOI':
        print('EGOI')
        count = 0
        for _, id, gender, _, _ in sorted(participants, key=lambda x: x[1]):
            if gender == 'female':
                print(id)
                count += 1
            if count == 4:
                break
    elif olympiad == 'EJOI':
        print('EJOI')
        count = 0
        for _, id, _, _, age in sorted(participants, key=lambda x: x[1]):
            if age <= 15:
                print(id)
                count += 1
            if count == 4:
                break
    elif olympiad == 'BaltOI':
        print('BaltOI')
        for _, id, _, _, _ in sorted(participants[:6], key=lambda x: x[1]):
            print(id)
    elif olympiad == 'BalkOI':
        print('BalkOI')
        count = 0
        for _, id, _, grade, _ in sorted(participants, key=lambda x: x[1]):
            if grade != 11:
                print(id)
                count += 1
            if count == 4:
                break
    elif olympiad == 'JBOI':
        print('JBOI')
        count = 0
        for _, id, _, grade, _ in sorted(participants, key=lambda x: x[1]):
            if grade not in [10, 11]:
                print(id)
                count += 1
            if count == 4:
                break
