process.stdin.on('data', function (data) {
    const inputs = data.toString().split('\n').filter(i => !!i).map(i => i.replace(/(\r\n|\n|\r)/gm, ""));

    const amt = parseInt(inputs[0]);
    const participants = inputs.slice(1, amt + 1).map(i => { const { 0: id, 1: gender, 2: grade, 3: age, 4: score } = i.split(' '); return {id, gender, grade: parseInt(grade), age: parseInt(age), score: parseInt(score)}})
    const m = inputs[amt + 1];
    const olymps = inputs.slice(amt + 2);

    participants.sort((a, b) => b.score - a.score);

    const r = [];
    olymps.forEach(o => {
        const f = (filter, amount) => r.push({o, r: participants.filter(filter).slice(0, amount)});
        
        if (o == 'IOI') f(i => true, 4);
        else if (o == 'CEOI') f(i => true, 4);
        else if (o == 'EGOI') f(i => i.gender == 'female', 4);
        else if (o == 'EJOI') f(i => i.age <= 15, 4);
        else if (o == 'BaltOI') f(i => true, 6);
        else if (o == 'BalkOI') f(i => i.grade != 11, 4);
        else if (o == 'JBOI') f(i => i.grade != 11 && i.grade != 10, 4)
    })

    console.log(r.map(e => `${e.o}\n${e.r.map(p => p.id).join('\n')}\n`).join('\n'))
});