#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareByScore(const Participant& a, const Participant& b) {
    return a.score > b.score;
}

int main() {
    int n, m;
    cin >> n;
    vector<Participant> participants(n);

    for (int i = 0; i < n; i++) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareByScore);

    cin >> m;
    for (int i = 0; i < m; i++) {
        string olympiad;
        cin >> olympiad;

        vector<int> selectedParticipants;

        if (olympiad == "IOI" || olympiad == "CEOI") {
            for (int j = 0; j < min(4, n); j++) {
                selectedParticipants.push_back(participants[j].id);
            }
        } else if (olympiad == "EGOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; j++) {
                if (participants[j].gender == "female") {
                    selectedParticipants.push_back(participants[j].id);
                    count++;
                }
            }
        } else if (olympiad == "EJOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; j++) {
                if (participants[j].age <= 15) {
                    selectedParticipants.push_back(participants[j].id);
                    count++;
                }
            }
        } else if (olympiad == "BaltOI") {
            for (int j = 0; j < min(6, n); j++) {
                selectedParticipants.push_back(participants[j].id);
            }
        } else if (olympiad == "BalkOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; j++) {
                if (participants[j].grade != 11) {
                    selectedParticipants.push_back(participants[j].id);
                    count++;
                }
            }
        } else if (olympiad == "JBOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; j++) {
                if (participants[j].grade != 11 && participants[j].grade != 10) {
                    selectedParticipants.push_back(participants[j].id);
                    count++;
                }
            }
        }

        cout << olympiad << endl;
        for (int id : selectedParticipants) {
            cout << id << endl;
        }
    }

    return 0;
}