#include <bits/stdc++.h>
using namespace std;

int main() {
    vector<int> w(4), t(4);

    // Input weights
    for (int i = 0; i < 4; ++i) {
        cin >> w[i];
    }

    // Input box numbers
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
    }

    // Check if it is optimal to not change anything
    if (w[t[0] - 1] + w[t[1] - 1] == w[t[2] - 1] + w[t[3] - 1] || w[t[0] - 1] + w[t[2] - 1] == w[t[1] - 1] + w[t[3] - 1] || w[t[0] - 1] + w[t[3] - 1] == w[t[1] - 1] + w[t[2] - 1]) {
        cout << -1 << endl;
        return 0;
    }

    // Iterate through all possible moves
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            if (i != j) {
                // Try moving item i to box j
                int newWeight1 = w[t[i] - 1] + w[t[j] - 1];
                int newWeight2 = w[t[0] - 1] + w[t[1] - 1] + w[t[2] - 1] + w[t[3] - 1] - newWeight1;

                // Check if the weights become more balanced
                if (abs(newWeight1 - newWeight2) < abs(w[t[i] - 1] - w[t[j] - 1])) {
                    cout << i + 1 << endl;
                    return 0;
                }
            }
        }
    }

    // If no move improves the balance
    cout << -1 << endl;

    return 0;
}
