weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

initial_box_weights = [0, 0]
for i in range(4):
    initial_box_weights[boxes[i] - 1] += weights[i]

min_max_weight = max(initial_box_weights)
move_item = -1

for i in range(4):
    current_box = boxes[i] - 1
    current_weight = initial_box_weights[current_box] - weights[i]
    other_weight = initial_box_weights[1 - current_box] + weights[i]
    max_weight_after_move = max(current_weight, other_weight)

    if max_weight_after_move < min_max_weight:
        min_max_weight = max_weight_after_move
        move_item = i + 1

print(move_item)   