#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> needed(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int colorIndex;
        char size;
        cin >> colorIndex >> size;

        int sizeIndex = find(sizes.begin(), sizes.end(), string(1, size)) - sizes.begin();
        
        if (available[colorIndex - 1][sizeIndex] > 0) {
            available[colorIndex - 1][sizeIndex]--;
        } else {
            int altSizeIndex = find(available[colorIndex - 1].begin(), available[colorIndex - 1].end(), 0) - available[colorIndex - 1].begin();
            
            if (altSizeIndex == m) {
                altSizeIndex = find(available[colorIndex - 1].begin(), available[colorIndex - 1].end(), *min_element(available[colorIndex - 1].begin(), available[colorIndex - 1].end())) - available[colorIndex - 1].begin();
            }

            remaining[colorIndex - 1][altSizeIndex]++;
        }

        needed[colorIndex - 1][sizeIndex]++;
    }

    // Вивід залишків
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    // Вивід футболок для замовлення
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << needed[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
