#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;
};

bool compare(Participant a, Participant b) {
    return a.score > b.score;
}

int main() {
    int n;
    cin >> n;
    vector<Participant> participants(n);
    for(int i = 0; i < n; i++) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }
    sort(participants.begin(), participants.end(), compare);
    int m;
    cin >> m;
    while(m--) {
        string olympiad;
        cin >> olympiad;
        cout << olympiad << ": ";
        vector<int> team;
        if(olympiad == "IOI" || olympiad == "CEOI") {
            for(int i = 0; i < min(4, n); i++) {
                team.push_back(participants[i].id);
            }
        } else if(olympiad == "EGOI") {
            for(int i = 0; i < n && team.size() < 4; i++) {
                if(participants[i].gender == "female") {
                    team.push_back(participants[i].id);
                }
            }
        } else if(olympiad == "EJOI") {
            for(int i = 0; i < n && team.size() < 4; i++) {
                if(participants[i].age <= 15) {
                    team.push_back(participants[i].id);
                }
            }
        } else if(olympiad == "BaltOI") {
            for(int i = 0; i < min(6, n); i++) {
                team.push_back(participants[i].id);
            }
        } else if(olympiad == "BalkOI") {
            for(int i = 0; i < n && team.size() < 4; i++) {
                if(participants[i].grade != 11) {
                    team.push_back(participants[i].id);
                }
            }
        } else if(olympiad == "JBOI") {
            for(int i = 0; i < n && team.size() < 4; i++) {
                if(participants[i].grade != 10 && participants[i].grade != 11) {
                    team.push_back(participants[i].id);
                }
            }
        }
        sort(team.begin(), team.end());
        for(int id : team) {
            cout << id << " ";
        }
        cout << "\n";
    }
    return 0;
}
