def flowerbed(n, m):
    # Initialize a variable to keep track of the total number of passes
    total_passes = 0
    
    # While there are still cells to be visited, increment the total number of passes
    while n * m > 0:
        total_passes += 1
        
        # Decrement the number of flowers that can be visited during the next pass
        n -= total_passes
        m -= total_passes
        
    # Return the total number of passes
    return total_passes

# Read the input
n = int(input())
m = int(input())

# Calculate and print the answer
print(flowerbed(n, m))