def min_max_weight(w, t):
    # Initial values
    current_max = max(w[i] for i in range(4) if t[i] == 1) + max(w[i] for i in range(4) if t[i] == 2)
    p = -1

    # Check all possible moves
    for i in range(4):
        next_max = max(current_max - w[i] + (w[i] if t[i] == 1 else 0), current_max - w[i] + (w[i] if t[i] == 2 else 0))
        if next_max < current_max:
            current_max = next_max
            p = i + 1

    return p

# Input
w = [5, 2, 4, 3]
t = [1, 2, 2, 1]

# Output
print(min_max_weight(w, t))