def calculate_total_weight(weights, boxes, item_to_move):
    current_weights = [0, 0]
    for w, b, i in zip(weights, boxes, item_to_move):
        if i == b:
            current_weights[b - 1] += w
        else:
            current_weights[1 - (b - 1)] += w
    return current_weights

# Example Input
weights = [4, 2, 3, 7]
boxes = [2, 1, 1, 2]
item_to_move = [2, 4, 3]

# Calculate the total weight of each box after moving the items
result = calculate_total_weight(weights, boxes, item_to_move)

# Output the result
print(result)