int main() {
  // Get the weights of the four items.
  vector<int> weights = {5, 2, 4, 3};

  // Get the box numbers in which the corresponding items are located.
  vector<int> boxes = {1, 2, 2, 1};

  // Calculate the maximum weight of a box.
  int maxWeight = max(box1Weight, box2Weight);

  // Find the item that needs to be moved to another box.
  int itemToMove = -1;
  for (int i = 0; i < 4; i++) {
    if (boxes[i] == 1 && box2Weight - weights[i] < maxWeight) {
      itemToMove = i + 1;
      break;
    } else if (boxes[i] == 2 && box1Weight - weights[i] < maxWeight) {
      itemToMove = i + 1;
      break;
    }
  }

  // If it is optimal to not change anything, then print a single integer "-1".
  if (itemToMove == -1) {
    cout << -1 << endl;
  } else {
    // Print the number of the item that needs to be moved to another box.
    cout << itemToMove << endl;
  }

  return 0;
}
