def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Fill in the upper-left quarter of the ornament
    for i in range(n // 2):
        ornament[i][i] = 'x'
        ornament[i][m - i - 1] = 'x'

    # Mirror the upper-left quarter to the lower-left quarter
    for i in range(n // 2):
        ornament[n - i - 1][i] = 'x'
        ornament[n - i - 1][m - i - 1] = 'x'

    return ornament

# Input
n, m = map(int, input().split())

# Generate ornament
ornament = generate_ornament(n, m)

# Output
for row in ornament:
    print("".join(row))
