def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m) // 2):
        ornament[i][i] = 'x'
        ornament[i][m - i - 1] = 'x'
        ornament[n - i - 1][i] = 'x'
        ornament[n - i - 1][m - i - 1] = 'x'

    return ornament


def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))


# Input
n, m = map(int, input().split())

# Generate and Print Ornament
ornament = generate_ornament(n, m)
print_ornament(ornament)
