def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Draw the upper left ray
    for i in range(n):
        ornament[i][0] = 'x'
        if i > 0:
            ornament[i - 1][1] = 'x'

    # Draw the upper right ray
    for i in range(n):
        ornament[i][m - 1] = 'x'
        if i > 0:
            ornament[i - 1][m - 2] = 'x'

    # Print the ornament
    for row in ornament:
        print(''.join(row))

# Example Input
n, m = 21, 12

# Generate and print the ornament
generate_ornament(n, m)
