def create_ornament(n, m):
    ornament = []

    for i in range(n):
        row = ['.'] * m

        if i == 0 or i == n - 1:
            # The first and last row have 'x' at the corners
            row[0] = 'x'
            row[m - 1] = 'x'
        elif i < m - 1:
            # For other rows, create the reflection pattern
            row[i] = 'x'
            row[m - i - 1] = 'x'

        ornament.append(''.join(row))

    return ornament

# Reading input from the user
n, m = map(int, input().split())

# Generating and printing the ornament
ornament = create_ornament(n, m)
for row in ornament:
    print(row)
