def color_wheels(n, m, a):
    # Sorting the numbers in ascending order
    a.sort()

    # Finding the largest number
    largest = a[-1]

    # Initializing the count of the largest number
    count = a.count(largest)

    # Finding the next largest number
    next_largest = a[-2] if len(a) > 1 else -1

    # Initializing the count of the next largest number
    next_count = a.count(next_largest)

    # Finding the second next largest number
    second_next_largest = a[-3] if len(a) > 2 else -1

    # Initializing the count of the second next largest number
    second_next_count = a.count(second_next_largest)

    # Updating the counts based on the given number of marked colors
    while m > 0:
        if count == 0:
            break

        if count >= m:
            count -= m
            m = 0
        else:
            m -= count
            count = 0

        if count == 0 and next_count > 0:
            if next_count >= m:
                next_count -= m
                m = 0
            else:
                m -= next_count
                next_count = 0

        if count == 0 and next_count == 0 and second_next_count > 0:
            if second_next_count >= m:
                second_next_count -= m
                m = 0
            else:
                m -= second_next_count
                second_next_count = 0

    # Calculating the maximum length of the sequence of unmarked colors
    max_len = largest * count + next_largest * next_count + second_next_largest * second_next_count

    return max_len

# Reading input from the user
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Calculating the maximum length of the sequence of unmarked colors
result = color_wheels(n, m, a)

# Printing the result
print(result)