def choose_colors(n, m, a):
    total_colors = sum(a) + n
    used_colors = [0] * n
    longest_sequence = 0

    for _ in range(m):
        for i in range(n):
            used_colors[i] += 1
            if used_colors[i] <= a[i]:
                longest_sequence += 1
                break
            else:
                used_colors[i] -= 1
                longest_sequence -= a[i]
        else:
            return -1

    return longest_sequence


# Example usage:

n = 1
m = 1
a = [11]

print(choose_colors(n, m, a))  # Output: 11
