function calculatePasses(n, m) {
    if (n === 1 || m === 1) {
        return 1; // For a single row or column, only one pass is needed
    }

    return n * m - (n + m - 2); // Formula for the maximum number of passes
}

const readline = require('readline');
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout
});

let n, m;
rl.question('', (nInput) => {
    n = parseInt(nInput);
    rl.question('', (mInput) => {
        m = parseInt(mInput);
        
        const result = calculatePasses(n, m);
        console.log(result);
        
        rl.close();
    });
});

