#include <iostream>

using namespace std;

bool isSameBitulianDate(int d1, int m1, int d2, int m2) {
    int bitulianMonths[] = {0, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24};
    int bitulianDays[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

    // Calculate the Bitulian date for the first given date
    for (int i = 1; i < m1; ++i) {
        bitulianDays[i] = bitulianDays[i - 1] + 30;
    }
    bitulianDays[m1] += d1;

    // Calculate the Bitulian date for the second given date
    int bitulianDate1 = bitulianDays[m1];

    for (int i = 1; i < m2; ++i) {
        bitulianDays[i] = bitulianDays[i - 1] + 30;
    }
    bitulianDays[m2] += d2;

    int bitulianDate2 = bitulianDays[m2];

    return (bitulianDate1 == bitulianDate2);
}

int main() {
    int d1, m1, d2, m2;
    cin >> d1 >> m1 >> d2 >> m2;

    if (isSameBitulianDate(d1, m1, d2, m2)) {
        cout << "Same birthday!" << endl;
    } else {
        cout << "Not the same" << endl;
    }

    return 0;
}