// function generateOrnament(n, m) {
//   let pattern = ''
//   for (let i = 0; i < n; i++) {
//     let row = ''
//     for (let j = 0; j < m; j++) {
//       if ((i + j) % 4 === 0 || (i - j) % 4 === 0) {
//         row += 'x'
//       } else {
//         row += '.'
//       }
//     }
//     pattern += row + '\n'
//   }
//   return pattern
// }
// console.log(generateOrnament(6, 4))
// console.log(generateOrnament(12, 5))
// console.log(generateOrnament(21, 12))

function generateOrnament(n, m) {
    const result = [];
    for (let i = 0; i < n; i++) {
        let row = '';
        for (let j = 0; j < m; j++) {
            if ((i + j) % 2 === 0) {
                if (i % 2 === 0) {
                    row += 'x';
                } else {
                    row += '.';
                }
            } else {
                if (i % 2 === 0) {
                    row += '.';
                } else {
                    row += 'x';
                }
            }
        }
        result.push(row);
    }
    return result.join('\n');
}

const readline = require('readline');
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout
});

let n, m;
rl.question('', (input) => {
    [n, m] = input.split(' ').map(Number);
    const result = generateOrnament(n, m);
    console.log(result);
    rl.close();
});

