def generate_ornament(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if (i + j) % 2 == 0 and (i % 2 == 0 or j % 2 == 0):
                pattern[i][j] = 'x'

    return '\n'.join([''.join(row) for row in pattern])

n, m = map(int, input().split())
print(generate_ornament(n, m))


