#include <iostream>
#include <vector>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    std::vector<int> box_weights = {0, 0};

    for (int i = 0; i < 4; ++i) {
        box_weights[boxes[i] - 1] += weights[i];
    }

    int max_weight = std::max(box_weights[0], box_weights[1]);
    int item_to_move = -1;

    for (int i = 0; i < 4; ++i) {
        int from_box = boxes[i] - 1;
        int to_box = 1 - from_box;

        int current_weight = box_weights[from_box] - weights[i] + box_weights[to_box];

        if (current_weight < max_weight) {
            max_weight = current_weight;
            item_to_move = i + 1;
        }
    }

    std::cout << item_to_move << std::endl;

    return 0;
}
