n, m = map(int, input().split())

sizes = input().split()

available = [list(map(int, input().split())) for _ in range(n)]

k = int(input())

required = [[0] * m for _ in range(n)]
for _ in range(k):
    c, s = input().split()
    c = int(c)
    size_index = sizes.index(s)
    required[c - 1][size_index] += 1

remaining = [row[:] for row in available]

surplus = [[0] * m for _ in range(n)]
needed = [[0] * m for _ in range(n)]

for i in range(n):
    for j in range(m):
        while required[i][j] > 0 and available[i][j] > 0:
            required[i][j] -= 1
            available[i][j] -= 1

        while required[i][j] > 0 and available[i][j] == 0:
            other_color = next((k for k in range(n) if remaining[k][j] > 0), -1)

            if other_color != -1:
                required[i][j] -= 1
                remaining[other_color][j] -= 1
                surplus[other_color][j] += 1
            else:
                larger_size = j
                while larger_size < m and remaining[i][larger_size] == 0:
                    larger_size += 1

                if larger_size < m:
                    required[i][j] -= 1
                    remaining[i][larger_size] -= 1
                    needed[i][larger_size] += 1
                else:
                    smallest_color = next((k for k in range(n) if remaining[k][0] > 0), -1)

                    required[i][j] -= 1
                    remaining[smallest_color][0] -= 1
                    needed[smallest_color][0] += 1

for row in surplus:
    print(*row)

for row in needed:
    print(*row)
