# birthday_comparison.py

from datetime import datetime, timedelta

def parse_bitulian_date(date_str):
    # Парсимо дату за Бітуліанським календарем
    return datetime.strptime(date_str, "%d %B %Y")

def compare_birthdays(miss_m_date, mister_n_date):
    # Порівнюємо дати народження
    return miss_m_date == mister_n_date

def main():
    # Вхідні дані
    miss_m_date_str = input("Введіть дату народження Міс M за Бітуліанським календарем (формат: день місяця повний_місяць рік): ")
    mister_n_date_str = input("Введіть дату народження Містера N за Байтуліанським календарем (формат: день місяця повний_місяць рік): ")

    # Парсимо дати
    miss_m_date = parse_bitulian_date(miss_m_date_str)
    mister_n_date = parse_bitulian_date(mister_n_date_str)

    # Порівнюємо дати та виводимо результат
    result = compare_birthdays(miss_m_date, mister_n_date)
    if result:
        print("Міс M та Містер N народилися в один день!")
    else:
        print("Міс M та Містер N не народилися в один день.")

if __name__ == "__main__":
    main()