def generate_ornament(n, m):
    ornament = []
    for i in range(n):
        row = ""
        for j in range(m):
            if (i + j) % 2 == 0:
                row += "x"
            else:
                row += "."
        ornament.append(row)

    for i in range(1, n, 2):
        ornament[i] = ornament[i][::-1]

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(row)

# Input
n, m = map(int, input().split())

# Generate and print the ornament
ornament = generate_ornament(n, m)
print_ornament(ornament)
