    #include <bits/stdc++.h>
using namespace std;

int numberSize(vector<string> v, string search)
{
    for (size_t i = 0; i < v.size(); i++)
    {
        if (search == v[i])
        {
            return i;
        }
    }
}

void mayBeSize(vector<int*>& color, int numSize, int afteMaxRow)
{
    for (size_t i = 0; i < afteMaxRow; i++)
    {
        if (color[i][numSize] != 0)
        {
            color[i][numSize]--;
        }
    }
}   

int mayBeSizeBool(vector<int*>& color, int numSize, int afteMaxRow)
{
    for (size_t i = 0; i < afteMaxRow; i++)
    {
        if (color[i][numSize] != 0)
        {
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
cin >> n >> m;
vector<string> sizes(m);
for (size_t i = 0; i < sizes.size(); i++)
{
    cin >> sizes[i];
}
vector<int*> color(n);
for (size_t i = 0; i < color.size(); i++)
{
    color[i] = new int[m];
    for (size_t j = 0; j < m; j++)
    {
        cin >> color[i][j];
    }
}

vector<int*> shop(n);
for (size_t i = 0; i < shop.size(); i++)
{
    shop[i] = new int[m];
    for (size_t j = 0; j < m; j++)
    {
        shop[i][j] = 0;
    }
}

cin >> k;
vector<pair<int, string>>winners(k);
for (size_t i = 0; i < winners.size(); i++)
{
   cin >> winners[i].first;
   cin >> winners[i].second;
}

for (size_t i = 0; i < winners.size(); i++)
{
    int row = winners[i].first - 1;
    bool help = true;
    int tmp = numberSize(sizes,winners[i].second);
    if (color[row][tmp] != 0)
    {
        color[row][tmp]--;
        help = false;
    }
    else if (mayBeSizeBool(color, tmp, n))
    {
        mayBeSize(color, tmp, n);
        help = false;
    }
    else
    {
        for (size_t j = tmp; j < m; j++)
        {
            if (color[row][j] != 0)
            {
                color[row][j]--;
                help = false;
                break;
            }

            if (mayBeSizeBool(color, j, n))
            {
                mayBeSize(color, j, n);
                help = false;
                break;
            }
        }
    }
    if (help)
    {
        shop[row][tmp] += 1;
    }

}


for (size_t i = 0; i < n; i++)
{
    for (size_t j = 0; j < m; j++)
    {
        cout << color[i][j] << " ";
    }
    cout << endl;
}
for (size_t i = 0; i < n; i++)
{
    for (size_t j = 0; j < m; j++)
    {
        cout << shop[i][j] << " ";
    }
    cout << endl;
}
}
