#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = int;

struct olym{
	ll id, grade, age, score;
	string gender;
};

bool comp(olym a, olym b) {
	return a.score > b.score;
}

bool comp2(ll a, ll b) {
	return a < b;
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0); cout.tie(0);
	ll n, m, timer = 0;
	string olymptype;
	cin >> n;
	vector<olym> olymp(n);
	vector<ll> ans;
	for (ll i = 0; i < n; i++) {
		cin >> olymp[i].id >> olymp[i].gender >> olymp[i].grade >> olymp[i].age >> olymp[i].score;
	}
	sort(olymp.begin(), olymp.end(), comp);
	cin >> m;
	for (ll i = 0; i < m; i++) {
		ans.clear();
		timer = 0;
		cin >> olymptype;
		cout << '\n' << olymptype << '\n';
		if (olymptype == "IOI" || olymptype == "CEOI") {
			for (ll i = 0; i < 4; i++) {
				ans.push_back(olymp[i].id);
			}
		}
		else if (olymptype == "EGOI") {
			for (ll i = 0; i < olymp.size() && timer < 4; i++) {
				if (olymp[i].gender == "female") {
					ans.push_back(olymp[i].id);
					timer++;
				}
			}
		}
		else if (olymptype == "EJOI") {
			for (ll i = 0; i < olymp.size() && timer < 4; i++) {
				if (olymp[i].age < 15) {
					ans.push_back(olymp[i].id);
					timer++;
				}
			}
		}
		else if (olymptype == "BaltOI") {
			for (ll i = 0; i < 6; i++) {
				ans.push_back(olymp[i].id);
			}
		}
		else if (olymptype == "BalkOI") {
			for (ll i = 0; i < olymp.size() && timer < 4; i++) {
				if (olymp[i].grade < 11) {
					ans.push_back(olymp[i].id);
					timer++;
				}
			}
		}
		else if (olymptype == "JBOI") {
			for (ll i = 0; i < olymp.size() && timer < 4; i++) {
				if (olymp[i].grade < 10) {
					ans.push_back(olymp[i].id);
					timer++;
				}
			}
		}
		sort(ans.begin(), ans.end(), comp2);
		for (ll i = 0; i < ans.size(); i++) {
			cout << ans[i] << '\n';
		}
	}
}