#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

bool comp(ll a, ll b) {
	return a < b;
}

ll binarsearch(vector<ll> a, ll sel) {
	if (!a.empty()) {
		if (a[0] > sel) {
			return 0;
		}
		ll l = 1, r = a.size(), m;
		while (l < r - 1) {
			m = (l + r) / 2;
			if (a[m] < sel) {
				l = m;
			}
			else if (a[m] > sel) {
				r = m;
			}
			else {
				return m;
			}
		}
		return l;
	}
	else {
		return 0;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0); cout.tie(0);
	ll m, element, elementpush, pos;
	short n;
	cin >> n >> m;
	vector<ll> a(n);
	for (short i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ll>::iterator it;
	sort(a.begin(), a.end(), comp);
	for (ll i = 1; i < m; i++) {
		element = a[a.size() - 1];
		a.pop_back();
		elementpush = (element - 1) / 2;
		if (element % 2 != 0) {
			pos = binarsearch(a, elementpush);
			it = a.begin();
			for (ll i = 0; i < pos; i++) {
				it++;
			}
			a.insert(it, elementpush);
			it = a.begin();
			for (ll i = 0; i < pos; i++) {
				it++;
			}
			a.insert(it, elementpush);
		}
		else {
			it = a.begin();
			pos = binarsearch(a, elementpush);
			for (ll i = 0; i < pos; i++) {
				it++;
			}
			a.insert(it, elementpush);
			it = a.begin();
			pos = binarsearch(a, element - 1 - elementpush);
			for (ll i = 0; i < pos; i++) {
				it++;
			}
			a.insert(it, element - 1 - elementpush);
		}
	}
	sort(a.begin(), a.end());
	cout << a[a.size() - 1];
}