participants_required = {
    'IOI': 4,
    'CEOI': 4,
    'EGOI': 4,
    'EJOI': 4,
    'BaltOI': 6,
    'BalkOI': 4,
    'JBOI': 4
}

for olympiad in olympiads:
    criteria = None

    if olympiad == 'IOI' or olympiad == 'CEOI':
        criteria = lambda p: True
    elif olympiad == 'EGOI':
        criteria = lambda p: p['gender'] == 'female'
    elif olympiad == 'EJOI':
        criteria = lambda p: p['age'] <= 15
    elif olympiad == 'BaltOI':
        criteria = lambda p: True
    elif olympiad == 'BalkOI':
        criteria = lambda p: p['grade'] != 11
    elif olympiad == 'JBOI':
        criteria = lambda p: p['grade'] not in {10, 11}

    selected_participants[olympiad] = [p['id'] for p in participants if criteria(p)][:participants_required[olympiad]]

for olympiad in olympiads:
    selected_participants[olympiad].sort()

for olympiad in olympiads:
    print(olympiad)
    for participant_id in selected_participants[olympiad]:
        print(participant_id)