def find_max_length(n, m, a):
    total_unmarked = sum(a) - n
    max_a = max(a)

    if total_unmarked <= m:
        return max_a

    left = 0
    right = max_a
    while left < right:
        mid = (left + right + 1) // 2
        count = sum(max(0, x - mid) for x in a)
        if count >= m:
            left = mid
        else:
            right = mid - 1

    return left

# Input parsing
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Call the function with input values
result = find_max_length(n, m, a)

# Output the result
print(result)