#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    long long max_length = 0;
    for (int i = 0; i < m; i++) {
        int max_subarray_length = 0;
        int current_subarray_length = 0;

        for (int j = 0; j < n; j++) {
            if (a[j] > 0) {
                current_subarray_length++;
            } else {
                max_subarray_length = max(max_subarray_length, current_subarray_length);
                current_subarray_length = 0;
            }
            a[j]--;
        }

        max_subarray_length = max(max_subarray_length, current_subarray_length);
        max_length += max_subarray_length;
    }

    cout << max_length << endl;

    return 0;
}
