# Read input
n, m = map(int, input().split())
sizes = input().split()
stock = [list(map(int, input().split())) for _ in range(n)]
winners_count = int(input())
winners = [tuple(input().split()) for _ in range(winners_count)]

remaining_stock = [row[:] for row in stock]
needed_stock = [[0] * m for _ in range(n)]

for color, size in winners:
    color = int(color)
    size_index = sizes.index(size)
    
    if remaining_stock[color - 1][size_index] > 0:
        remaining_stock[color - 1][size_index] -= 1
    else:
        alt_color = next((c for c in range(n) if remaining_stock[c][size_index] > 0), None)
        if alt_color is not None:
            remaining_stock[alt_color][size_index] -= 1
        else:
            larger_size = next((i for i in range(size_index + 1, m) if remaining_stock[color - 1][i] > 0), None)
            if larger_size is not None:
                remaining_stock[color - 1][larger_size] -= 1
            else:
                larger_size = next((i for i in range(size_index + 1, m) if any(remaining_stock[c][i] > 0 for c in range(n))), None)
                remaining_stock[alt_color][larger_size] -= 1

for row in remaining_stock:
    print(*row)

for color, size in winners:
    color = int(color)
    size_index = sizes.index(size)
    needed_stock[color - 1][size_index] += 1

for row in needed_stock:
    print(*row)