def convert_to_days(d, m):
    return d + (m - 1) * 30

try:
    d1, m1 = map(int, input().split())
    if not (1 <= d1 <= 30) or not (1 <= m1 <= 12):
        raise ValueError("Некоректні дані для першої дати")

    d2, m2 = map(int, input().split())
    if not (1 <= d2 <= 30) or not (1 <= m2 <= 12):
        raise ValueError("Некоректні дані для другої дати")

except ValueError as e:
    print(f"Помилка введення: {e}")
    exit()

to_d_1 = convert_to_days(d1, m1)
to_d_2 = convert_to_days(d2, m2)

difference = to_d_2 - to_d_1

if difference % 13 == 0:
    print("Same birthday!")
else:
    print("Not the same")
