# Функція для обчислення максимальної ваги коробки
def max_box_weight(weights, boxes):
    return max(sum(weights[i] for i in range(4) if boxes[i] == box) for box in range(1, 3))

# Вхідні дані
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Обчислюємо початкову максимальну вагу коробок
max_initial_weight = max_box_weight(weights, boxes)

# Шукаємо оптимальний варіант переміщення
for i in range(4):
    for j in range(1, 3):
        if boxes[i] != j:
            new_boxes = boxes.copy()
            new_boxes[i] = j
            new_max_weight = max_box_weight(weights, new_boxes)
            if new_max_weight < max_initial_weight:
                print(i + 1)
                exit()

# Якщо жоден варіант не зменшує максимальну вагу коробки, виводимо -1
print(-1)
