def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if i == 0 or j == 0:
                ornament[i][j] = 'x'
            elif (i + j) % 2 == 1:
                ornament[i][j] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

# Зчитуємо вхідні дані
n, m = map(int, input().split())

# Створюємо та виводимо орнамент
ornament = create_ornament(n, m)
print_ornament(ornament)
