def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Заповнюємо головну діагональ
    for i in range(min(n, m)):
        ornament[i][i] = '*'

    # Заповнюємо бічні промені
    for i in range(n):
        ornament[i][0] = '*'
        ornament[i][m - 1] = '*'

    for j in range(m):
        ornament[0][j] = '*'
        ornament[n - 1][j] = '*'

    return ornament


def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))


# Зчитуємо вхідні дані
n, m = map(int, input().split())

# Створюємо та виводимо орнамент
ornament = create_ornament(n, m)
print_ornament(ornament)
