def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Loop through the grid and apply the ornament pattern
    for i in range(n):
        for j in range(m):
            if i % 2 == 0 and (j == 0 or j == m - 1):
                ornament[i][j] = 'x'
            elif i % 2 == 1 and (j == 1 or j == m - 2):
                ornament[i][j] = 'x'

    # Display the ornament
    for row in ornament:
        print(''.join(row))

# Taking input for height and width
height, width = map(int, input().split())

# Call the function with provided height and width
create_ornament(height, width)