def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Fill the ornament with the ray pattern
    for i in range(0, n, 2):
        ornament[i][0] = ornament[i][-1] = 'x'
    for i in range(1, n, 4):
        ornament[i][1] = ornament[i][-2] = 'x'

    # Display the ornament
    for row in ornament:
        print(''.join(row))

# Taking input for height and width
height, width = map(int, input().split())

# Call the function with provided height and width
create_ornament(height, width)
