n, m = map(int, input().split())
wheels = list(map(int, input().split()))

def count_unmarked_colors(wheel):
    max_gap = 0
    current_gap = 0
    wheel_length = wheel[0]
    for i in range(1, len(wheel)):
        if wheel[i] - wheel[i - 1] > 1:
            current_gap = wheel[i] - wheel[i - 1] - 1
            max_gap = max(max_gap, current_gap)
    return max(max_gap, wheel_length - wheel[-1])

def remaining_unmarked_colors(m, wheels):
    wheels.sort()
    while m > 0:
        max_unmarked = max(wheels, key=count_unmarked_colors)
        wheel_length = max_unmarked[0]
        mid = wheel_length // 2
        if wheel_length % 2 == 1:
            m -= 1
            max_unmarked.append(max_unmarked.pop(1) + mid)
        else:
            m -= 1
            max_unmarked.append(max_unmarked.pop(1) + mid - 1)
        max_unmarked.sort()
    return max(count_unmarked_colors(wheel) for wheel in wheels)

result = remaining_unmarked_colors(m, [[w, 1] for w in wheels])
print(result)
