
def process_gifts(n, m, sizes, stock, k, orders):
    remaining_stock = [row.copy() for row in stock]
    additional_orders = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = int(orders[i][0]) - 1, sizes.index(orders[i][1])

        if remaining_stock[color][size] > 0:
            remaining_stock[color][size] -= 1
        else:
            for new_size in range(size + 1, m):
                if any(remaining_stock[j][new_size] > 0 for j in range(n)):
                    for j in range(n):
                        if remaining_stock[j][new_size] > 0:
                            remaining_stock[j][new_size] -= 1
                            additional_orders[j][new_size] += 1
                            break
                    break
            else:
                for new_color in range(n):
                    if any(remaining_stock[new_color][j] > 0 for j in range(m)):
                        for j in range(m):
                            if remaining_stock[new_color][j] > 0:
                                remaining_stock[new_color][j] -= 1
                                additional_orders[new_color][j] += 1
                                break
                        break
                else:
                    additional_orders[color][size] += 1

    return remaining_stock, additional_orders

# Вхідні дані для тестування
n, m = 2, 3
sizes = ['S', 'M', 'XL']
stock = [[1, 3, 0], [3, 0, 3]]
k = 9
orders = [['1', 'S'], ['2', 'XL'], ['1', 'M'], ['2', 'XL'], ['1', 'M'], ['2', 'M'], ['1', 'M'], ['2', 'S'], ['1', 'XL']]

# Обробка і вивід результатів
remaining_stock, additional_orders = process_gifts(n, m, sizes, stock, k, orders)
for row in remaining_stock:
    print(*row)
for row in additional_orders:
    print(*row)