#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long maxSubsegmentLength = 0;

    for (long long i = 0; i < n; ++i) {
        maxSubsegmentLength = max(maxSubsegmentLength, a[i]);
    }

    sort(a.begin(), a.end(), greater<long long>());

    for (long long i = 0; i < m; ++i) {
        maxSubsegmentLength = max(maxSubsegmentLength, a[i] + a[i + 1] - 1);
        i++;
    }

    cout << maxSubsegmentLength << endl;

    return 0;
}