#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sort(a.begin(), a.end(), greater<long long>());

    long long maxSubsegmentLength = a[0] - 1;

    for (long long i = 1; i < n; ++i) {
        maxSubsegmentLength = max(maxSubsegmentLength, a[i] - 1);
    }

    cout << maxSubsegmentLength << endl;

    return 0;
}
