#include <iostream>
#include <algorithm>

// Function to calculate the greatest common divisor
int gcd(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

// Function to calculate the least common multiple
int lcm(int a, int b) {
    return (a * b) / gcd(a, b);
}

// Function to calculate the maximum passes
int max_passes(int n, int m) {
    return lcm(n, m) / n;
}

int main() {
    // Input
    int n, m;
    std::cin >> n >> m;

    // Output
    std::cout << max_passes(n, m) << std::endl;

    return 0;
}
