
#include <iostream>
#include <string>
#include<vector>
#include <queue>
#include<algorithm>
using namespace std;

struct comp {
    bool operator()(vector<int>& a, vector<int>& b) const{
        if (a[4] == b[4]) {
            return a[0] < b[0];
        }
        return a[4] < b[4];
    }
};

vector<int> form(string s) {
    vector<int> out;
    int n = stoi(s.substr(0, s.find(" ")));
    out.push_back(n);
    s = s.erase(0, s.find(" ") + 1);
    if (s[0] == 'f') {
        out.push_back(1);
    }
    else {
        out.push_back(0);
    }
    s = s.erase(0, s.find(" ") + 1);
    n = stoi(s.substr(0, s.find(" ")));
    out.push_back(n);
    s = s.erase(0, s.find(" ") + 1);
    n = stoi(s.substr(0, s.find(" ")));
    out.push_back(n);
    s = s.erase(0, s.find(" ") + 1);
    n = stoi(s.substr(0, s.size()));
    out.push_back(n);
    return out;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    cin.ignore();
    priority_queue<vector<int>, vector<vector<int>>, comp> persons;
    vector<bool> olympiads(7);
    string s;
    for (int i = 0; i < n; i++) {
        getline(cin, s);
        vector<int> t = form(s);
        persons.push(t);
    }
    cin >> n;
    string t;
    for (int i = 0; i < n; i++) {
        cin >> t;
        if (t == "IOI") {
            olympiads[0] = true;
        }
        else if (t == "CEOI") {
            olympiads[1] = true;
        }
        else if (t == "EGOI") {
            olympiads[2] = true;
        }
        else if (t == "EJOI") {
            olympiads[3] = true;
        }
        else if (t == "BaltOI") {
            olympiads[4] = true;
        }
        else if (t == "BalkOI") {
            olympiads[5] = true;
        }
        else if (t == "JBOI") {
            olympiads[6] = true;
        }
    }

    vector<vector<int>> out(7);
    while (persons.size()) {
        vector<int> cur = persons.top();
        persons.pop();
        if (olympiads[0]) {
            if (out[0].size() != 4) {
                out[0].push_back(cur[0]);
            }
        }
        if (olympiads[1]) {
            if (out[1].size() != 4) {
                out[1].push_back(cur[0]);
            }
        }
        if (olympiads[2]) {
            if (out[2].size() != 4) {
                if (cur[1] == 1) {
                    out[2].push_back(cur[0]);
                }
            }
        }
        if (olympiads[3]) {
            if (out[3].size() != 4) {
                if (cur[3] <= 15) {
                    out[3].push_back(cur[0]);
                }
            }
        }
        if (olympiads[4]) {
            if (out[4].size() != 6) {
                out[4].push_back(cur[0]);
            }
        }
        if (olympiads[5]) {
            if (out[5].size() != 4) {
                if (cur[2] != 11) {
                    out[5].push_back(cur[0]);
                }
            }
        }
        if (olympiads[6]) {
            if (out[6].size() != 4) {
                if (cur[2] != 11 and cur[2] != 10) {
                    out[6].push_back(cur[0]);
                }
            }
        }
    }
    for (auto& e : out) {
        sort(e.begin(), e.end());
    }
    for (int i = 0; i < olympiads.size(); i++) {
        if (olympiads[i]) {
            if (i == 0) {
                cout << "IOI" << endl;
            }
            if (i == 1) {
                cout << "CEOI" << endl;
            }
            if (i == 2) {
                cout << "EGOI" << endl;
            }
            if (i == 3) {
                cout << "EJOI" << endl;
            }
            if (i == 4) {
                cout << "BaltOI" << endl;
            }
            if (i == 5) {
                cout << "BalkOI" << endl;
            }
            if (i == 6) {
                cout << "JBOI" << endl;
            }

            for (const auto& e : out[i]) {
                cout << e << endl;
            }

            cout << endl;
        }
    }
}
