import heapq

def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    a = [-x for x in a]
    a.sort(reverse=True)
    
    for _ in range(m):
        longest_seq = -a.pop(0)
        if longest_seq % 2 == 0:
            mid = longest_seq // 2
            a.append(-mid)
        else:
            mid = (longest_seq - 1) // 2
            a.append(-mid)
            a.append(-mid)

    return -a[0]

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)

