#include <queue>
#include <iostream>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int n;
    long long m;
    cin >> n >> m;
    
    priority_queue<long long> pq;
    long long ai;
    for (int i = 0; i < n; i++) {
        
        cin >> ai;
        pq.push(ai);
    }
    long long longest_sequence;
    long long smaller_sequence1;
    long long smaller_sequence2;
    for (long long i = 0; i < m-1; i++) {
        longest_sequence = pq.top();
        pq.pop();
        if (longest_sequence > 1){
            smaller_sequence1 = longest_sequence / 2;
            smaller_sequence2 = longest_sequence - 1 - smaller_sequence1;
        }
        else
        {
            smaller_sequence1 =0;
            smaller_sequence2 = 0;
        }
        if (smaller_sequence1 > 0) pq.push(smaller_sequence1);
        if (smaller_sequence2 > 0) pq.push(smaller_sequence2);
    }

    
    cout << pq.top() << endl;
    
    return 0;
}
