#include <iostream>

struct Date {
    int day;
    int month;

    Date(int d, int m) : day(d), month(m) {}
};

bool areBirthdaysEqual(const Date &date1, const Date &date2) {
    return (date1.day == date2.day) && (date1.month == date2.month);
}

int main() {
    int dayByteulian, monthByteulian;
    std::cin >> dayByteulian >> monthByteulian;

    int dayBitulian, monthBitulian;
    std::cin >> dayBitulian >> monthBitulian;

    Date birthdayByteulian(dayByteulian, monthByteulian);
    Date birthdayBitulian(dayBitulian, monthBitulian);

    if (areBirthdaysEqual(birthdayByteulian, birthdayBitulian)) {
        std::cout << "Same birthday!" << std::endl;
    } else {
        std::cout << "Not the same" << std::endl;
    }

    return 0;
}
