w1, w2, w3, w4 = map(int, input().split())
t1, t2, t3, t4 = map(int, input().split())

things = [w1, w2, w3, w4]

sum_box1 = sum(w for w, t in zip(things, [t1, t2, t3, t4]) if t == 1)
sum_box2 = sum(w for w, t in zip(things, [t1, t2, t3, t4]) if t == 2)

min_unbalance = abs(sum_box1 - sum_box2)
move_item = -1

for i, (weight, box) in enumerate(zip(things, [t1, t2, t3, t4])):
    if box == 1:
        sum_box1 -= weight
        sum_box2 += weight
    else:
        sum_box1 += weight
        sum_box2 -= weight

    current_unbalance = abs(sum_box1 - sum_box2)

    if current_unbalance < min_unbalance:
        min_unbalance = current_unbalance
        move_item = i + 1

    if box == 1:
        sum_box1 += weight
        sum_box2 -= weight
    else:
        sum_box1 -= weight
        sum_box2 += weight

print(move_item)
