def process_tshirt_requests(colors, sizes, available, winners):
    excess = defaultdict(lambda: defaultdict(int))
    required = defaultdict(lambda: defaultdict(int))

    for color, size in winners:
        color_idx = color - 1
        size_idx = sizes.index(size)

        if available[color_idx][size_idx] > 0:
            available[color_idx][size_idx] -= 1
        else:
            found = False
            for i in range(size_idx + 1, len(sizes)):
                for j in range(color_idx, len(colors)):
                    if available[j][i] > 0:
                        available[j][i] -= 1
                        excess[j][i] += 1
                        found = True
                        break
                if found:
                    break
            if not found:
                for i in range(size_idx + 1, len(sizes)):
                    for j in range(len(colors)):
                        if available[j][i] > 0:
                            available[j][i] -= 1
                            excess[j][i] += 1
                            found = True
                            break
                    if found:
                        break
            if not found:
                required[color_idx][size_idx] += 1

    return excess, required

n, m = map(int, input().split())
sizes = input().split()

available = []
for _ in range(n):
    available.append(list(map(int, input().split())))

k = int(input())
winners = []
for _ in range(k):
    color, size = input().split()
    winners.append((int(color), size))

excess, required = process_tshirt_requests(range(1, n + 1), sizes, available, winners)

for i in range(n):
    print(" ".join(str(excess[i][j]) for j in range(m)))

for i in range(n):
    print(" ".join(str(required[i][j]) for j in range(m)))