process.stdin.on('data', function (data) {
  let [w, t] = (""+data).split('\n').map(arr => {
    return arr.split(' ').map(num => parseInt(num));
  });
  
  let items = [];
  w.forEach((weight, i) => items.push({ 
    inFirstBox: t[i] === 1, 
    weight: weight 
  }));

  function calcMaxWeight(items) {
    const boxWeight = items.reduce((boxes, it) => {
      boxes[(it.inFirstBox ? 0 : 1)] += it.weight;
      return boxes;
    }, [0, 0]);

    return Math.max(boxWeight[0], boxWeight[1]);
  }

  const best = items.reduce((bestAttempt, w, i) => {
    let attempt = [...items];
    attempt[i].inFirstBox = !attempt[i].inFirstBox;
    
    const max = calcMaxWeight(attempt);
    if (bestAttempt.max > max)
      return { max: max, i: i };
    return bestAttempt;
  }, { max: calcMaxWeight(items), i: -1 });

  console.log(best.i + 1)
});
