#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // Input weights and box numbers
    vector<int> weights(4);
    vector<int> boxes(4);
    
    for (int i = 0; i < 4; ++i) {
        cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        cin >> boxes[i];
    }

    // Calculate the sum of weights in each box
    vector<int> boxWeights(3, 0);

    for (int i = 0; i < 4; ++i) {
        boxWeights[boxes[i]] += weights[i];
    }

    // Find the box with the maximum weight
    int maxWeight = *max_element(boxWeights.begin(), boxWeights.end());

    // Find the item with the maximum weight in the heaviest box
    int itemToMove = -1;

    for (int i = 0; i < 4; ++i) {
        if (boxWeights[boxes[i]] == maxWeight) {
            if (itemToMove == -1 || weights[i] > weights[itemToMove]) {
                itemToMove = i;
            }
        }
    }

    cout << itemToMove + 1 << "\n"; // Output 1-based index of the item to move

    return 0;
}
