#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> colors(n, 0); // 0 means uncrossed, 1 means crossed

    for (int i = 0; i < m; ++i) {
        int len;
        cin >> len;

        // Find the longest uncrossed subsegment
        int start = 0, end = 0;
        int maxLen = 0;
        int currentLen = 0;

        for (int j = 0; j < n; ++j) {
            if (colors[j] == 0) {
                ++currentLen;
                if (currentLen > maxLen) {
                    maxLen = currentLen;
                    start = end - currentLen + 1;
                    end = j;
                }
            } else {
                currentLen = 0;
            }
        }

        // Choose the color(s) in the middle of the subsegment
        int middle = (maxLen + 1) / 2;
        int middleColor = colors[start + middle - 1];
        cout << middleColor << " ";

        // Cross out the chosen color
        colors[start + middle - 1] = 1;
    }

    return 0;
}

