#include <bits/stdc++.h>
#include <map>
using namespace std;

struct Player 
{
    bool gender;
    int grade;
    int age;
    int score;
};

std::vector<int> GetPlayersID(std::string olimpiad, std::map<int, Player> players) 
{
    std::vector<int> playersIndexes = std::vector<int>();

    if (olimpiad == "IOI" || olimpiad == "CEOI") 
    {
        for (int i = 0; i < 4; i++) 
        {
            int maxScore = 0;
            int playerId = -1;
            for (map<int, Player>::iterator it = players.begin(); it != players.end(); it++)
            {
                if ((*it).second.score > maxScore) 
                {
                    maxScore = (*it).second.score;
                    playerId = (*it).first;
                }
            }

            playersIndexes.push_back(playerId);
            players.erase(playerId);
        }
    }

    if (olimpiad == "EGOI") 
    {
        for (int i = 0; i < 4; i++) 
        {
            int maxScore = 0;
            int playerId = -1;
            for (map<int, Player>::iterator it = players.begin(); it != players.end(); it++)
            {
                if ((*it).second.gender == false) 
                {
                    continue;
                }

                if ((*it).second.score > maxScore) 
                {
                    maxScore = (*it).second.score;
                    playerId = (*it).first;
                }
            }

            if (playerId != -1) {
                playersIndexes.push_back(playerId);
                players.erase(playerId);
            }
        }
    }

    if (olimpiad == "EJOI") 
    {
        for (int i = 0; i < 4; i++) 
        {
            int maxScore = 0;
            int playerId = -1;
            for (map<int, Player>::iterator it = players.begin(); it != players.end(); it++)
            {
                if ((*it).second.age >= 15) 
                {
                    continue;
                }

                if ((*it).second.score > maxScore) 
                {
                    maxScore = (*it).second.score;
                    playerId = (*it).first;
                }
            }

            if (playerId != -1) {
                playersIndexes.push_back(playerId);
                players.erase(playerId);
            }
        }
    }

    if (olimpiad == "BaltOI") 
    {
        for (int i = 0; i < 6; i++) 
        {
            int maxScore = 0;
            int playerId = -1;
            for (map<int, Player>::iterator it = players.begin(); it != players.end(); it++)
            {
                if ((*it).second.score > maxScore) 
                {
                    maxScore = (*it).second.score;
                    playerId = (*it).first;
                }
            }

            if (playerId != -1) {
                playersIndexes.push_back(playerId);
                players.erase(playerId);
            }
        }
    }

    if (olimpiad == "BalkOI") 
    {
        for (int i = 0; i < 4; i++) 
        {
            int maxScore = 0;
            int playerId = -1;
            for (map<int, Player>::iterator it = players.begin(); it != players.end(); it++)
            {
                if ((*it).second.grade == 11) 
                {
                    continue;
                }

                if ((*it).second.score > maxScore) 
                {
                    maxScore = (*it).second.score;
                    playerId = (*it).first;
                }
            }

            if (playerId != -1) {
                playersIndexes.push_back(playerId);
                players.erase(playerId);
            }
        }
    }

    if (olimpiad == "JBOI") 
    {
        for (int i = 0; i < 4; i++) 
        {
            int maxScore = 0;
            int playerId = -1;
            for (map<int, Player>::iterator it = players.begin(); it != players.end(); it++)
            {
                if ((*it).second.grade > 9) 
                {
                    continue;
                }

                if ((*it).second.score > maxScore) 
                {
                    maxScore = (*it).second.score;
                    playerId = (*it).first;
                }
            }

            if (playerId != -1) {
                playersIndexes.push_back(playerId);
                players.erase(playerId);
            }
        }
    }

    return playersIndexes;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int numberPlayers;
    cin >> numberPlayers;

    std::map<int, Player> players;

    for (int i = 0; i < numberPlayers; i++) 
    {
        Player player;

        int id;
        cin >> id;
        
        std::string gender;
        cin >> gender;
        bool gender_b;
        if (gender == "male") 
        {
            gender_b = false;
        } else {
            gender_b = true;
        }
        player.gender = gender_b;

        int grade;
        cin >> grade;
        player.grade = grade;

        int age;
        cin >> age;
        player.age = age;

        int score;
        cin >> score;
        player.score = score;

        players[id] = player;
    }

    int numberOlimpiad;
    cin >> numberOlimpiad;

    for (int olimpiad_index = 0; olimpiad_index < numberOlimpiad; olimpiad_index++) 
    {
        std::string olimpiad;
        cin >> olimpiad;

        std::vector<int> found_players = GetPlayersID(olimpiad, players);

        std::sort(found_players.begin(), found_players.end());

        cout << olimpiad << "\n";

        for (int i = 0; i < found_players.size(); i++) 
        {
            cout << found_players[i] << "\n";
        }

        cout << "\n";
    }
}
