#include <bits/stdc++.h>
using namespace std;

int main() {
    // INPUT
    int n, m, k;
    cin >> n; // y
    cin >> m; // x

    string sizeNames[m];
    
    for(int i = 0; i < m; i++) {
        cin >> sizeNames[i];
    }

    int input[n][m]; // [color][size]
    
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> input[i][j];
        }
    }

    int requests[n][m];

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            requests[i][j] = 0;
        }
    }

    vector<pair<int, int>> requestsVector; // pair<color, size>

    cin >> k;

    for(int i = 0; i < k; i++) {
        int c;
        string sizeName;

        cin >> c;
        cin >> sizeName;

        c--;

        for(int j = 0; j < m; j++) {
            if(sizeNames[j] == sizeName) {
                requests[c][j] += 1;
                requestsVector.push_back(make_pair(c, j));
                break;
            }
        }
    }

    // PROGRAM

    // input[color][size] lim[n][m]
    // requests[color][size] lim[n][m]
    // requestsVector[k] -> pair<color, size>
    
    for(int i = 0; i < requestsVector.size(); i++) {
        pair<int, int> request = requestsVector.at(i);
        int color = request.first;
        int size = request.second;
        
        // 1. ищем полное совпадение DONE
        if(input[color][size] > 0) {
            input[color][size]--;
            requests[color][size]--;
            continue;
        } else {
            bool cont = false;

            // 2. ищем тот же размер другой минимальный цвет DONE
            for(int j = 0; j < n; j++) {
                if(input[j][size] > 0) {
                    input[j][size]--;
                    requests[color][size]--;
                    cont = true;
                    break;
                }
            }

            if(cont) {
                continue;
            }

            for(int currentSize = size + 1; currentSize < m; currentSize++) {
                // того же цвета
                if(input[color][currentSize] > 0) {
                    input[color][currentSize]--;
                    requests[color][size]--;
                    break;
                }else {
                    for(int j = 0; j < n; j++) {
                        if(input[j][currentSize] > 0) {
                            input[j][currentSize]--;
                            requests[color][size]--;
                            break;
                        }
                    }
                }
            }
        }
    }

    // OUTPUT

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << input[i][j] << " ";
        }
        cout << endl;
    }
    

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << requests[i][j] << " ";
        }
        cout << endl;
    }
}
