import math

def main():
    # Зчитуємо вхідні дані
    try:
        n = int(input("Введіть n (1≤n≤1000): "))
        m = int(input("Введіть m (1≤m≤1000): "))
    except ValueError:
        print("Помилка: Введіть цілі числа.")
        return

    if n < 1 or m < 1 or n > 1000 or m > 1000:
        print("Помилка: Значення n та m повинні бути в межах від 1 до 1000.")
        return

    # Обчислюємо кількість проходів та округлюємо вверх
    проходи = math.ceil((n + m - 3) / (n - 1))

    # Виводимо результат
    print(f"Кількість проходів робота: {проходи}")

if __name__ == "__main__":
    main()
