def max_unmarked_sequence(size, limit, elements):
    elements.sort()
    left = 1
    right = elements[-1] * 2
    result = 0

    while left <= right:
        mid = (left + right) // 2
        count = 0

        for i in range(size):
            count += (elements[i] + mid) // (mid + 1)

        if count <= limit:
            result = mid
            right = mid - 1
        else:
            left = mid + 1

    return result

n, m = map(int, input().split())
elements = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, elements)
print(result)
