def convert(data) -> list[str]:
    """Convert birthday between calendars"""
    day = data[0] + 13
    month = data[1]

    if day > 30:
        day -= 30
        month += 1

    if month > 12:
        month -= 12

    return [day, month]

input_data = [input(), input()]
data = [list(map(int, x.split())) for x in input_data]

if convert(data[0]) == data[1]:
    print("Same birthday!")
else:
    print("Not the same")