import json  # to convert tuples -> lists
import copy


def calc_max(data) -> int:
    """Return the max weight for a box"""
    box1, box2 = 0, 0

    for box in data:
        if box[1] == 1:
            box1 += box[0]
        else:
            box2 += box[0]

    return max(box1, box2)


weights = list(map(int, input().split()))
box = list(map(int, input().split()))
data = json.loads(json.dumps(list(zip(weights, box))))

results = []
for i in range(4):
    new_data = copy.deepcopy(data)
    if new_data[i][1] == 1:
        new_data[i][1] = 2
    else:
        new_data[i][1] = 1

    results.append([copy.deepcopy(new_data), calc_max(new_data), i])

min_max = min(results, key = lambda x: x[1])
if min_max[1] < calc_max(data):
    print(min_max[2]+1)
else:
    print(-1)