#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    // Введення ваг та номерів коробок
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Ініціалізація ваг коробок
    std::vector<int> boxWeights(2, 0);

    // Обчислення ваг кожної коробки
    for (int i = 0; i < 4; ++i) {
        boxWeights[boxes[i] - 1] += weights[i];
    }

    // Знаходження речі, яку можна оптимально перемістити
    for (int i = 0; i < 4; ++i) {
        int otherBox = 3 - (boxes[i] - 1);  // Знаходження індексу іншої коробки
        int newWeight = boxWeights[otherBox] + weights[i];  // Нова вага іншої коробки після переміщення речі

        // Знаходження максимальної мінімальної ваги коробок
        int maxMinWeight = std::max(*std::max_element(boxWeights.begin(), boxWeights.end()), newWeight);

        // Перевірка, чи ця переміна робить ваги коробок оптимальними
        if (maxMinWeight == *std::min_element(boxWeights.begin(), boxWeights.end())) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    std::cout << "-1" << std::endl;

    return 0;
}
