def get_team(olymp, cheliki):
    if olymp == 'IOI' or olymp == 'CEOI':
        return sorted(cheliki, key=lambda x: x[4], reverse=True)[:4]
    elif olymp == 'EGOI':
        return sorted([p for p in cheliki if p[1] == 'female'], key=lambda x: x[4], reverse=True)[:4]
    elif olymp == 'EJOI':
        return sorted([p for p in cheliki if p[3] <= 15], key=lambda x: x[4], reverse=True)[:4]
    elif olymp == 'BaltOI':
        return sorted(cheliki, key=lambda x: x[4], reverse=True)[:6]
    elif olymp == 'BalkOI':
        return sorted([p for p in cheliki if p[2] != 11], key=lambda x: x[4], reverse=True)[:4]
    elif olymp == 'JBOI':
        return sorted([p for p in cheliki if p[2] not in {10, 11}], key=lambda x: x[4], reverse=True)[:4]

def vir():
    n = int(input())
    cheliki = []
    for _ in range(n):
        chel_inf = input().split()
        cheliki.append((int(chel_inf[0]), chel_inf[1], int(chel_inf[2]),
                             int(chel_inf[3]), int(chel_inf[4])))
    m = int(input())
    olymps = [input() for _ in range(m)]
    cheliki_in_olymp = {}

    for olymp in olymps:
        team_participants = get_team(olymp, cheliki)
        team_participants = sorted(team_participants, key=lambda x: x[0])
        cheliki_in_olymp[olymp] = team_participants

    for olymp in olymps:
        print(olymp)

        for chel in cheliki_in_olymp[olymp]:
            print(chel[0])
vir()