def main():
    weights = list(map(int, input().split()))
    boxes = list(map(int, input().split()))

    box_1_weight = sum(weights[i] for i in range(4) if boxes[i] == 1)
    box_2_weight = sum(weights[i] for i in range(4) if boxes[i] == 2)

    max_weight = max(box_1_weight, box_2_weight)

    for i in range(4):
        if boxes[i] == 1:
            if (box_1_weight - weights[i] + weights[i]) < max_weight:
                print(i + 1)
                return

        if boxes[i] == 2:
            if (box_2_weight - weights[i] + weights[i]) < max_weight:
                print(i + 1)
                return

    print(-1)

if __name__ == "__main__":
    main()