from collections import defaultdict

def process_gifts(n, m, sizes, initial_inventory, orders):
    remaining_inventory = defaultdict(lambda: defaultdict(int))
    additional_orders = defaultdict(lambda: defaultdict(int))
    excess_inventory = defaultdict(lambda: defaultdict(int))

    for color in range(n):
        for size_index, size in enumerate(sizes):
            remaining_inventory[color][size] = initial_inventory[color][size_index]

    for color, size in orders:
        size_index = sizes.index(size)

        if remaining_inventory[color][size] > 0:
            remaining_inventory[color][size] -= 1
        else:
            found_replacement = False
            for larger_size in sizes[size_index + 1:]:
                if remaining_inventory[color][larger_size] > 0:
                    remaining_inventory[color][larger_size] -= 1
                    found_replacement = True
                    additional_orders[color][larger_size] += 1
                    break

            if not found_replacement:
                excess_inventory[color][size] += 1

    display_inventory(remaining_inventory)
    display_inventory(additional_orders)
    display_inventory(excess_inventory)

def displa
