#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    cin >> m;

    vector<string> olympiads(m);

    for (int i = 0; i < m; ++i) {
        cin >> olympiads[i];
    }

    // Sorting participants by score in descending order
    sort(participants.begin(), participants.end(), [](const Participant& a, const Participant& b) {
        return a.score > b.score;
    });

    for (const auto& olympiad : olympiads) {
        cout << olympiad << endl;

        if (olympiad == "IOI" || olympiad == "CEOI") {
            for (const auto& participant : participants) {
                if (participant.grade >= 1 && participant.grade <= 11) {
                    cout << participant.id << endl;
                }
            }
        } else if (olympiad == "EGOI") {
            for (const auto& participant : participants) {
                if (participant.gender == "female" && participant.grade >= 1 && participant.grade <= 11) {
                    cout << participant.id << endl;
                }
            }
        } else if (olympiad == "EJOI") {
            for (const auto& participant : participants) {
                if (participant.age <= 15 && participant.grade >= 1 && participant.grade <= 11) {
                    cout << participant.id << endl;
                }
            }
        } else if (olympiad == "BaltOI") {
            for (const auto& participant : participants) {
                cout << participant.id << endl;
                if (--n == 0) {
                    break;
                }
            }
        } else if (olympiad == "BalkOI") {
            for (const auto& participant : participants) {
                if (participant.grade != 11) {
                    cout << participant.id << endl;
                }
            }
        } else if (olympiad == "JBOI") {
            for (const auto& participant : participants) {
                if (participant.grade != 11 && participant.grade != 10) {
                    cout << participant.id << endl;
                }
            }
        }

        cout << endl;
    }

    return 0;
}