#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade
            >> participants[i].age >> participants[i].score;
    }

    int m;
    cin >> m;

    map<string, vector<int>> olympiadParticipants;

    for (int i = 0; i < n; ++i) {
        if (participants[i].gender == "female" && participants[i].grade <= 15) {
            olympiadParticipants["EJOI"].push_back(participants[i].id);
        }
        if (participants[i].grade <= 10) {
            olympiadParticipants["JBOI"].push_back(participants[i].id);
        }
        if (participants[i].grade <= 11 && participants[i].gender != "female") {
            olympiadParticipants["BalkOI"].push_back(participants[i].id);
        }
        if (participants[i].grade <= 11) {
            olympiadParticipants["CEOI"].push_back(participants[i].id);
            olympiadParticipants["IOI"].push_back(participants[i].id);
            olympiadParticipants["BaltOI"].push_back(participants[i].id);
        }
        if (participants[i].grade <= 11 && participants[i].gender == "female") {
            olympiadParticipants["EGOI"].push_back(participants[i].id);
        }
    }

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        sort(olympiadParticipants[olympiad].begin(), olympiadParticipants[olympiad].end());

        for (int id : olympiadParticipants[olympiad]) {
            cout << id << '\n';
        }
    }

    return 0;
}
