#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    long long left = 0, right = 1e18;
    long long last = -1;  // declare last here

    while (left < right) {
        long long mid = (left + right) / 2;
        long long count = 0;

        for (int i = 0; i < n; ++i) {
            if (a[i] <= mid) {
                count += a[i] + 1;
            } else {
                count += (a[i] - mid) * 2 + 1;
            }

            last = max(last, a[i]);
        }

        if (count >= m) {
            right = mid;
        } else {
            left = mid + 1;
        }
    }

    cout << max(left, last) << endl;

    return 0;
}
