# Зчитуємо вхідні дані
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Визначаємо ваги коробок
box_weights = [0, 0]

for i, weight in enumerate(weights):
    box_weights[boxes[i] - 1] += weight

# Шукаємо оптимальне переміщення
max_weight = max(box_weights)
item_to_move = -1

for i, box in enumerate(boxes):
    from_box = box - 1
    to_box = 1 - from_box
    current_weight = box_weights[from_box] - weights[i] + box_weights[to_box]

    # Перевіряємо, чи зменшення різниці ваг на 1 або менше
    if abs(current_weight - max_weight) <= 1:
        item_to_move = i + 1
        break

# Виводимо результат
print(item_to_move)
