#include <iostream>

void generateOrnament(int n, int m) {
    char ornament[n][m];

    // Ініціалізуємо масив крапок
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ornament[i][j] = '.';
        }
    }

    // Заповнюємо 'x' в клітинах з парними координатами
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i % 2 == 0 && j % 2 == 0) {
                ornament[i][j] = 'x';
            }
        }
    }

    // Заповнюємо 'x' в клітинах з непарними координатами
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i % 2 == 1 && j % 2 == 1) {
                ornament[i][j] = 'x';
            }
        }
    }

    // Виводимо орнамент
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cout << ornament[i][j];
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, m;

    // Зчитуємо вхідні дані
    std::cin >> n >> m;

    // Генеруємо та виводимо орнамент
    generateOrnament(n, m);

    return 0;
}
