#include <iostream>
#include <vector>

void generateOrnament(int n, int m) {
    std::vector<std::vector<char>> pattern(n, std::vector<char>(m, '.'));

    for (int i = 0; i < n; i += 2) {
        for (int j = 0; j < m; ++j) {
            pattern[i][j] = 'x';
        }
    }

    for (int i = 1; i < n; i += 4) {
        pattern[i][0] = 'x';
    }

    for (int i = 3; i < n; i += 4) {
        pattern[i][m - 1] = 'x';
    }

    // Вивід орнаменту
    for (const auto& row : pattern) {
        for (char cell : row) {
            std::cout << cell;
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    generateOrnament(n, m);

    return 0;
}
