def can_choose_color(length, n, m, colors):
    total = 0
    for a in colors:
        if a <= length:
            total += 1
    return total >= length

def find_maximum_subsequence(n, m, colors):
    left, right = 1, n + m

    result = 0
    while left <= right:
        mid = (left + right) // 2
        if can_choose_color(mid, n, m, colors):
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

# Ввід даних
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Знаходимо та виводимо відповідь
answer = find_maximum_subsequence(n, m, colors)
print(answer)
