#include <iostream>

using namespace std;

int main() {
    int weights[4];
    int boxes[4];

    int box1 = 0;
    int box2 = 0;

    for (int i = 0; i < 4; i++) {
        cin >> weights[i];
    }

    for (int i = 0; i < 4; i++) {
        cin >> boxes[i];

        if (boxes[i] == 1) {
            box1 += weights[i];
        } else {
            box2 += weights[i];
        }
    }

    if (box1 == box2) {
        cout << "-1\n";
        return 0;
    }

    int heavier = box1 > box2 ? 1 : 2;
    int diff = abs(box1 - box2);
    int best_item = -2;
    int best_new_diff = diff;

    for (int i = 0; i < 4; i++) {
        int current_diff = abs(diff - weights[i] * 2);

        if (boxes[i] == heavier && current_diff < best_new_diff) {
            best_new_diff = current_diff;
            best_item = i;
        }
    }

    cout << (best_item + 1) << "\n";

    return 0;
}
