import java.util.Scanner;

public class CoinDistribution {

    public static String distributeCoins(int coins, int numWinners) {
        int totalCoinsNeeded = numWinners * 3;

        if (coins < totalCoinsNeeded) {
            return "Недостатньо копійок для виплати всім переможцям.";
        }

        int coinsPerWinner = 3;
        int remainingCoins = coins - totalCoinsNeeded;

        return String.format("Кожен переможець отримає %d копійки. Залишилося %d копійок.", coinsPerWinner, remainingCoins);
    }

    public static void main(String[] args) {
        try {
            Scanner scanner = new Scanner(System.in);

            System.out.print("Введіть кількість копійок (від 3 до 100): ");
            int coins = scanner.nextInt();

            System.out.print("Введіть кількість переможців (від 1 до 100): ");
            int winners = scanner.nextInt();

            if (3 <= coins && coins <= 100 && 1 <= winners && winners <= 100) {
                String result = distributeCoins(coins, winners);
                System.out.println(result);
            } else {
                System.out.println("Некоректні вхідні дані. Спробуйте ще раз.");
            }

        } catch (java.util.InputMismatchException e) {
            System.out.println("Введіть ціле число.");
        }
    }
}