#include <stdio.h>
int main() {
    int weights[4];
    int boxes[4];
    for (int i = 0; i < 4; i++) {
        scanf("%d", &weights[i]);
    }

    for (int i = 0; i < 4; i++) {
        scanf("%d", &boxes[i]);
    }

    int box_weights[2] = {0, 0};
    for (int j = 1; j <= 2; j++) {
        for (int i = 0; i < 4; i++) {
            if (boxes[i] == j) {
                box_weights[j - 1] += weights[i];
            }
        }
    }

 
    int max_weight = (box_weights[0] > box_weights[1]) ? box_weights[0] : box_weights[1];

    int optimal_move = -1;
    int min_max_weight = max_weight;


    for (int i = 0; i < 4; i++) {
        int new_weight, max_weight_after_move;
        if (boxes[i] == 1) {
            new_weight = box_weights[0] - weights[i];
            max_weight_after_move = (new_weight > (box_weights[1] + weights[i])) ? new_weight : (box_weights[1] + weights[i]);
        } else {
            new_weight = box_weights[1] - weights[i];
            max_weight_after_move = (new_weight > (box_weights[0] + weights[i])) ? new_weight : (box_weights[0] + weights[i]);
        }

        if (max_weight_after_move < min_max_weight) {
            min_max_weight = max_weight_after_move;
            optimal_move = i + 1;
        }
    }


    printf("%d\n", optimal_move);

    return 0;
}