#include <stdio.h>

int main() {
    int n, m;
    scanf("%d %d", &n, &m);

    int x1_coords[2] = {1, 1};
    int x2_coords[2] = {1, m};
    char result[n * m + n]; // Assuming maximum space required
    int result_index = 0;
    int reflected = 0;

    for (int i1 = 0; i1 < n; i1++) {
        for (int i2 = 0; i2 < m; i2++) {
            if ((x1_coords[0] == i1 + 1 && x1_coords[1] == i2 + 1) || 
                (x2_coords[0] == i1 + 1 && x2_coords[1] == i2 + 1)) {
                result[result_index++] = 'x';
            } else {
                result[result_index++] = '.';
            }
        }

        x1_coords[0]++;
        x2_coords[0]++;

        if ((x1_coords[1] == m || x1_coords[1] == 1) && 
            (x2_coords[1] == m || x2_coords[1] == 1) && i1 != 0) {
            reflected = !reflected;
        }

        if (!reflected) {
            x1_coords[1]++;
        } else {
            x1_coords[1]--;
        }

        if (!reflected) {
            x2_coords[1]--;
        } else {
            x2_coords[1]++;
        }

        result[result_index++] = '\n';
    }

    result[result_index] = '\0'; // Null-terminate the string
    printf("%s", result);

    return 0;
}