def generate_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if i == 0 or i == n - 1 or j == 0 or j == m - 1:
                if (i + j) % 2 == 0:
                    ornament[i][j] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))


n, m = map(int, input().split())


ornament = generate_ornament(n, m)
print_ornament(ornament)
