from operator import itemgetter

def select_participants(n, participants, m, olympiads):
    for olympiad in olympiads:
        selected = []
        if olympiad == 'IOI' or olympiad == 'CEOI':
            selected = sorted(participants, key=itemgetter('score'), reverse=True)[:4]
        elif olympiad == 'EGOI':
            selected = sorted([p for p in participants if p['gender'] == 'female'], key=itemgetter('score'), reverse=True)[:4]
        elif olympiad == 'EJOI':
            selected = sorted([p for p in participants if p['age'] < 15], key=itemgetter('score'), reverse=True)[:4]
        elif olympiad == 'BaltOI':
            selected = sorted(participants, key=itemgetter('score'), reverse=True)[:6]
        elif olympiad == 'BalkOI':
            selected = sorted([p for p in participants if p['grade'] != 11], key=itemgetter('score'), reverse=True)[:4]
        elif olympiad == 'JBOI':
            selected = sorted([p for p in participants if p['grade'] not in [10, 11]], key=itemgetter('score'), reverse=True)[:4]
        
        print(olympiad)
        for p in sorted(selected, key=itemgetter('id')):
            print(p['id'])

if __name__ == "__main__":
    n = int(input())
    participants = []
    for _ in range(n):
        id, gender, grade, age, score = input().split()
        participants.append({'id': int(id), 'gender': gender, 'grade': int(grade), 'age': int(age), 'score': int(score)})
    m = int(input())
    olympiads = [input() for _ in range(m)]
    select_participants(n, participants, m, olympiads)