def choose_colors(n, m, a):
    def check(x):
        return sum(max(0, (ai+1)//2 - x) for ai in a) >= m

    left, right = 0, max(a)+1
    while right - left > 1:
        mid = (left + right) // 2
        if check(mid):
            left = mid
        else:
            right = mid

    return left

if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    print(choose_colors(n, m, a))