#include <iostream>
#include <vector>

void generateOrnament(int n, int m) {
    std::vector<std::vector<char>> ornament(n, std::vector<char>(m, ' '));


    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i == 0 || j == 0 || i == n - 1 || j == m - 1) {
                ornament[i][j] = '*';
            } else if (i == j || i == m - 1 - j) {
                ornament[i][j] = '*';
            }
        }
    }


    for (const auto &row : ornament) {
        for (char c : row) {
            std::cout << c << ' ';
        }
        std::cout << '\n';
    }
}

int main() {

    int n, m;
    std::cin >> n >> m;


    generateOrnament(n, m);

    return 0;
}
