#include <iostream>
#include <vector>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<int> x1_coords = {1, 1};
    std::vector<int> x2_coords = {1, m};

    std::string result;
    bool reflected = false;

    for (int i1 = 0; i1 < n; ++i1) {
        for (int i2 = 0; i2 < m; ++i2) {
            if (x1_coords == std::vector<int>{i1+1, i2+1} || x2_coords == std::vector<int>{i1+1, i2+1}) {
                result += "x";
            } else {
                result += ".";
            }
        }
        x1_coords[0] += 1;
        x2_coords[0] += 1;

        if (x1_coords[1] == m || x1_coords[1] == 1 || x2_coords[1] == m || x2_coords[1] == 1) {
            if (i1 != 0) {
                reflected = !reflected;
            }
        }
        if (!reflected) {
            x1_coords[1] += 1;
            x2_coords[1] -= 1;
        } else {
            x1_coords[1] -= 1;
            x2_coords[1] += 1;
        }

        result += "\n";
    }

    std::cout << result;

    return 0;
}
