#include <iostream>
#include <vector>

int main() {
    // Input weights of items
    std::vector<int> weights(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    // Input box numbers for each item
    std::vector<int> boxes(4);
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Calculate the total weight of each box
    int box1 = weights[0] * (boxes[0] == 1) + weights[1] * (boxes[1] == 1) + weights[2] * (boxes[2] == 1) + weights[3] * (boxes[3] == 1);
    int box2 = weights[0] * (boxes[0] == 2) + weights[1] * (boxes[1] == 2) + weights[2] * (boxes[2] == 2) + weights[3] * (boxes[3] == 2);

    // Find the item to move or output -1 if no change is needed
    for (int i = 0; i < 4; ++i) {
        int newBox1 = box1 - weights[i] * (boxes[i] == 1) + weights[i] * (boxes[i] == 2);
        int newBox2 = box2 - weights[i] * (boxes[i] == 2) + weights[i] * (boxes[i] == 1);

        if (std::max(newBox1, newBox2) < std::max(box1, box2)) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // If no change is needed
    std::cout << "-1" << std::endl;

    return 0;
}
