n, m = map(int, input().split())
a = list(map(int, input().split()))

# Calculate the cumulative sum of a
cumulative_sum = [0] * (n + 1)
for i in range(n):
    cumulative_sum[i + 1] = cumulative_sum[i] + a[i]

result = 0

# Find the maximum length of the unmarked segment
for i in range(1, n + 1):
    for j in range(i, n + 1):
        current_length = cumulative_sum[j] - cumulative_sum[i - 1]
        if current_length % 2 == 1:
            result = max(result, current_length)

print(result)
