#include <iostream>
#include <vector>
using namespace std;

void printOrnament(int r, int c, const vector<vector<char>>& p) {
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j)
            cout << p[i][j];
        cout << endl;
    }
}

vector<vector<char>> createOrnamentPattern(int r, int c) {
    vector<vector<char>> p(r, vector<char>(c, '.'));
    int m = min(r, c);

    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            if (i == j || i + j == m - 1 || (i >= m && j >= m && (i - m) % m == (j - m) % m))
                p[i][j] = 'x';
        }
    }

    return p;
}

int main() {
    int r, c;
    cin >> r >> c;
    printOrnament(r, c, createOrnamentPattern(r, c));
    return 0;
}
