def create_ornament(n, m):
    ornament = []
    for i in range(n):
        row = []
        for j in range(m):
            if (i + j) % 2 == 0 or (i - j) % 2 == 0:
                row.append("x")
            else:
                row.append(".")
        ornament.append("".join(row))
    return ornament

# Input for height and width
n, m = map(int, input().split())

# Generate and print the ornament
ornament = create_ornament(n, m)
for row in ornament:
    print(row)
