from collections import defaultdict

def process_inventory():

    n, m = map(int, input().split())
    sizes = input().split()
    inventory = [list(map(int, input().split())) for _ in range(n)]
    winners_count = int(input())
    winners = [input().split() for _ in range(winners_count)]

    extra = defaultdict(lambda: defaultdict(int))
    missing = defaultdict(lambda: defaultdict(int))

    for i in range(winners_count):
        color, size = winners[i]
        size_index = sizes.index(size)
        color_index = int(color) - 1

        if inventory[color_index][size_index] > 0:
            inventory[color_index][size_index] -= 1
        else:
            found = False
            for s in range(size_index + 1, m):
                if inventory[color_index][s] > 0:
                    extra[color_index][s] += 1
                    found = True
                    break

            if not found:
                for s in range(size_index):
                    if inventory[color_index][s] > 0:
                        extra[color_index][s] += 1
                        found = True
                        break

            if not found:
                for c in range(color_index + 1, n):
                    for s in range(m):
                        if inventory[c][s] > 0:
                            extra[c][s] += 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                for c in range(color_index):
                    for s in range(m):
                        if inventory[c][s] > 0:
                            extra[c][s] += 1
                            found = True
                            break
                    if found:
                        break


    for row in inventory:
        print(*row)

    for i in range(n):
        print(*missing[i].values())

process_inventory()

