using System;

class Solution {
    public static void Main(string[] args) {
        string[] weightsInput = Console.ReadLine().Split();
        int[] weights = Array.ConvertAll(weightsInput, int.Parse);
        string[] boxesInput = Console.ReadLine().Split();
        int[] boxes = Array.ConvertAll(boxesInput, int.Parse);
        int[] boxWeights = new int[3];
        for (int i = 0; i < 4; i++)
        {
          boxWeights[boxes[i] - 1] += weights[i];
        }
        int itemToMove = -1;
        int minMaxWeight = int.MaxValue;
        for (int i = 0; i < 4; i++)
        {
          for (int j = 0; j < 3; j++)
            {
                if (j != boxes[i] - 1)
                {
                    int newMaxWeight = Math.Max(boxWeights[j] + weights[i], boxWeights[boxes[i] - 1] - weights[i]);
                    if (newMaxWeight < minMaxWeight)
                    {
                        minMaxWeight = newMaxWeight;
                        itemToMove = i + 1;
                    }
                }
            }
        }
        Console.WriteLine(itemToMove);
    }
}
