from collections import defaultdict

# Function to find the required T-shirt
def find_tshirt(color, size):
    if (color, size) in inventory and inventory[(color, size)] > 0:
        inventory[(color, size)] -= 1
        return None
    else:
        for i in range(colors):
            for j in range(sizes):
                if j == size and inventory[(i, j)] > 0:
                    inventory[(i, j)] -= 1
                    return i, j
        for i in range(colors):
            for j in range(size + 1, sizes):
                if inventory[(i, j)] > 0:
                    inventory[(i, j)] -= 1
                    return i, j
    return None

# Reading input
colors, sizes = map(int, input().split())
size_names = input().split()
inventory = defaultdict(int)

for i in range(colors):
    line = list(map(int, input().split()))
    for j, num in enumerate(line):
        inventory[(i, j)] = num

winners = int(input())
absent_tshirts = defaultdict(int)

# Processing winners' requests
for _ in range(winners):
    color, size = map(str, input().split())
    size_idx = size_names.index(size)
    tshirt = find_tshirt(int(color) - 1, size_idx)
    if tshirt:
        absent_tshirts[tshirt] += 1

# Printing remaining and required T-shirts
for i in range(colors):
    print(*[inventory[(i, j)] for j in range(sizes)])
for i in range(colors):
    print(*[absent_tshirts[(i, j)] for j in range(sizes)])
