n = int(input())
participants = []
for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append((int(id), gender, int(grade), int(age), int(score)))

m = int(input())
olympiads = []
for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)

for olympiad in olympiads:
    team = []
    if olympiad == "IOI" or olympiad == "CEOI":
        participants.sort(key=lambda x: x[4], reverse=True)
        team = [p[0] for p in participants[:4]]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        female_participants.sort(key=lambda x: x[4], reverse=True)
        team = [p[0] for p in female_participants[:4]]
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p[3] <= 15]
        young_participants.sort(key=lambda x: x[4], reverse=True)
        team = [p[0] for p in young_participants[:4]]
    elif olympiad == "BaltOI":
        participants.sort(key=lambda x: x[4], reverse=True)
        team = [p[0] for p in participants[:6]]
    elif olympiad == "BalkOI":
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        non_11th_grade_participants.sort(key=lambda x: x[4], reverse=True)
        team = [p[0] for p in non_11th_grade_participants[:4]]
    elif olympiad == "JBOI":
        non_11th_10th_grade_participants = [p for p in participants if p[2] != 11 and p[2] != 10]
        non_11th_10th_grade_participants.sort(key=lambda x: x[4], reverse=True)
        team = [p[0] for p in non_11th_10th_grade_participants[:4]]
    
    print(olympiad)
    for participant_id in team:
        print(participant_id)
