def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        ornament[i][0] = '*'
        ornament[i][m - 1] = '*'

    for j in range(m):
        ornament[0][j] = '*'

    for i in range(1, n):
        for j in range(1, m):
            if i == j or i + j == m - 1:
                ornament[i][j] = '*'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

if __name__ == "__main__":
    n, m = map(int, input().split())
    
    if n < 3 or m < 3:
        print("Задані розміри надто малі.")
    else:
        ornament = create_ornament(n, m)
        print_ornament(ornament)


