def process_requests(n, m, sizes, available, winners):
    remaining = [[0] * m for _ in range(n)]
    needed = [[0] * m for _ in range(n)]
    for i in range(len(available)):
        for j in range(len(available[i])):
            remaining[i][j] = available[i][j]

    for winner in winners:
        color, size = winner
        size_index = sizes.index(size)

        found = False
        for i in range(n):
            if remaining[i][size_index] > 0 and i + 1 == color:
                remaining[i][size_index] -= 1
                found = True
                break

        if not found:
            for i in range(n):
                if remaining[i][size_index] > 0:
                    remaining[i][size_index] -= 1
                    needed[i][size_index] += 1
                    break

    return remaining, needed



n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
winners = [list(map(int, input().split())) for _ in range(k)]


remaining, needed = process_requests(n, m, sizes, available, winners)


for row in remaining:
    print(*row)

for row in needed:
    print(*row)
