#include <iostream>

using namespace std;

int move_item(int w1, int w2, int w3, int w4, int t1, int t2, int t3, int t4) {
  
  int box1 = w1 + w2;
  int box2 = w3 + w4;

  
  if (box1 > box2) {
    return -1;
  }

 
  if (box1 < box2) {
    
    int min_weight_in_light_box = min(w1, w2);

  
    int max_weight_in_heavy_box = max(w3, w4);

    
    if (min_weight_in_light_box < (box2 - box1)) {
      return t1 == 1 ? w1 : w2;
    } else {
      return -1;
    }
  } else {
  
    int max_weight_in_light_box = max(w1, w2);

    int min_weight_in_heavy_box = min(w3, w4);

   
    if (max_weight_in_light_box > (box1 - box2)) {
      return t3 == 2 ? w3 : w4;
    } else {
      return -1;
    }
  }
}

int main() {

  int w1, w2, w3, w4;
  cin >> w1 >> w2 >> w3 >> w4;
  int t1, t2, t3, t4;
  cin >> t1 >> t2 >> t3 >> t4;


  int p = move_item(w1, w2, w3, w4, t1, t2, t3, t4);

  cout << p << endl;

  return 0;
}
  