#include <bits/stdc++.h>
using namespace std;
using ll = long long;
ll n;

map<string, ll> conv;

struct person {
    ll id, grade, age, score;
    string gender;

    bool operator<(person& p) {
        return score < p.score;
    }
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    conv["IOI"] = 0;
    conv["CEOI"] = 1;
    conv["EGOI"] = 2;
    conv["EJOI"] = 3;
    conv["BaltOI"] = 4;
    conv["BalkOI"] = 5;
    conv["JBOI"] = 6;
    
    cin >> n;
    vector<person> a;
    a.reserve(n);
    for (int i = 0; i < n; i++) {
        ll id, grade, age, score; string gender;
        cin >> id >> gender >> grade >> age >> score;
        person p = {id, grade, age, score, gender};
        a.push_back(p);
    }
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());

    vector<vector<ll>> v(7);
    for (int i = 0; i < n; i++) {
        if (v[0].size() < 4) {
            v[0].push_back(a[i].id);
            v[1].push_back(a[i].id);
        }
        if (v[2].size() < 4 && a[i].gender == "female") {
            v[2].push_back(a[i].id);
        }
        if (v[3].size() < 4 && a[i].age <= 15) {
            v[3].push_back(a[i].id);
        }
        if (v[4].size() < 6) {
            v[4].push_back(a[i].id);
        }
        if (v[5].size() < 4 && a[i].grade <= 10) {
            v[5].push_back(a[i].id);
        }
        if (v[6].size() < 4 && a[i].grade <= 9) {
            v[6].push_back(a[i].id);
        }
    }

    for (int i = 0; i < 7; i++) {
        sort(v[i].begin(), v[i].end());
    }
    ll q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;
        printf("%s\n", s.c_str());
        for (ll id : v[conv[s]]) {
            printf("%lld\n", id);
        }
        printf("\n");
    }

}