#include <bits/stdc++.h>
using namespace std;
using ll = long long;
ll n, m;


ll least(ll m, ll k) {
    if (m > k) return 0;
    ll lg = log2(m);
    if (m == (1LL << (lg + 1)) - 1) {
        lg++;
    }

    ll here = (1LL << lg) - 1;
    ll left = m - here;
    if (left < (k - here) % (here + 1)) {
        return (k - here + here) / (here + 1);
    }
    else {
        return (k - here) / (here + 1);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> n >> m;
    m--;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    ll beg = 0;
    ll end = 1e18 + 10;

    while (beg <= end) {
        ll mid = (beg + end) / 2;
        ll need = 0;
        for (int i = 0; i < n; i++) {
            ll l = 0;
            ll r = 1e18 + 10;
            while (l <= r) {
                ll md = (l + r) / 2;
                ll here = least(md, a[i]);
                if (here <= mid) {
                    r = md - 1;
                }
                else {
                    l = md + 1;
                }
            }
            need += r + 1;
        }
        if (need <= m) {
            end = mid - 1;
        }
        else {
            beg = mid + 1;
        }
    }
    printf("%lld\n", end + 1);
    

}