def process_gifts(n, m, sizes, available, k, requests):
    remaining = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for request in requests:
        c, s = request
        size_index = sizes.index(s)

        # Шукаємо футболку потрібного розміру та кольору
        if available[int(c) - 1][size_index] > 0:
            available[int(c) - 1][size_index] -= 1
        else:
            found = False
            for j in range(size_index + 1, m):
                if available[int(c) - 1][j] > 0:
                    available[int(c) - 1][j] -= 1
                    found = True
                    break

            if not found:
                for j in range(size_index + 1, m):
                    if to_order[int(c) - 1][j] > 0:
                        to_order[int(c) - 1][j] -= 1
                        found = True
                        break

            if not found:
                for j in range(size_index + 1, m):
                    if available[int(c) - 1][j] > 0:
                        available[int(c) - 1][j] -= 1
                        break

                to_order[int(c) - 1][size_index] += 1

    return remaining, to_order


def main():
    n, m = map(int, input().split())
    sizes = input().split()
    available = [list(map(int, input().split())) for _ in range(n)]

    k = int(input())
    requests = [input().split() for _ in range(k)]

    remaining, to_order = process_gifts(n, m, sizes, available, k, requests)

    for row in remaining:
        print(" ".join(map(str, row)))

    for row in to_order:
        print(" ".join(map(str, row)))


if __name__ == "__main__":
    main()
