#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int l = 0, r = n + m;
    while (l < r) {
        int x = (l + r + 1) / 2;  // Середина інтервалу
        vector<int> b(a);
        
        // Закреслюємо x найбільших елементів
        sort(b.begin(), b.end(), greater<int>());
        for (int i = 0; i < x; ++i) {
            b[i] = 0;
        }

        // Знаходимо найбільший підвідрізок
        int max_subarray = 0, current_subarray = 0;
        for (int i : b) {
            if (i == 0) {
                current_subarray = 0;
            } else {
                ++current_subarray;
                max_subarray = max(max_subarray, current_subarray);
            }
        }

        if (max_subarray >= x) {
            l = x;
        } else {
            r = x - 1;
        }
    }

    cout << l << endl;

    return 0;
}
