def max_length(n, m, a):
    colors = [(a[i], i + 1) for i in range(n)]

    colors.sort(reverse=True)

    prefix_sum = 0
    max_length = 0
    for _, index in colors:
        prefix_sum += index
        max_length = max(max_length, prefix_sum)

    return max_length

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_length(n, m, a)
print(result)
