#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Input weights
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    // Input box numbers
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Iterate through each item and check if moving it balances the boxes
    for (int i = 0; i < 4; ++i) {
        int currentWeight = weights[i];

        // Calculate total weights in each box
        int totalWeightBox1 = 0, totalWeightBox2 = 0;
        for (int j = 0; j < 4; ++j) {
            if (j != i) {
                if (boxes[j] == 1) {
                    totalWeightBox1 += weights[j];
                } else {
                    totalWeightBox2 += weights[j];
                }
            }
        }

        // Check if moving the item balances the boxes
        if (std::max(totalWeightBox1, totalWeightBox2) <= currentWeight) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // If it's optimal not to change anything
    std::cout << "-1" << std::endl;

    return 0;
}
