n = int(input())
print ("%d %d\n" % (n/10, n%10))
class Participant:
    def __init__(self, id, gender, grade, age, score):
        self.id = id
        self.gender = gender
        self.grade = grade
        self.age = age
        self.score = score


def get_team(participants, olympiad, team_size):

    sorted_participants = sorted(participants, key=lambda x: x.score, reverse=True)
    
    
    if olympiad == "IOI" or olympiad == "CEOI":
        team = sorted_participants[:team_size]
    elif olympiad == "EGOI":
        team = [p for p in sorted_participants if p.gender == "female"][:team_size]
    elif olympiad == "EJOI":
        team = [p for p in sorted_participants if p.age <= 15][:team_size]
    elif olympiad == "BaltOI":
        team = sorted_participants[:team_size]
    elif olympiad == "BalkOI":
        team = [p for p in sorted_participants if p.grade != 11][:team_size]
    elif olympiad == "JBOI":
        team = [p for p in sorted_participants if p.grade not in [10, 11]][:team_size]

    return team


n = int(input())
participants = []

for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append(Participant(int(id), gender, int(grade), int(age), int(score)))

m = int(input())
olympiads = [input() for _ in range(m)]


for olympiad in olympiads:
    team = get_team(participants, olympiad, 4)  
    print(olympiad)
    for participant in team:
        print(participant.id)