#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Зчитуємо вхідні дані: ваги предметів та номери коробок
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Знаходимо вагу кожної коробки
    int weight_box1 = 0, weight_box2 = 0;
    for (int i = 0; i < 4; ++i) {
        if (boxes[i] == 1) {
            weight_box1 += weights[i];
        } else {
            weight_box2 += weights[i];
        }
    }

    // Знаходимо максимальну вагу коробки
    int max_weight = std::max(weight_box1, weight_box2);

    // Шукаємо предмет з максимальною вагою і переміщаємо його з важчої коробки в легшу
    for (int i = 0; i < 4; ++i) {
        if ((boxes[i] == 1 && weight_box1 == max_weight && weight_box2 < max_weight) ||
            (boxes[i] == 2 && weight_box2 == max_weight && weight_box1 < max_weight)) {
            std::cout << i + 1 << std::endl; // Нумерація з 1
            return 0;
        }
    }

    std::cout << "-1" << std::endl; // Якщо оптимальний варіант не знайдено
    return 0;
}