import java.util.Scanner;

public class Main 
{
    public static void main(String[] args) 
    {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();

        char[][] ornament = new char[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ornament[i][j] = '.';
            }
        }

        for (int i = 0; i < Math.min(n, m); i++) {
            ornament[i][i] = 'x';
            ornament[i][m - i - 1] = 'x';
        }
        
        for (int i = m - 1; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                ornament[i][j] = ornament[i - m + 1][j];
            }
        }

        for (char[] row : ornament) {
            System.out.println(new String(row));
        }
    }
}