#include <iostream>
#include <vector>
using namespace std;

int main() {
    vector<int> w(4), t(4);
    vector<int> boxWeight(3, 0); 

    for (int i = 0; i < 4; ++i) cin >> w[i];
    for (int i = 0; i < 4; ++i) {
        cin >> t[i];
        boxWeight[t[i]] += w[i];
    }

    int minMaxWeight = max(boxWeight[1], boxWeight[2]);
    int itemToMove = -1;
    for (int i = 0; i < 4; ++i) {
        int newWeight1 = boxWeight[1] - (t[i] == 1 ? w[i] : 0) + (t[i] == 2 ? w[i] : 0);
        int newWeight2 = boxWeight[2] - (t[i] == 2 ? w[i] : 0) + (t[i] == 1 ? w[i] : 0);
        int newMaxWeight = max(newWeight1, newWeight2);
        if (newMaxWeight < minMaxWeight) {
            minMaxWeight = newMaxWeight;
            itemToMove = i + 1;
        }
    }

    cout << itemToMove;
    return 0;
}
