#include <bits/stdc++.h>
using namespace std;

int size_index(string sizes[], int length, string s){
    for (int i=0; i<length; i++){
        if (sizes[i] == s) {
            return i;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    string sizes[m];
    for (int i=0; i<m; i++){
        cin >> sizes[i];
    }
    int t_shirts[n][m];
    int orders[n][m];
    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            cin >> t_shirts[i][j];
            orders[i][j] = 0;
        }
    }
    

    int n_winners;
    cin >> n_winners;

    for (int k=0; k<n_winners; k++){
        int color;
        cin >> color;
        string size;
        cin >> size;
        
        int i = color - 1;
        int j = size_index(sizes, m, size);
        
        bool found = false;
        int s = j;
        while (s < m && !found) {
            if (t_shirts[i][s] > 0) {
                t_shirts[i][s]--;
                found = true;
                break;
            }
            int c = 0;
            while (c < n){
                if (t_shirts[c][s] > 0){
                    t_shirts[c][s]--;
                    found = true;
                    break;
                }
                c++;
            }
            s++;
        }
        if (!found) {
            orders[i][j]++;
        }
    }

    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            cout << t_shirts[i][j] << ' '; 
        }
        cout << '\n';
    }
    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            cout << orders[i][j] << ' '; 
        }
        cout << '\n';
    }
}
