import java.util.Scanner;

public class CrossStitch {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int m = scanner.nextInt();

        char[][] ornament = createOrnament(n, m);

        printOrnament(ornament);
    }

    private static char[][] createOrnament(int n, int m) {
        char[][] ornament = new char[n][m];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ornament[i][j] = '.';
            }
        }

        for (int i = 0; i < n; i++) {
            ornament[i][0] = 'x';  // Лівий промінь
            ornament[i][m - 1] = 'x';  // Правий промінь
        }

        return ornament;
    }

    private static void printOrnament(char[][] ornament) {
        for (int i = 0; i < ornament.length; i++) {
            for (int j = 0; j < ornament[i].length; j++) {
                System.out.print(ornament[i][j]);
            }
            System.out.println();
        }
    }
}
