def determine_team(participants, olympiad):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EGOI":
        return sorted([p for p in participants if p[1] == 'female'], key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "EJOI":
        return sorted([p for p in participants if p[3] < 15], key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif olympiad == "BalkOI":
        return sorted([p for p in participants if p[3] != 11], key=lambda x: (-x[4], x[0]))[:4]
    elif olympiad == "JBOI":
        return sorted([p for p in participants if p[3] not in [10, 11]], key=lambda x: (-x[4], x[0]))[:4]

n = int(input())
participants = []

for _ in range(n):
    data = input().split()
    participant_id = int(data[0])
    gender = data[1]
    grade = int(data[2])
    age = int(data[3])
    score = int(data[4])
    participants.append((participant_id, gender, grade, age, score))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    team = determine_team(participants, olympiad)
    print(olympiad)
    for participant in team:
        print(participant[0])
