def max_subarray_length(n, m, a):
    prefix_sum = [0] * (n + 1)

    for i in range(n):
        prefix_sum[i + 1] = prefix_sum[i] + a[i]

    max_length = 0

    for i in range(n):
        for j in range(i + 1, n + 1):
            current_length = j - i
            remaining_colors = m + 1 - (prefix_sum[j] - prefix_sum[i])

            if remaining_colors >= 0:
                current_length += min(remaining_colors, a[(i + j) // 2 - 1])

            max_length = max(max_length, current_length)

    return max_length


n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_subarray_length(n, m, a)
print(result)
