#include <bits/stdc++.h>
using namespace std;

vector<vector<char>> create_ornament(int n, int m) {
  int index = 0;
  bool reverse = false;
  vector<vector<char>> ornament(n, vector<char>(m, '.'));

  for (int i = 0; i < n; i++) {
    if (!reverse) {
      index++;
    } else {
      index--;
    }

    if (index == m / 2 + 1 && m % 2 != 0) {
      ornament[i][index - 1] = 'x';
    } else if (index != m / 2 + 1) {
      ornament[i][index - 1] = 'x';
      ornament[i][m - index] = 'x';
    } else {
      ornament[i][index - 1] = 'x';
      ornament[i][m - index] = 'x';
      reverse = true;
      index = m / 2;
      continue;
    }

    if (index > m / 2) {
      reverse = true;
    }

    if (index == 1) {
      reverse = false;
    }
  }

  return ornament;
}

void print_ornament(const vector<vector<char>>& ornament) {
  for (const auto& row : ornament) {
    for (const char& chr : row) {
      cout << chr;
    }
    cout << endl;
  }
}

int main() {
  int n, m;
  cin >> n >> m;
  vector<vector<char>> ornament = create_ornament(n, m);
  print_ornament(ornament);

  return 0;
}

