#include <bits/stdc++.h>
using namespace std;

int main() {
  int n, m;
  cin >> n >> m;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }

  int max_length = 0;

  for (int ai : a) {
    if (ai > max_length) {
      max_length = ai;
    }
  }

  for (int _ = 0; _ < m; ++_) {
    int longest_sequence = 0;
    int longest_wheel = -1;

    for (int i = 0; i < n; ++i) {
      if (a[i] == 0) {
        continue;
      }

      int current_length = 0;
      while (current_length < a[i] && a[i + current_length] == 0) {
        ++current_length;
      }

      if (current_length > longest_sequence) {
        longest_sequence = current_length;
        longest_wheel = i;
      }
    }

    if (longest_sequence % 2 == 1) {
      a[longest_wheel + longest_sequence / 2] = 0;
    } else {
      a[longest_wheel + longest_sequence / 2] = 0;
    }

    if (longest_sequence > max_length) {
      max_length = longest_sequence;
    }
  }

  cout << max_length << endl;

  return 0;
}