def create_cross_stitching_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    # Creating the upper left ray
    for i in range(min(n, m)):
        pattern[i][i] = 'X'

    # Creating the upper right ray
    for i in range(min(n, m)):
        pattern[i][m - i - 1] = 'X'

    # Printing the pattern
    for row in pattern:
        print(''.join(row))

# Getting input
n, m = map(int, input().split())

# Checking the condition 3 <= n, m <= 1000
if 3 <= n <= 1000 and 3 <= m <= 1000:
    create_cross_stitching_pattern(n, m)
else:
    print("Please enter valid values for n and m (3 <= n, m <= 1000).")
