def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        ornament[i][0] = 'X'
        ornament[i][-1] = 'X'

    for j in range(m):
        ornament[0][j] = 'X'
        ornament[-1][j] = 'X'

    for i in range(1, n - 1):
        for j in range(1, m - 1):
            if i % 2 == 1 and j % 2 == 1:
                ornament[i][j] = 'x'

    return ornament


def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))


if __name__ == "__main__":
    n, m = map(int, input().split())
    ornament = create_ornament(n, m)
    print_ornament(ornament)
