def max_unmarked_sequence(n, m, wheels):
    sequence_lengths = []
    for wheel in wheels:
        # Subtract 1 for the initially chosen color
        sequence_lengths.append(wheel - 1)

    sequence_lengths.sort(reverse=True)

    while m > 0:
        # Find the longest sequence
        longest_sequence = sequence_lengths[0]

        # If the sequence is odd, take the middle color
        if longest_sequence % 2 == 1:
            middle = longest_sequence // 2
            sequence_lengths[0] = middle
            sequence_lengths.append(middle)
        # If the sequence is even, take one of the middle two colors
        else:
            middle = longest_sequence // 2
            sequence_lengths[0] = middle
            sequence_lengths.insert(1, middle)

        sequence_lengths.sort(reverse=True)
        m -= 1

    return sequence_lengths[0]

# Reading input
n, m = map(int, input().split())
wheels = list(map(int, input().split()))

result = max_unmarked_sequence(n, m, wheels)
print(result)
