def max_unmarked_sequence_length(n, m, a):
    total_colors = sum(a) + m
    max_length = 0

    for i in range(n):
        length = a[i] - 1  # Initial unmarked sequence length on each color wheel
        max_length = max(max_length, length)

    remaining_colors = total_colors - sum(a)  # Remaining colors to choose
    if remaining_colors > 0:
        max_length += remaining_colors

    return max_length


# Reading input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Calculating and printing the result
result = max_unmarked_sequence_length(n, m, a)
print(result)
