n, m = 11, 11
wheels = [11]

def find_max_seq_length(wheels, m):
    max_seq = max(wheels)
    total = sum(wheels)
    if m >= total:
        return max_seq + (m - total) // n

    low, high = 1, max_seq
    while low < high:
        mid = (low + high + 1) // 2
        count = sum((wheel - mid) // 2 + 1 for wheel in wheels if wheel > mid)
        if count >= m:
            low = mid
        else:
            high = mid - 1

    return low

result = find_max_seq_length(wheels, m)
print(result)
