def get_max_unmarked_sequence_length(n, m, colors):
    max_sequence_length = max(colors)
    remaining_colors = sum(colors) - n
    if remaining_colors >= m:
        return max_sequence_length

    m -= remaining_colors
    max_sequence_length += m // n * 2
    if m % n != 0:
        max_sequence_length += 1 if m % n != 1 else 0

    return max_sequence_length

# Reading input
n, m = map(int, input().split())
colors = list(map(int, input().split()))

result = get_max_unmarked_sequence_length(n, m, colors)
print(result)
