def calculate_weights(w, t):
    weights = [0, 0]
    for i in range(4):
        weights[t[i] - 1] += w[i]
    return weights

weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

initial_weights = calculate_weights(weights, boxes)
max_initial_weight = max(initial_weights)

for i in range(4):
    new_boxes = boxes.copy()
    new_boxes[i] = 3 - new_boxes[i]
    new_weights = calculate_weights(weights, new_boxes)
    
    if max(new_weights) < max_initial_weight:
        print(i + 1)
        break
else:
    print(-1)