def julian(day, month):
    return (month - 14) / 12 + day + 365 * (month - 3)

def compare_dates(day1, month1, day2, month2):
    jd1 = julian(day1, month1)
    jd2 = julian(day2, month2)

    if (jd1 % 365) == (jd2 % 365):
        return "Same birthday!"
    else:
        return "Not the same"

day1, month1 = map(int, input().split())
day2, month2 = map(int, input().split())

print(compare_dates(day1, month1, day2, month2))