#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    map< string, vector<ll> > ans;
    ans["IOI"].resize(0);
    ans["CEOI"].resize(0);
    ans["EGOI"].resize(0);
    ans["EJOI"].resize(0);
    ans["BaltOI"].resize(0);
    ans["BalkOI"].resize(0);
    ans["JBOI"].resize(0);
    vector< pair< ll, pair< pair<ll, string>, pair<ll, ll> > > > v(n);
    for (int i = 0; i < n; i++) {
        ll id, grade, age, score;
        string gender;
        cin >> id >> gender >> grade >> age >> score;
        v[i] = {score, {{id, gender}, {grade, age}}};
    }
    sort(v.rbegin(), v.rend());
    for (int i = 0; i < n; i++) {
        ll id, grade, age, score;
        string gender;
        score = v[i].first;
        id = v[i].second.first.first;
        gender = v[i].second.first.second;
        grade = v[i].second.second.first;
        age = v[i].second.second.second;
        if (ans["IOI"].size() < 4) {
            ans["IOI"].push_back(id);
        }
        if (ans["CEOI"].size() < 4) {
            ans["CEOI"].push_back(id);
        }
        if (ans["BaltOI"].size() < 6) {
            ans["BaltOI"].push_back(id);
        }
        if (gender == "female" && ans["EGOI"].size() < 4) {
            ans["EGOI"].push_back(id);
        }
        if (age <= 15 && ans["EJOI"].size() < 4) {
            ans["EJOI"].push_back(id);
        }
        if (grade <= 10 && ans["BalkOI"].size() < 4) {
            ans["BalkOI"].push_back(id);
        }
        if (grade <= 9 && ans["JBOI"].size() < 4) {
            ans["JBOI"].push_back(id);
        }
    }
    for (auto &i : ans) {
        sort(i.second.begin(), i.second.end());
    }
    cin >> n;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        cout << s << '\n';
        for (int j : ans[s]) {
            cout << j << '\n';
        }
        cout << '\n';
    }
}
