import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

 
        int n = scanner.nextInt(); 
        int m = scanner.nextInt(); 
        String[] sizes = new String[m]; 
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }

        int[][] available = new int[n][m]; 
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                available[i][j] = scanner.nextInt();
            }
        }

        int k = scanner.nextInt(); 
        for (int i = 0; i < k; i++) {
            int c = scanner.nextInt();
            String s = scanner.next(); 

            boolean found = false;
            for (int j = 0; j < m; j++) {
                int sizeIndex = indexOf(sizes, s);
                if (available[c - 1][sizeIndex] > 0) {
                    available[c - 1][sizeIndex]--;
                    found = true;
                    break;
                } else {
                    int nextSizeIndex = (sizeIndex + 1) % m;
                    if (available[c - 1][nextSizeIndex] > 0) {
                        available[c - 1][nextSizeIndex]--;
                        found = true;
                        break;
                    }
                }
            }

            if (!found) {
                available[c - 1][indexOf(sizes, s)]--;
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(available[i][j] + " ");
            }
            System.out.println();
        }
    }

    private static int indexOf(String[] sizes, String size) {
        for (int i = 0; i < sizes.length; i++) {
            if (sizes[i].equals(size)) {
                return i;
            }
        }
        return -1;
    }
}