import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int m = scanner.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = scanner.nextInt();
        }
        System.out.println(findMaxSubsequence(n, m, a));
    }

    public static int findMaxSubsequence(int n, int m, int[] a) {
        boolean[] usedColors = new boolean[1001];
        usedColors[0] = true;
        int totalColors = 0;
        for (int i = 0; i < n; i++) {
            totalColors += a[i];
        }
        int currentColor = 1;
        int maxSubsequence = 0;

        while (m > 0) {
            int start = 0;
            while (start < n && !usedColors[start]) {
                start += 1;
            }
            if (start == n) {
                break;
            }

            int maxColor = a[start];
            for (int i = start; i < n; i++) {
                for (int j = 1; j <= maxColor; j++) {
                    if (a[i] >= j && !usedColors[totalColors - a[i]]) {
                        usedColors[totalColors - a[i]] = true;
                        maxSubsequence += 1;
                        currentColor += 1;
                        break;
                    }
                }
            }
            m -= 1;
        }
        return maxSubsequence;
    }
}