def generate_ornament(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            if (i + j) % 2 == 0:
                pattern[i][j] = 'x'

    return pattern


def print_ornament(pattern):
    for row in pattern:
        print("".join(row))


# Read input
n, m = map(int, input().split())

# Generate and print ornament
ornament = generate_ornament(n, m)
print_ornament(ornament)

