def is_possible(x, m, a):
    count = 0
    n = len(a)
    
    for i in range(n):
        # Додаємо довжину підвідрізку
        count += min(x, a[i])
        
        # Якщо довжина підвідрізку більше за x, то зменшуємо вказівник m
        if a[i] > x:
            m -= (a[i] - x)
        
        # Якщо m стає від'ємним, це означає, що можливо вибрати необхідну кількість кольорів
        if m < 0:
            return True
    
    # Якщо m ще залишилось, то не можливо вибрати необхідну кількість кольорів
    return False

def max_subarray_length(n, m, a):
    left, right = 1, sum(a)
    result = 0
    
    while left <= right:
        mid = (left + right) // 2
        
        # Перевіряємо, чи можливо вибрати m кольорів з середньою довжиною підвідрізку mid
        if is_possible(mid, m, a):
            result = mid
            left = mid + 1
        else:
            right = mid - 1
    
    return result

# Зчитуємо вхідні дані
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Знаходимо та виводимо результат
result = max_subarray_length(n, m, a)
print(result)

