def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        for j in range(m):
            distance_to_top_left = min(i, j)
            distance_to_bottom_left = min(n - i - 1, j)

            if distance_to_top_left % 2 == 0:
                ornament[i][j] = 'x'
            elif distance_to_bottom_left % 2 == 0:
                ornament[i][j] = 'x'

    return ornament

def print_ornament(ornament):
    for row in ornament:
        print(''.join(row))

n, m = map(int, input().split())

ornament = create_ornament(n, m)
print_ornament(ornament)
