def draw_ornate(n, m):
    matrix = [[' ' for _ in range(m)] for _ in range(n)]

    x1, y1 = 0, 0
    x2, y2 = n - 1, 0

    while x1 != -1 or x2 != -1:
        if x1 != -1:
            if matrix[x1][y1] == ' ':
                matrix[x1][y1] = 'x'
                y1 += 1
                if y1 == m:
                    x1 = -1
                else:
                    x1 -= 1
        if x2 != -1:
            if matrix[x2][y2] == ' ':
                matrix[x2][y2] = 'x'
                y2 -= 1
                if y2 == -1:
                    x2 = -1
                else:
                    x2 += 1

    return matrix


if name == "main":
    n, m = map(int, input().split())

    matrix = draw_ornate(n, m)

    for row in matrix:
        print("".join(row))
