n = int(input()) 
participants = [] 
for _ in range(n): 
    participant_info = input().split() 
    participant = { 
        'id': int(participant_info[0]), 
        'gender': participant_info[1], 
        'grade': int(participant_info[2]), 
        'age': int(participant_info[3]), 
        'score': int(participant_info[4]) 
    } 
    participants.append(participant) 
 
m = int(input()) 
olympiads = [] 
for _ in range(m): 
    olympiad = input().strip() 
    olympiads.append(olympiad) 
 
# Sort participants based on score in descending order 
participants.sort(key=lambda x: x['score'], reverse=True) 
 
for olympiad in olympiads: 
    team = [] 
    if olympiad == 'IOI': 
        for participant in participants: 
            if len(team) >= 4: 
                break 
            team.append(participant['id']) 
    elif olympiad == 'CEOI': 
        for participant in participants: 
            if len(team) >= 4: 
                break 
            team.append(participant['id']) 
    elif olympiad == 'EGOI': 
        female_participants = [participant for participant in participants if participant['gender'] == 'female'] 
        female_participants.sort(key=lambda x: x['score'], reverse=True) 
        for participant in female_participants: 
            if len(team) >= 4: 
                break 
            team.append(participant['id']) 
    elif olympiad == 'EJOI': 
        young_participants = [participant for participant in participants if participant['age'] <= 15] 
        young_participants.sort(key=lambda x: x['score'], reverse=True) 
        for participant in young_participants: 
            if len(team) >= 4: 
                break 
            team.append(participant['id']) 
    elif olympiad == 'BaltOI': 
        for participant in participants: 
            if len(team) >= 6: 
                break 
            team.append(participant['id']) 
    elif olympiad == 'BalkOI': 
        non_11th_grade = [participant for participant in participants if participant['grade'] != 11] 
        non_11th_grade.sort(key=lambda x: x['score'], reverse=True) 
        for participant in non_11th_grade: 
            if len(team) >= 4: 
                break 
            team.append(participant['id']) 
    elif olympiad == 'JBOI': 
        non_10th_11th_grade = [participant for participant in participants if participant['grade'] != 11 and participant['grade'] != 10] 
        non_10th_11th_grade.sort(key=lambda x: x['score'], reverse=True) 
        for participant in non_10th_11th_grade: 
            if len(team) >= 4: 
                break 
            team.append(participant['id']) 
     
    team.sort() 
    print(olympiad) 
    for participant_id in team: 
        print(participant_id)
