def max_sequence_length(n, m, a):
    lengths = [ai for ai in a]
    remaining_colors = m

    while remaining_colors > 0:
        max_length = max(lengths)
        if max_length % 2 == 1:
            remaining_colors -= 1
        else:
            remaining_colors -= min(max_length // 2, remaining_colors)

        lengths = [min(remaining_colors, length // 2) if length % 2 == 0 else length for length in lengths]

    return max(lengths)

n, m = map(int, input().split())
a = list(map(int, input().split()))

result = max_sequence_length(n, m, a)
print(result)
