def solve(n, m, a):
    for i in range(n):
        a[i] -= m

    max_length = 0
    for i in range(n):
        max_length = max(max_length, binary_search(a[i]))

    return max_length


def binary_search(k):
    left = 0
    right = k

    while left <= right:
        mid = (left + right) // 2

        if mid * 2 <= k:
            left = mid + 1
        else:
            right = mid - 1

    return mid


if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    print(solve(n, m, a))
