from collections import defaultdict

colors, sizes = input().split()
available_sizes = {color: defaultdict(int) for color in colors}
remaining_stock = {color: defaultdict(int) for color in colors}

for i in range(len(sizes)):
    available_sizes[colors[i]][sizes[i]] += 1
winners_count = int(input())
for _ in range(winners_count):
    color, size = input().split()
    if available_sizes[color][size] > 0:
        available_sizes[color][size] -= 1
    else:
        alt_color = min(available_sizes.keys(), key=lambda c: (c, available_sizes[c][size]))
        available_sizes[alt_color][size] -= 1
        remaining_stock[alt_color][size] -= 1
for color in colors:
    print("".join(str(available_sizes[color][size]) for size in sizes))
for color in colors:
    print("".join(str(max(0, remaining_stock[color][size])) for size in sizes))
                                                        
