# Read input data
n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant = {
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    }
    participants.append(participant)

t = int(input())
output_order = []

for _ in range(t):
    olympiad_name = input()
    output_order.append(olympiad_name)
    criterion = input()
    count = 4 if criterion not in ['EGOI', 'BalkOI'] else 6
    
    # Sort participants by score in descending order
    sorted_participants = sorted(participants, key=lambda x: (-x['score'], x['id']))

    # Apply the criterion to select team participants
    team_participants = []
    if criterion == '101':
        team_participants = sorted_participants[:count]
    elif criterion == 'CEOI':
        team_participants = sorted_participants[:count]
    elif criterion == 'EGOI':
        team_participants = [p for p in sorted_participants if p['gender'] == 'female'][:count]
    elif criterion == 'EJOI':
        team_participants = [p for p in sorted_participants if p['grade'] <= 10][:count]
    elif criterion == 'BaltoI':
        team_participants = sorted_participants[:count]
    elif criterion == 'BalkOI':
        team_participants = [p for p in sorted_participants if p['grade'] != 11][:count]
    elif criterion == 'JBOI':
        team_participants = [p for p in sorted_participants if p['grade'] not in [10, 11]][:count]

    team_participants_ids = sorted([p['id'] for p in team_participants])
    print('\n'.join(map(str, team_participants_ids)))

# Ensure the order of output matches the order in the input
for olympiad_name in output_order:
    if olympiad_name not in ['EGOI', 'BalkOI']:
        continue
    criterion = 'EGOI' if olympiad_name == 'EGOI' else 'BalkOI'
    count = 4 if criterion == 'BalkOI' else 6
    
    # Sort participants by score in descending order
    sorted_participants = sorted(participants, key=lambda x: (-x['score'], x['id']))

    # Apply the criterion to select team participants
    team_participants = []
    if criterion == 'EGOI':
        team_participants = [p for p in sorted_participants if p['gender'] == 'female'][:count]
    elif criterion == 'BalkOI':
        team_participants = [p for p in sorted_participants if p['grade'] != 11][:count]

    team_participants_ids = sorted([p['id'] for p in team_participants])
    print('\n'.join(map(str, team_participants_ids)))
