def create_pattern(m, n):
    pattern = [['.' for _ in range(n)] for _ in range(m)]

    for i in range(min(m, n) // 2 + 1):
        pattern[i][i] = 'x'
        pattern[i][n - 1 - i] = 'x'
        pattern[m - 1 - i][i] = 'x'
        pattern[m - 1 - i][n - 1 - i] = 'x'

    for row in pattern:
        print(''.join(row))

m, n = map(int, input().split())

if m % 2 != 0:
    m += 1
if n % 2 != 0:
    n += 1

create_pattern(m, n)
