def main():
    n, m = map(int, input().split())
    sizes = input().split()
    tshirts_count = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    requests = [input().split() for _ in range(k)]
    remaining_count = [row.copy() for row in tshirts_count]

    for request in requests:
        color, size = int(request[0]), sizes.index(request[1]) + 1
        given = False

        if remaining_count[color - 1][size - 1] > 0:
            remaining_count[color - 1][size - 1] -= 1
            given = True

        elif remaining_count[color - 1][size - 1] == 0:
            for other_color in range(n):
                if remaining_count[other_color][size - 1] > 0:
                    remaining_count[other_color][size - 1] -= 1
                    given = True
                    break

        if not given:
            for other_size in range(size, m):
                if any(remaining_count[other_color][other_size] > 0 for other_color in range(n)):
                    remaining_count[min(range(n), key=lambda x: remaining_count[x][other_size])][other_size] -= 1
                    given = True
                    break

        if not given:
            print(f"Error: No T-shirt available for request {request}")

    for row in remaining_count:
        print(*row)

    for i in range(n):
        print(*[tshirts_count[i][j] - remaining_count[i][j] for j in range(m)])

if __name__ == "__main__":
    main()
