def max_unmarked_length(n, m, a):
    if m >= sum(a):
        return 0

    a.sort(reverse=True)
    low, high = 1, 2 * 10**18

    while low < high:
        mid = (low + high) 
        total = 0

        for ai in a:
            total += min(mid, ai)

        if total >= m:
            high = mid
        else:
            low = mid + 1

    return low - 1

def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    result = max_unmarked_length(n, m, a)
    print(result)

if __name__ == "__main__":
    main()
