#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Item {
    int weight;
    int box;
    int index;

    bool operator<(const Item& other) const {
        return weight < other.weight;
    }
};

int main() {
    int n = 4;

    vector<Item> items(n);

    for (int i = 0; i < n; ++i) {
        cin >> items[i].weight;
        items[i].index = i + 1;
    }

    for (int i = 0; i < n; ++i) {
        cin >> items[i].box;
    }

    sort(items.begin(), items.end());

    int replaceIndex = -1;

    for (int i = 0; i < n - 1; ++i) {
        if (items[i].box == items[i + 1].box) {
            replaceIndex = items[i].index;
            break;
        }
    }

    if (replaceIndex == -1) {
        cout << "-1" << endl;
    }
    else {
        cout << replaceIndex << endl;
    }

    return 0;
}
