def main():
    n, m = map(int, input().split())
    sizes = input().split()
    stocks = []
    for _ in range(n):
        stocks.append(list(map(int, input().split())))

    k = int(input())
    requests = []
    for _ in range(k):
        c, s = input().split()
        requests.append((int(c), s))

    remaining = [list(row) for row in stocks]
    to_order = [[0] * m for _ in range(n)]

    for c, s in requests:
        color = c - 1
        size = sizes.index(s)

        if remaining[color][size] > 0:
            remaining[color][size] -= 1
        else:
            found = False

            for i in range(n):
                if i != color and remaining[i][size] > 0:
                    remaining[i][size] -= 1
                    to_order[i][size] += 1
                    found = True
                    break

            if not found:
                for j in range(size + 1, m):
                    for i in range(n):
                        if remaining[i][j] > 0:
                            remaining[i][j] -= 1
                            to_order[i][j] += 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                for j in range(size + 1, m):
                    if remaining[color][j] > 0:
                        remaining[color][j] -= 1
                        to_order[color][j] += 1
                        found = True
                        break

            if not found:
                to_order[color][size] += 1

    for row in remaining:
        print(*row)

    for row in to_order:
        print(*row)


if __name__ == "__main__":
    main()










