def team(people, olympiads):
    result = {}

    for olympiad in olympiads:
        result[olympiad] = []

    for pearson in people:
        id, gender, grade, age, score = pearson
        if score == 0:
            continue

        if "IOI" in olympiads and grade == 11:
            result["IOI"].append((score, id))
        if "EGOI" in olympiads and gender == "female":
            result["EGOI"].append((score, id))
        if "BaltOI" in olympiads:
            result["BaltOI"].append((score, id))

    for olympiad in olympiads:
        result[olympiad] = [id for i, id in sorted(result[olympiad], reverse=True)[:min(4, len(result[olympiad]))]]

    return result

n = int(input())
people = []
for i in range(n):
    id, gender, grade, age, score = map(str, input().split())
    people.append((int(id), gender, int(grade), int(age), int(score)))

m = int(input())
olympiads = [input().strip() for i in range(m)]
result = team(people, olympiads)

for olympiad in olympiads:
    print(olympiad)
    for pearson_id in sorted(result[olympiad]):
        print(pearson_id)
