def find_max_subarray(a, n, m):
    count = [0] * n
    for i in range(n):
        count[i] = a[i] - m - 1

    max_length = 0
    left, right = 0, 0
    current_sum = 0

    while right < n:
        current_sum += count[right]

        while current_sum < 0:
            if left > 0:
                current_sum -= count[left]
                left += 1
            else:
                break

        max_length = max(max_length, right - left + 1)
        right += 1

    return max_length


if __name__ == "__main__":
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    print(find_max_subarray(a, n, m))









