def select_participants(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "EGOI":
        females = [participant for participant in participants if participant[1] == "female"]
        return sorted(females, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "EJOI":
        juniors = [participant for participant in participants if participant[3] <= 15]
        return sorted(juniors, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "BaltOI":
        return sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad == "BalkOI":
        non_11_graders = [participant for participant in participants if participant[2] != 11]
        return sorted(non_11_graders, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "JBOI":
        non_11_10_graders = [participant for participant in participants if participant[2] not in [10, 11]]
        return sorted(non_11_10_graders, key=lambda x: x[4], reverse=True)[:4]

# Зчитування вхідних даних
n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participant_info[0] = int(participant_info[0])
    participant_info[3] = int(participant_info[3])
    participant_info[4] = int(participant_info[4])
    participants.append(participant_info)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Визначення та виведення результатів
for olympiad in olympiads:
    selected_participants = select_participants(olympiad, participants)
    print(olympiad)
    for participant in sorted(selected_participants, key=lambda x: x[0]):
        print(participant[0])
