def max_unmarked_sequence(n, m, colors):
    max_sequence = 0
    total_colors = sum(colors)

    for i in range(n):
        max_sequence += colors[i] - 1

    total_unmarked_sequence = max_sequence + m

    if total_unmarked_sequence % 2 == 1:
        return total_unmarked_sequence

    smallest_odd = float('inf')
    for i in range(n):
        if colors[i] % 2 == 1:
            smallest_odd = min(smallest_odd, colors[i])

    if smallest_odd != float('inf'):
        return total_unmarked_sequence

    return total_unmarked_sequence - 1

n, m = map(int, input().split())
colors = list(map(int, input().split()))

res = max_unmarked_sequence(n, m, colors)
print(res)
