#include <bits/stdc++.h>
using namespace std;

#include <vector>
#include <algorithm>
#include <numeric>



bool canChooseColor(int mid, const vector<int>& a, int m) {
    vector<int> b(a.begin(), a.end());
    for (int i = 0; i < b.size(); ++i) {
        b[i] = min(b[i], 2 * i + 1);
    }
    sort(b.begin(), b.end(), greater<int>());
    long long sum = accumulate(b.begin(), b.begin() + mid, 0LL);
    return sum >= m + 1;
}

int main() {
   
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

   
    int left = 0, right = n;
    while (left < right) {
        int mid = (left + right) / 2;
        if (canChooseColor(mid, a, m)) {
            left = mid + 1;
        } else {
            right = mid;
        }
    }

 
    cout << left - 1 << endl;

    return 0;
}
