#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> colour(n);
    priority_queue<long long> pq;

    for (int i = 0; i < n; ++i) {
        cin >> colour[i];
        pq.push(-colour[i]); // Negate the length for max heap
    }

    long long max_len = 0;

    for (long long remain = m; remain > 0; --remain) {
        long long len = -pq.top(); // Retrieve the maximum length
        pq.pop();
        long long select;

        if (len % 2 == 1) {
            select = (len - 1) / 2;
        } else {
            select = len / 2 - 1;
        }

        max_len = max(max_len, len);
        pq.push(-select); // Negate the length for max heap
        pq.push(-(len - select - 1)); // Negate the length for max heap
    }

    cout << max_len << endl;

    return 0;
}

