#include <bits/stdc++.h>
using namespace std;

void IOI(vector <vector<int>> database, string name){
    vector<pair <int, int>> id_score;
    for (int i = 0 ; i < database.size(); i++){
        id_score.push_back({database[i][4],database[i][0]});
    }
    sort(id_score.begin(), id_score.end());
    reverse(id_score.begin(), id_score.end());
    
    vector<pair <int, int>> best;
    for (int i = 0; i < id_score.size(); i++){
        if (i > 3){break;}
        best.push_back({id_score[i].second, id_score[i].first});
    }
    
    sort(best.begin(), best.end());
    cout << name << "\n";
    for (int i = 0; i < best.size(); i++){
        cout << best[i].first << "\n";
    }
    cout << "\n";
}

void BaltOI(vector <vector<int>> database){
    vector<pair <int, int>> id_score;
    for (int i = 0 ; i < database.size(); i++){
        id_score.push_back({database[i][4],database[i][0]});
    }
    sort(id_score.begin(), id_score.end());
    reverse(id_score.begin(), id_score.end());
    
    vector<pair <int, int>> best;
    for (int i = 0; i < id_score.size();i++){
        if (i > 5){
            break;
        }
        best.push_back({id_score[i].second, id_score[i].first});
    }
    
    sort(best.begin(), best.end());
    cout << "BaltOI" << "\n";
    for (int i = 0; i < best.size(); i++){
        cout << best[i].first << "\n";
    }
    cout << "\n";
}

void EGOI(vector <vector<int>> database){
    vector<pair <int, int>> id_score;
    for (int i = 0 ; i < database.size(); i++){
        if (database[i][1] == 2){
            id_score.push_back({database[i][4],database[i][0]});
        }
    }
    sort(id_score.begin(), id_score.end());
    reverse(id_score.begin(), id_score.end());
    
    vector<pair <int, int>> best;
    for (int i = 0; i < id_score.size(); i++){
        if (i > 3){
            break;
        }
        best.push_back({id_score[i].second, id_score[i]. first});
    }
    
    sort(best.begin(), best.end());
    cout << "EGOI" << "\n";
    for (int i = 0; i < best.size(); i++){
        cout << best[i].first << "\n";
    }
    cout << "\n";
}

void EJOI(vector <vector<int>> database){
    vector<pair <int, int>> id_score;
    for (int i = 0 ; i < database.size(); i++){
        if (database[i][3] <= 15){
            id_score.push_back({database[i][4],database[i][0]});
        }
    }
    sort(id_score.begin(), id_score.end());
    reverse(id_score.begin(), id_score.end());
    
    vector<pair <int, int>> best;
    for (int i = 0; i < id_score.size(); i++){
        if (i > 3){break;}
        best.push_back({id_score[i].second, id_score[i].first});
    }
    
    sort(best.begin(), best.end());
    cout << "EJOI" << "\n";
    for (int i = 0; i < best.size(); i++){
        cout << best[i].first << "\n";
    }
    cout << "\n";
}

void BalkOI(vector <vector<int>> database){
    vector<pair <int, int>> id_score;
    for (int i = 0 ; i < database.size(); i++){
        if (database[i][2] != 11){
            id_score.push_back({database[i][4],database[i][0]});
        }
    }
    sort(id_score.begin(), id_score.end());
    reverse(id_score.begin(), id_score.end());
    
    vector<pair <int, int>> best;
    for (int i = 0; i < id_score.size(); i++){
        if (i > 3){break;}
        best.push_back({id_score[i].second, id_score[i].first});
    }

    sort(best.begin(), best.end());
    cout << "BalkOI" << "\n";
    for (int i = 0; i < best.size(); i++){
        cout << best[i].first << "\n";
    }
    cout << "\n";
}

void JBOI(vector <vector<int>> database){
    vector<pair <int, int>> id_score;
    for (int i = 0 ; i < database.size(); i++){
        if (database[i][2] != 10 && database[i][2] != 11){
            id_score.push_back({database[i][4],database[i][0]});
        }
    }
    sort(id_score.begin(), id_score.end());
    reverse(id_score.begin(), id_score.end());
    
    vector<pair <int, int>> best;
    for (int i = 0; i < id_score.size(); i++){
        if (i > 3){break;}
        best.push_back({id_score[i].second, id_score[i].first});
    }
    

    sort(best.begin(), best.end());
    cout << "JBOI" << "\n";
    for (int i = 0; i < best.size(); i++){
        cout << best[i].first << "\n";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m,  user_id, score, age, grade, igender;
    string gender;
    vector <vector<int>> database;

    cin >> n;

    for (int i = 0; i < n; i++){
        vector <int> user;
        cin >> user_id >> gender >> grade >> score >> age;
        user.push_back(user_id);
        if (gender[0] == 'f'){
            igender = 2;
        }
        else{
            igender = 1;
        }
        user.push_back(igender);
        user.push_back(grade);
        user.push_back(score);
        user.push_back(age);
        database.push_back(user);
    }

    cin >> m;
    string olymp;
    for (int i = 0; i < m; i++){
        cin >> olymp;
        if (olymp == "IOI"){
            IOI(database, "IOI");
        }
        else if (olymp == "CEOI"){
            IOI(database, "CEOI");
        }
        else if (olymp == "BaltOI"){
            BaltOI(database);
        }
        else if (olymp == "EGOI"){
            EGOI(database);
        }
        else if (olymp == "EJOI"){
            EJOI(database);
        }
        else if (olymp == "BalkOI"){
            BalkOI(database);
        }
        else if (olymp == "JBOI"){
            JBOI(database);
        }
        
    }

    /*for (int i = 0 ; i < database.size(); i++){
        for (int j = 0; j < 5; j++){
            cout << database[i][j] << " ";
        }
        cout << endl;
    }*/
}
