n, m = map(int, input().split())

embroidery = [['.' for _ in range(m)] for _ in range(n)]

x1, y1 = 0, 0
x2, y2 = 0, m - 1

dx1, dy1 = 1, 1
dx2, dy2 = 1, -1

while x1 < n and x2 < n:
    embroidery[x1][y1] = 'x'
    embroidery[x2][y2] = 'x'

    if y1 == m - 1:
        dx1, dy1 = 1, -1
    elif y1 == 0:
        dx1, dy1 = 1, 1
    if y2 == m - 1:
        dx2, dy2 = 1, -1
    elif y2 == 0:
        dx2, dy2 = 1, 1

    x1, y1 = x1 + dx1, y1 + dy1
    x2, y2 = x2 + dx2, y2 + dy2

for row in embroidery:
    print(''.join(row))
