def create_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(n):
        pos_forward = i % (m * 2 - 2)
        pos_backward = (m - 1 - i) % (m * 2 - 2)

        if pos_forward < m:
            pattern[i][pos_forward] = 'x'
        else:
            pattern[i][m * 2 - 2 - pos_forward] = 'x'

        if pos_backward < m:
            pattern[i][pos_backward] = 'x'
        else:
            pattern[i][m * 2 - 2 - pos_backward] = 'x'

    for row in pattern:
        print(''.join(row))


n, m = map(int, input().split())
create_pattern(n, m)
