#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
using namespace std;

int main() {
  vector<int> w(4); 
  vector<int> t(4); 
  for (int i = 0; i < 4; i++) {
    cin >> w[i];
  }
  for (int i = 0; i < 4; i++) {
    cin >> t[i];
  }
  vector<int> s(2); 
  for (int i = 0; i < 4; i++) {
    s[t[i] - 1] += w[i];
  }
  int max_weight = *max_element(s.begin(), s.end());
  int best_item = -1; 
  int best_weight = max_weight; 
  for (int i = 0; i < 4; i++) {
    vector<int> new_s = s; 
    new_s[t[i] - 1] -= w[i];
    new_s[2 - t[i]] += w[i];
    int new_max_weight = *max_element(new_s.begin(), new_s.end());
    if (new_max_weight < best_weight) {
      best_item = i;
      best_weight = new_max_weight;
    }
  }

  if (best_item == -1) {
    cout << -1 ; 
  } else {
    cout << 1 ; 
  }

  return 0;
}



