#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    unordered_map<int, vector<string>> mp;
    for (int i = 0; i < n; i++)
    {
        int id;
        string gender, grade, age, score;
        cin >> id >> gender >> grade >> age >> score;
        mp[id] = { gender, grade, age, score };
    }
    cin >> n;
    unordered_map<string, vector<int>> mr;
    for (int i = 0; i < n; i++) {
        string team;
        cin >> team;
        if (team == "IOI" || team=="CEOI")
        {
            int accept[4];

            vector<pair<int, int>> tempVector;
            for (const auto& pair : mp) {
                int tempId = pair.first;
                int tempScore = stoi(pair.second[3]);
                tempVector.emplace_back(tempId, tempScore);
            }

            std::sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.second > rhs.second;
                });

            for (int i = 0; i < 4; i++)
                accept[i] = tempVector[i].first;
            
            sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.first < rhs.first;
                });

            cout << team << endl;
            for (int i = 0; i < 4; i++)
            {
                cout << accept[i] << endl;
            }
            cout << endl;
        } else if (team == "EGOI") {

            int accept[4];

            vector<pair<int, int>> tempVector;
            for (const auto& pair : mp) {
                int tempId = pair.first;
                int tempScore = stoi(pair.second[3]);
                if (pair.second[0] == "female")
                {
                    tempVector.emplace_back(tempId, tempScore);
                }
            }

            std::sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.second > rhs.second;
                });

            for (int i = 0; i < 4; i++)
                accept[i] = tempVector[i].first;

            sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.first < rhs.first;
                });

            cout << team << endl;
            for (int i = 0; i < 4; i++)
            {
                cout << accept[i] << endl;
            }
            cout << endl;

        } else if (team == "EJOI") {

            int accept[4];

            vector<pair<int, int>> tempVector;
            for (const auto& pair : mp) {
                int tempId = pair.first;
                int tempScore = stoi(pair.second[3]);
                if (stoi(pair.second[2]) < 15)
                {
                    tempVector.emplace_back(tempId, tempScore);
                }
            }

            std::sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.second > rhs.second;
                });

            for (int i = 0; i < 4; i++)
                accept[i] = tempVector[i].first;

            sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.first < rhs.first;
                });
                
            cout << team << endl;
            for (int i = 0; i < 4; i++)
            {
                cout << accept[i] << endl;
            }
            cout << endl;

        } else if (team == "BaltOI") {

            int accept[6];

            vector<pair<int, int>> tempVector;
            for (const auto& pair : mp) {
                int tempId = pair.first;
                int tempScore = stoi(pair.second[3]);
                    tempVector.emplace_back(tempId, tempScore); 
            }

            std::sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.second > rhs.second;
                });

            for (int i = 0; i < 4; i++)
                accept[i] = tempVector[i].first;

            sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.first < rhs.first;
                });

            cout << team << endl;
            for (int i = 0; i < 4; i++)
            {
                cout << accept[i] << endl;
            }
            cout << endl;

        } else if (team == "BalkOI") {

            int accept[4];

            vector<pair<int, int>> tempVector;
            for (const auto& pair : mp) {
                int tempId = pair.first;
                int tempScore = stoi(pair.second[3]);
                if (stoi(pair.second[2]) != 11)
                {
                    tempVector.emplace_back(tempId, tempScore);
                }
            }

            for (int i = 0; i < 4; i++)
                accept[i] = tempVector[i].first;

            std::sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.second > rhs.second;
                });

            cout << team << endl;
            for (int i = 0; i < 4; i++)
            {
                cout << accept[i] << endl;
            }
            cout << endl;

        } else if (team == "JBOI") {
            int accept[4];

            vector<pair<int, int>> tempVector;
            for (const auto& pair : mp) {
                int tempId = pair.first;
                int tempScore = stoi(pair.second[3]);
                if (stoi(pair.second[2]) != 11 && stoi(pair.second[2]) != 10)
                {
                    tempVector.emplace_back(tempId, tempScore);
                }
            }

            std::sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.second > rhs.second;
                });

            for (int i = 0; i < 4; i++)
                accept[i] = tempVector[i].first;

            sort(tempVector.begin(), tempVector.end(),
                [](const auto& lhs, const auto& rhs) {
                    return lhs.first < rhs.first;
                });

            cout << team << endl;
            for (int i = 0; i < 4; i++)
            {
                cout << accept[i] << endl;
            }
            cout << endl;
        }
        
    }
}