def partition(array, index, low, high):

  pivot = array[high][index]

  i = low - 1

  for j in range(low, high):
    if array[j][index] <= pivot:

      i = i + 1

      (array[i], array[j]) = (array[j], array[i])

  (array[i + 1], array[high]) = (array[high], array[i + 1])

  return i + 1

def quickSort(array, index, low, high):
  if low < high:

    pi = partition(array, index, low, high)

    quickSort(array, index, low, pi - 1)

    quickSort(array, index, pi + 1, high)

def sort_by_index(array, index):
    quickSort(array, index, 0, len(array) - 1)
    return array

n = int(input())

participants = []

for i in range(n):
    inp = input().split(' ')
    for i in range(5):
        if i != 1:
            inp[i] = int(inp[i])
    participants.append(inp)
    
sort_by_index(participants, 4)
participants.reverse()

def getAdvanced(array):
    IOI = []
    CEOI = []
    
    EGOI = []
    girls = 0

    EJOI = []
    smols = 0

    BaltOI = []

    BalkOI = []
    not11 = 0
    
    JBOI = []
    almost_smol = 0

    c = 0
    for i in array:
        if c < 4:
            IOI.append(i[0])
            CEOI.append(i[0])
        if c < 6:
            c += 1
            BaltOI.append(i[0])

        if girls < 4 and i[1] == 'female':
            EGOI.append(i[0])
            girls += 1
        if smols < 4 and i[3] <= 15:
            EJOI.append(i[0])
            smols += 1
        if not11 < 4 and i[2] != 11:
            BalkOI.append(i[0])
            not11 += 1
        if almost_smol < 4 and i[2] < 10:
            JBOI.append(i[0])
            almost_smol += 1

    return {
        'IOI': IOI,
        'CEOI': CEOI,
        'EGOI': EGOI,
        'EJOI': EJOI,
        'BaltOI': BaltOI,
        'BalkOI': BalkOI,
        'JBOI': JBOI
    }

results = getAdvanced(participants)

m = int(input())

for i in range(m):
    contest = input().replace('\r', '')
    print(contest)
    advanced = results[contest]
    advanced.sort()
    for j in advanced:
        print(j)
    
    print()

