#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    // Сортуємо масив a у зростаючому порядку
    sort(a.begin(), a.end());

    long long result = 0;

    // Рахуємо суму найбільших n-1 чисел
    for (int i = 0; i < n - 1; ++i) {
        result += a[i];
    }

    // Якщо m менше або дорівнює n, то додавання ще кольорів не збільшить результат
    if (m >= n) {
        result += a[n - 1] * (m - n + 1);
    } else {
        // Якщо m менше n, то додавання ще кольорів зменшить довжину підвідрізку
        result += a[m - 1];
    }

    cout << result << endl;

    return 0;
}
