n = int(input())

participants = []
for _ in range(n):
    id_, gender, grade, age, score = input().split()
    participants.append((int(id_), gender, int(grade), int(age), int(score)))

participants.sort(key=lambda x: x[-1], reverse=True)

m = int(input())
contests = [input() for _ in range(m)]

for contest in contests:
    team = []
    if contest == "IOI" or contest == "CEOI":
        team = [p[0] for p in participants[:4]]
    elif contest == "EGOI": 
        team = [p[0] for p in participants if p[1]=="female"][:4]
    elif contest == "EJOI":
        team = [p[0] for p in participants if p[2]<=10][:4]
    elif contest == "BaltOI":
        team = [p[0] for p in participants[:6]] 
    elif contest == "BalkOI":
        team = [p[0] for p in participants if p[2]!=11][:4]
    elif contest == "JBOI":
        team = [p[0] for p in participants if p[2]<11][:4]
    
    print(contest)
    print(*sorted(team), sep="\n")