#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    for (int i = 0; i < n; i++) {
        cin >> colors[i];
    }

    sort(colors.begin(), colors.end());

    int maxSubsequenceLength = 0;
    for (int i = 0; i < n; i++) {
        int count = 0;
        for (int j = i; j < n; j++) {
            if (colors[j] - colors[i] <= j - i) {
                count++;
            }
        }
        maxSubsequenceLength = max(maxSubsequenceLength, count);
    }

    int remaining = m - n;
    int additionalGroups = remaining / n;
    int remainder = remaining % n;

    int result = maxSubsequenceLength + additionalGroups;
    if (remainder > 0) {
        result++;
    }

    cout << result << endl;

    return 0;
}
